function ranking=MJPairR2GlbR(pairR,IMDB,printDir)

% pairR=pairR(pairR(:,3)==attrIdx,:);
pairR(pairR(:,4)==3,:)=[];
uniqueIdx=unique(vec(pairR(:,1:2)));


% transform all global img idx into local idx
[ignore localIdx]=ismember(vec(pairR(:,1:2)),uniqueIdx);
if sum(localIdx==0)>0
    error('invalid local index');
end

pairR(:,1:2)=reshape(localIdx,[size(pairR,1) 2]);
% samples=zeros(size(pairR,1),length(uniqueIdx));
samples=[];y=[];constIdx=[];
N=length(uniqueIdx);
counter=1;
for i = 1:size(pairR,1)
    firstIdx=pairR(i,1);
    secIdx=pairR(i,2);
    relation=pairR(i,4);
    
    switch relation
        case 1
            [buffer]=initBuffer(N);
            buffer(firstIdx)=1;
            buffer(secIdx)=-1;
            samples=[samples;buffer];
            y=[y;1];
            constIdx=[constIdx;counter];
            [buffer]=initBuffer(N);
            buffer(firstIdx)=-1;
            buffer(secIdx)=1;
            samples=[samples;buffer];
            y=[y;-1];
            constIdx=[constIdx;counter];
        case 2
            [buffer]=initBuffer(N);
            buffer(firstIdx)=-1;
            buffer(secIdx)=1;
            samples=[samples;buffer];
            y=[y;1];
            constIdx=[constIdx;counter];
            [buffer]=initBuffer(N);
            buffer(firstIdx)=1;
            buffer(secIdx)=-1;
            samples=[samples;buffer];
            y=[y;-1];
            constIdx=[constIdx;counter];
        case 3
            %SKIP
            % [buffer]=initBuffer(N);
            % buffer(firstIdx)=1;
            % buffer(secIdx)=-1;
            % samples=[samples;buffer];
            % y=[y;1];
            % [buffer]=initBuffer(N);
            % buffer(firstIdx)=-1;
            % buffer(secIdx)=1;
            % samples=[samples;buffer];
            % y=[y;1];
        otherwise
            error('unkown relation');
    end
    counter=counter+1;
end




% x-fold cross validation
x=100;
trRatio=0.8;
c_seq=10.^(-5:5);
acc=zeros(x,length(c_seq));
uConstIdx=unique(constIdx);
constN=length(uConstIdx);
fprintf('Start x-fold cross validation...\n');

for k=1:x
    % sample training and validating sets
    trConstIdx=uConstIdx(myPermute(constN,round(constN*trRatio)));
    teConstIdx=uConstIdx(~ismember(uConstIdx,trConstIdx));
    trSamples=samples(ismember(constIdx,trConstIdx),:);
    trY=y(ismember(constIdx,trConstIdx));
    teSamples=samples(ismember(constIdx,teConstIdx),:);
    teY=y(ismember(constIdx,teConstIdx));
    for j=1:length(c_seq)
        c=c_seq(j);
        svm_model=train(trY,sparse(trSamples),sprintf('-s 1 -c %f -q',c));
        %convert support vectors to decision boundary
        % svm_weights=full(sum(svm_model.SVs.*repmat(svm_model.sv_coef,1,size(svm_model.SVs,2)),1));
        % w=svm_weights';
        w=svm_model.w';
        if svm_model.Label(1)==-1
            w=-w;
        end
        estY=2*(double((teSamples*w)>=0)-0.5);
        acc(k,j)=sum(estY==teY)/length(teY);
        fprintf('c=%g, iter=%g, acc=%g\n',c,k,acc(k,j));
    end
end

meanAcc=mean(acc,1);
[maxVal maxIdx]=max(meanAcc);
bestC=c_seq(maxIdx);

fprintf('Finished x-fold cross validation. Best c = %g, val acc = %g\n',bestC,maxVal);

svm_model=train(y,sparse(samples),sprintf('-s 1 -c %f -q',bestC));
%convert support vectors to decision boundary
% svm_weights=full(sum(svm_model.SVs.*repmat(svm_model.sv_coef,1,size(svm_model.SVs,2)),1));
% w=svm_weights';
w=svm_model.w';
if svm_model.Label(1)==-1
    w=-w;
end

% pruneIdx=w==0;
% w(pruneIdx)=[];
% uniqueIdx(pruneIdx)=[];

[sortVal sortIdx]=sort(w,'descend');
ranking=uniqueIdx(sortIdx);

% print
htmlFilename=fullfile(printDir,'MJRanking.html');
imgStr=[];
imgList=[];
for i=1:length(ranking)
    imgIdx=ranking(i);
    imgList{end+1}=relativepath(IMDB(imgIdx).file,printDir);
    if i==1
        imgStr{end+1}=sprintf('(cv=%g)<br>imgIdx:%g,%g/%g,r=%g',maxVal,imgIdx,i,length(ranking),sortVal(i));
    else
        imgStr{end+1}=sprintf('imgIdx:%g,%g/%g,r=%g',imgIdx,i,length(ranking),sortVal(i));
    end
end
displayPatch(htmlFilename,imgList,imgStr,[],[],8,200,200);


function [buffer]=initBuffer(N)
buffer=zeros(1,N);


