function [bboxes selIdx]=chainNMS(bboxes,initInferenceK,score)
% measuring the affinities between chains and perform NMS subsequently
selIdx=[];
if length(bboxes)<=initInferenceK
    [sortval sortidx]=sort(score,'descend');
    selIdx=sortidx;
    bboxes=bboxes(sortidx);
    return;
end

A=zeros(length(bboxes));
for i = 1:length(bboxes)
    for j = i+1:length(bboxes)
        A(i,j)=measureA(bboxes{i},bboxes{j});
    end
end
A=(A+A')/2;

[NcutDiscrete,NcutEigenvectors,NcutEigenvalues] = ncutW(A,initInferenceK);
for i = 1:initInferenceK
    g=find(NcutDiscrete(:,i));
    if ~isempty(g)
        selIdx(end+1)=g(1);
    end
end

[sortval sortidx]=sort(score(selIdx),'descend');
selIdx=selIdx(sortidx);
bboxes=bboxes(selIdx);


function a=measureA(chainA,chainB)
% assert(norm(chainA(:,5)-chainB(:,5))==0);
overlapBboxes=[max(chainA(:,1),chainB(:,1)) max(chainA(:,2),chainB(:,2)) min(chainA(:,3),chainB(:,3)) min(chainA(:,4),chainB(:,4))];
areaA=(chainA(:,4)-chainA(:,2)+1).*(chainA(:,3)-chainA(:,1)+1);
areaB=(chainB(:,4)-chainB(:,2)+1).*(chainB(:,3)-chainB(:,1)+1);

h=overlapBboxes(:,4)-overlapBboxes(:,2)+1;
w=overlapBboxes(:,3)-overlapBboxes(:,1)+1;
overlap=zeros(size(overlapBboxes,1),1);
valididx=h>0&w>0;
overlap(valididx)=h(valididx).*w(valididx);
union=(areaA+areaB-overlap);
os=overlap./union;
a=mean(os);


% os_orig=diag(getosmatrix_bb(chainA(:,1:4),chainB(:,1:4)));
% diff=norm(os-os_orig);
% if diff>0
%     stop=1;
% end
