function [child parent]=distributedPassmsg(dsidx)
global ds;
touch;
startTime=tic;
if ~dsfield(ds,'store')
    dsload('ds.store.operatingIntegralDir');
    dsload('ds.store.operatingW');
    dsload('ds.store.operatingIntegralDir');
    dsload('ds.store.operatingLambda');
    dsload('ds.store.operatingC_appr');
    dsload('ds.store.operatingC_proj');
    dsload('ds.store.operatingC_resp');
    dsload('ds.store.operatingC_context');
    dsload('ds.store.operatingSpry');
    dsload('ds.store.operatingPollingDir');
    dsload('ds.store.operatingNodeIdx');
    dsload('ds.store.operatingIMDB');
    dsload('ds.store.operatingHogStepSize');
    dsload('ds.store.whitenMu');
    dsload('ds.store.whitenRT');
    dsload('ds.store.isChainNMS');
    dsload('ds.store.operatingDetector');
    dsload('ds.store.operatingExtRate');
end
if dsmapredisopen
    dsload('ds.store.operatingChildParentTable');
end
childParentPair=ds.store.operatingChildParentTable(dsidx,:);
nodeIdx=ds.store.operatingNodeIdx;
childIdx=find(childParentPair(1)==nodeIdx);
parentIdx=find(childParentPair(2)==nodeIdx);
if dsmapredisopen
    dsload(sprintf('ds.store.operatingStructData{%g}',childIdx));
    dsload(sprintf('ds.store.operatingStructData{%g}',parentIdx));
end
structData=ds.store.operatingStructData;

child=structData{childIdx};
parent=structData{parentIdx};
integralDir=ds.store.operatingIntegralDir;
w=ds.store.operatingW;
lambda=ds.store.operatingLambda;
c_appr=ds.store.operatingC_appr;
c_proj=ds.store.operatingC_proj;
c_resp=ds.store.operatingC_resp;
c_context=ds.store.operatingC_context;
extRate=ds.store.operatingExtRate;
spry=ds.store.operatingSpry;
pollingDir=ds.store.operatingPollingDir;
IMDB=ds.store.operatingIMDB;
hogStepSize=ds.store.operatingHogStepSize;
% NOTE: these are data we got directly from main script
whitenMu=ds.store.whitenMu;
whitenRT=ds.store.whitenRT;
whitenDataDim=cellfun(@(x)length(x),whitenMu);
isChainNMS=ds.store.isChainNMS;
detector=ds.store.operatingDetector;


MAXWIN=2600;
childImgIdx=child.imgIdx;
parentImgIdx=parent.imgIdx;
parentSW=parent.sw;
childSW=child.sw;


% TODO: switch between dense SIFT jianxiong's pixel wise hog 
% [childInt childScaledSize childScales]=loadMap(integralDir,childImgIdx);
% [parentInt parentScaledSize parentScales]=loadMap(integralDir,parentImgIdx);

[childInt childScaledSize childScales]=loadCodeMap(integralDir,childImgIdx,[]);
% get pixelwisehog as well, here the assumption is that the gradientMap is the same size as the hogMap
% TODO: switch between pedro and jianxiong hog
% childHog=pixelwiseHogPyramidFixedScales(I,childScales);
childI=readImIMDB(childImgIdx,IMDB);
childPedroHog=pedroHogFixedScales(childI,childScales);
childHog=fakePadding(childPedroHog,childScaledSize);
intChildGradientMap=cell(length(childScales),1);
for j = 1:length(childScales)
    scaled=myimresize(childI,childScales(j));
    [gx gy]=gradient(im2double(scaled),1);
    intChildGradientMap{j}=(max(gx.^2,[],3)+max(gy.^2,[],3));
    intChildGradientMap{j}=cumsum(intChildGradientMap{j},1);
    intChildGradientMap{j}=cumsum(intChildGradientMap{j},2);
end


[parentInt parentScaledSize parentScales]=loadCodeMap(integralDir,parentImgIdx,[]);
parentI=readImIMDB(parentImgIdx,IMDB);
% TODO: switch between pedro and jianxiong hog
% parentHog=pixelwiseHogPyramidFixedScales(I,parentScales);
parentHog=pedroHogFixedScales(parentI,parentScales);
parentHog=fakePadding(parentHog,parentScaledSize);
intParentGradientMap=cell(length(parentScales),1);
for j = 1:length(parentScales)
    scaled=myimresize(parentI,parentScales(j));
    [gx gy]=gradient(im2double(scaled),1);
    intParentGradientMap{j}=(max(gx.^2,[],3)+max(gy.^2,[],3));
    intParentGradientMap{j}=cumsum(intParentGradientMap{j},1);
    intParentGradientMap{j}=cumsum(intParentGradientMap{j},2);
end



% % some debug code
% imshow(I);
% figure
% layeridx=1;
% for debugidx = 1:size(childInt{layeridx},3)
%     imagesc(childInt{layeridx}(:,:,debugidx));
%     title(sprintf('%g/%g\n',debugidx,size(childInt{layeridx},3)));
%     pause;
% end

[childInt]=integrateMap(childInt,childI);
[parentInt]=integrateMap(parentInt,parentI);
fprintf('distributedPassmsg: integral image loaded\n');


if child.isParentStronger~=0
    isParentStronger=child.isParentStronger;
else
    isParentStronger=1;% fake
end

if ~isempty(child.childList)
    childHaveChildren=1;
else
    childHaveChildren=0;
end
childPyramidSize=cellfun(@(x)size(x),childInt,'uniformoutput',false);
childPyramidSize=cat(1,childPyramidSize{:});
childResp=cell(size(childSW,1),1);
parentResp=cell(size(parentSW,1),1);
childDetResp=cell(size(childSW,1),1);
parentDetResp=cell(size(parentSW,1),1);
% TODO: switch between fixed sliding window stepsize and the adaptive one
% childStepsize=estimateStepsize(childSW,childInt,MAXWIN);
% parentStepsize=estimateStepsize(parentSW,parentInt,MAXWIN);
childStepsize=hogStepSize*ones(length(childInt),1);
parentStepsize=hogStepSize*ones(length(parentInt),1);

total_score=cell(size(parentSW,1),1);
total_lh=cell(size(parentSW,1),1);
total_lw=cell(size(parentSW,1),1);
total_Ik=cell(size(parentSW,1),1);
total_lad=cell(size(parentSW,1),1);
total_lcd=cell(size(parentSW,1),1);

total_MP=nan(size(parentSW,1),length(parentInt));
total_NP=nan(size(parentSW,1),length(parentInt));
total_MC=nan(size(childSW,1),length(childInt));
total_NC=nan(size(childSW,1),length(childInt));

total_parentHMark=cell(size(parentSW,1),1);
total_parentWMark=cell(size(parentSW,1),1);
for i=1:length(total_parentHMark)
    total_parentHMark{i}=cell(length(parentInt),1);
    total_parentWMark{i}=cell(length(parentInt),1);
    parentResp{i}=cell(length(parentInt),1);
    parentDetResp{i}=cell(length(parentInt),1);
end

total_childHMark=cell(size(childSW,1),1);
total_childWMark=cell(size(childSW,1),1);
for i=1:length(total_childHMark)
    total_childHMark{i}=cell(length(childInt),1);
    total_childWMark{i}=cell(length(childInt),1);
    childResp{i}=cell(length(childInt),1);
    childDetResp{i}=cell(length(childInt),1);
end

total_overallObj=cell(size(parentSW,1)*length(parentInt)*size(childSW,1)*length(childInt),1);
total_apprDist=cell(size(parentSW,1)*length(parentInt)*size(childSW,1)*length(childInt),1);
total_contextDist=cell(size(parentSW,1)*length(parentInt)*size(childSW,1)*length(childInt),1);

for p = 1:size(parentSW,1)
    parentWhitenDataSelector=(prod(round(parentSW(p,:)/hogStepSize))*pedroHogFixedScales==whitenDataDim);
    if sum(parentWhitenDataSelector)==0
        error('no suitable whiten data found!');
    end
    
    % total_score{p}=cell(length(parentInt),1);
    % total_lh{p}=cell(length(parentInt),1);
    % total_lw{p}=cell(length(parentInt),1);
    % total_Ik{p}=cell(length(parentInt),1);
    % total_lad{p}=cell(length(parentInt),1);
    for i = 1:length(parentInt)
        if size(parentInt{i},1)<parentSW(p,1) || size(parentInt{i},2)<parentSW(p,2)
            continue;
        end
        respSize=genSize(size(parentInt{i}),parentSW(p,:),parentStepsize(i));
        respH=respSize(1);
        respW=respSize(2);
        % score=zeros(respH,respW,size(childSW,1)*length(childInt));
        % lh=zeros(respH,respW,size(childSW,1)*length(childInt));
        % lw=zeros(respH,respW,size(childSW,1)*length(childInt));
        % lad=zeros(respH,respW,size(childSW,1)*length(childInt));
        % layer0=reshape(1:respH*respW,[respH respW]);
        for q = 1:size(childSW,1)
            childWhitenDataSelector=(prod(round(childSW(q,:)/hogStepSize))*pedroHogFixedScales==whitenDataDim);
            if sum(childWhitenDataSelector)==0
                error('no suitable whiten data found!');
            end
            
            for j = 1:length(childInt)
                counter=sub2ind([length(childInt) size(childSW,1) length(parentInt) size(parentSW,1)],j,q,i,p);
                if size(childInt{j},1)<childSW(q,1) || size(childInt{j},2)<childSW(q,2) || sum(parentSW(p,:)==childSW(q,:))~=size(parentSW,2)
                    continue;
                end
                %[score(:,:,layerIdx) lh(:,:,layerIdx) lw(:,:,layerIdx) lad(:,:,layerIdx) wParentFeat wChildFeat]=...
                %computeObj(parentInt{i},childInt{j},parentSW(p,:),childSW(q,:),parentStepsize(i),childStepsize(j),w,lambda,c_appr,c_proj,spry);

                % TODO: remove parentHog{i},childHog{j} inputs
                [overallObj apprDist contextDist wParentFeat wChildFeat detWParentFeat detWChildFeat MP NP parentHMark parentWMark MC NC childHMark childWMark]=...
                    computeObj(whitenMu{parentWhitenDataSelector},whitenRT{parentWhitenDataSelector},...
                    whitenMu{childWhitenDataSelector},whitenRT{childWhitenDataSelector},intParentGradientMap{i},intChildGradientMap{j},...
                    parentHog{i},childHog{j},parentInt{i},childInt{j},parentSW(p,:),childSW(q,:),...
                    parentStepsize(i),childStepsize(j),w,detector,lambda,c_appr,c_proj,c_resp,c_context,extRate,spry,hogStepSize,childHaveChildren,isParentStronger);
                total_overallObj{counter}=single(overallObj);
                total_apprDist{counter}=single(apprDist);
                total_contextDist{counter}=single(contextDist);
                if isnan(total_MP(p,i))
                    total_MP(p,i)=MP;
                end
                if isnan(total_NP(p,i))
                    total_NP(p,i)=NP;
                end
                if isnan(total_MC(q,j))
                    total_MC(q,j)=MC;
                end
                if isnan(total_NC(q,j))
                    total_NC(q,j)=NC;
                end
                if isempty(total_parentHMark{p}{i})
                    total_parentHMark{p}{i}=parentHMark;
                end
                if isempty(total_parentWMark{p}{i})
                    total_parentWMark{p}{i}=parentWMark;
                end
                if isempty(parentResp{p}{i})
                    parentResp{p}{i}=wParentFeat;
                end
                
                if isempty(parentDetResp{p}{i})
                    parentDetResp{p}{i}=detWParentFeat;
                end
                
                if isempty(total_childHMark{q}{j})
                    total_childHMark{q}{j}=childHMark;
                end
                if isempty(total_childWMark{q}{j})
                    total_childWMark{q}{j}=childWMark;
                end
                if isempty(childResp{q}{j})
                    childResp{q}{j}=wChildFeat;
                end
                if isempty(childDetResp{q}{j})
                    childDetResp{q}{j}=detWChildFeat;
                end
            end
        end
        % [score maxLayer]=max(score,[],3);
        % idx=layer0+respH*respW*(maxLayer-1);
        % lh=lh(idx);
        % lw=lw(idx);
        % lad=lad(idx);
        % 
        % if isfield(parent,'score')
        %     score=score+parent.score{p}{i};
        % end
        % 
        % total_score{p}{i}=score;
        % total_lh{p}{i}=lh;
        % total_lw{p}{i}=lw;
        % total_Ik{p}{i}=maxLayer;
        % total_lad{p}{i}=lad;
    end
end
preComputeTime=toc(startTime);
childIntLength=length(childInt);
childIntSize=cellfun(@(x)[size(x,1) size(x,2)],childInt,'uniformoutput',false);
childIntSize=cat(1,childIntSize{:});
parentIntLength=length(parentInt);
parentIntSize=cellfun(@(x)[size(x,1) size(x,2)],parentInt,'uniformoutput',false);
parentIntSize=cat(1,parentIntSize{:});
clear childInt parentInt;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CHECKING POINT: get scores for me
startTime=tic;
queryGap=1;
if childHaveChildren
    while 1
        rtouch(pollingDir);
        fileList=dir(fullfile(pollingDir,'*.mat'));
        if numel(fileList)==0
            pause(queryGap);
            continue;
        end
        [ignore finishedChildParentList]=arrayfun(@(x)fileparts(x.name),fileList,'uniformoutput',false);
        finishedChildParentList=cellfun(@(x)regexp(x,'_','split'),finishedChildParentList,'uniformoutput',false);
        childList=cellfun(@(x)str2double(x{1}),finishedChildParentList);
        parentList=cellfun(@(x)str2double(x{2}),finishedChildParentList);
        valFileIdx=find(childParentPair(1)==parentList);
        finishedChildList=childList(valFileIdx);
        if sum(ismember(structData{childIdx}.childList,finishedChildList))==length(structData{childIdx}.childList)
            %fprintf('eligible to pass from node %g --> node %g\n',childParentPair(1),childParentPair(2));
            childScoreCell=cell(length(valFileIdx),1);
            for i = 1:length(valFileIdx)
                res=load(fullfile(pollingDir,fileList(valFileIdx(i)).name));
                childScoreCell{i}=res.score;
            end
            childScore=[];
            for i = 1:length(childScoreCell{1})
                for j = 1:length(childScoreCell{1}{i})
                    tmpScore=cellfun(@(x)x{i}{j},childScoreCell,'uniformoutput',false);
                    childScore{i}{j}=sum(cat(3,tmpScore{:}),3);
                end
            end
            break;
        end
        pause(queryGap);
    end
else
    childScore=[];
end
waitingTime=toc(startTime);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

startTime=tic;
% add scores on
for p = 1:size(parentSW,1)
    total_score{p}=cell(parentIntLength,1);
    total_lh{p}=cell(parentIntLength,1);
    total_lw{p}=cell(parentIntLength,1);
    total_Ik{p}=cell(parentIntLength,1);
    total_lad{p}=cell(parentIntLength,1);
    total_lcd{p}=cell(parentIntLength,1);
    for i = 1:parentIntLength
        if parentIntSize(i,1)<parentSW(p,1) || parentIntSize(i,2)<parentSW(p,2)
            continue;
        end
        respSize=genSize(parentIntSize(i,:),parentSW(p,:),parentStepsize(i));
        respH=respSize(1);
        respW=respSize(2);
        score=-inf(respH,respW,size(childSW,1)*childIntLength);
        lh=nan(respH,respW,size(childSW,1)*childIntLength);
        lw=nan(respH,respW,size(childSW,1)*childIntLength);
        lad=nan(respH,respW,size(childSW,1)*childIntLength);
        lcd=nan(respH,respW,size(childSW,1)*childIntLength);
        layer0=reshape(1:respH*respW,[respH respW]);
        
        for q = 1:size(childSW,1)
            for j = 1:childIntLength
                layerIdx=(q-1)*childIntLength+j;
                if childIntSize(j,1)<childSW(q,1) || childIntSize(j,2)<childSW(q,2) || sum(parentSW(p,:)==childSW(q,:))~=size(parentSW,2)
                    continue;
                end
                idx=sub2ind([childIntLength size(childSW,1) parentIntLength size(parentSW,1)],j,q,i,p);
                MP=total_MP(p,i);
                NP=total_NP(p,i);
                MC=total_MC(q,j);
                NC=total_NC(q,j);
                parentHMark=total_parentHMark{p}{i};
                parentWMark=total_parentWMark{p}{i};
                childHMark=total_childHMark{q}{j};
                childWMark=total_childWMark{q}{j};
                apprDist=total_apprDist{idx};
                contextDist=total_contextDist{idx};
                overallObj=total_overallObj{idx};
                if childHaveChildren
                    % child is not a leaf node
                    overallObj=bsxfun(@plus,overallObj,vec(childScore{q}{j})');
                end
                [tmpScore maxI]=max(overallObj,[],2);
                score(:,:,layerIdx)=reshape(tmpScore,[respH respW]);
                [tmpLh tmpLw]=ind2sub(genSize([MC NC],childSW(q,:),childStepsize(j)),maxI);
                lh(:,:,layerIdx)=reshape(tmpLh,[respH respW]);
                lw(:,:,layerIdx)=reshape(tmpLw,[respH respW]);
                apprIdx=sub2ind(size(apprDist),vec(1:size(apprDist,1)),maxI);
                contextIdx=sub2ind(size(contextDist),vec(1:size(contextDist,1)),maxI);
                lad(:,:,layerIdx)=reshape(apprDist(apprIdx),[length(parentHMark) length(parentWMark)]); 
                lcd(:,:,layerIdx)=reshape(contextDist(contextIdx),[length(parentHMark) length(parentWMark)]); 
            end
        end
        [score maxLayer]=max(score,[],3);
        idx=layer0+respH*respW*(maxLayer-1);
        lh=lh(idx);
        lw=lw(idx);
        lad=lad(idx);
        lcd=lcd(idx);
        
        total_score{p}{i}=score;
        total_lh{p}{i}=lh;
        total_lw{p}{i}=lw;
        total_Ik{p}{i}=maxLayer;
        total_lad{p}{i}=lad;
        total_lcd{p}{i}=lcd;
    end
end

score=total_score;
saveFilename=fullfile(pollingDir,sprintf('%g_%g.mat',childParentPair(1),childParentPair(2)));
mySaveFile(saveFilename,score);

% parentPyramidSize=cellfun(@(x)size(x),parentInt,'uniformoutput',false);
% parentPyramidSize=cat(1,parentPyramidSize{:});
% parent.score=total_score;
% parent.stepsize=parentStepsize;
% parent.pyramidSize=parentPyramidSize;
% parent.scales=parentScales;
% parent.scaledSize=parentScaledSize;
% parent.resp=parentResp;

child.score=childScore;
child.lh=total_lh;
child.lw=total_lw;
child.lk=total_Ik;
child.lad=total_lad;
child.lcd=total_lcd;
child.pyramidSize=childPyramidSize;
child.stepsize=childStepsize;
child.scales=childScales;
child.scaledSize=childScaledSize;
child.resp=childResp;
child.detResp=childDetResp;
child.pedroHog.hog=childPedroHog;
child.pedroHog.scales=childScales;

if isChainNMS
    child.toParentObj=total_overallObj;
    child.toParentApprDist=total_apprDist;
    child.hMark=total_childHMark;
    child.wMark=total_childWMark;
    child.M=total_MC;
    child.N=total_NC;
end

ds.res.structData{childIdx}=child;
postComputeTime=toc(startTime);
fprintf('Finished passing from node %g --> node %g, time %g/%g/%g secs\n',...
    childParentPair(1),childParentPair(2),preComputeTime,waitingTime,postComputeTime);



function [overallObj apprDist contextDist wParentFeat wChildFeat detWParentFeat detWChildFeat MP NP parentHMark parentWMark MC NC childHMark childWMark]=...
    computeObj(parentWhitenMu,parentWhitenRT,childWhitenMu,childWhitenRT,intParentGradient,intChildGradient,parentHog,childHog,parentInt,childInt,parentSW,...
    childSW,parentStepsize,childStepsize,w,detector,lambda,c_appr,c_proj,c_resp,c_context,extRate,spry,hogStepSize,childHaveChildren,isParentStronger)

% TODO: switch between pooling feature and hog feature for appearance matching
% [parentApprFeat MP NP parentHMark parentWMark atomP]=getBatchFeat(spry,parentInt,parentSW,parentStepsize);
% [childApprFeat MC NC childHMark childWMark atomC]=getBatchFeat(spry,childInt,childSW,childStepsize);
% parentFeat=parentApprFeat(:,1:atomP);
% childFeat=childApprFeat(:,1:atomC);
[parentFeat parentApprFeat parentPedroHog parentExtFeat MP NP parentHMark parentWMark atomP parentInvalidEnergyIdx]=getBatchFeatHeter(spry,parentInt,parentHog,intParentGradient,parentWhitenMu,parentWhitenRT,parentSW,parentStepsize,hogStepSize,extRate);
[childFeat childApprFeat childPedroHog childExtFeat MC NC childHMark childWMark atomC childInvalidEnergyIdx]=getBatchFeatHeter(spry,childInt,childHog,intChildGradient,childWhitenMu,childWhitenRT,childSW,childStepsize,hogStepSize,extRate);
% parentFeat=parentFeat(:,1:atomP);
% childFeat=childFeat(:,1:atomC);

% compute distance between window appearances
% TODO: experimenting direct dot product
%apprDist=sqrt(pdist2(parentApprFeat,childApprFeat));
parentHogCellN=length(1:hogStepSize:parentSW(1))*length(1:hogStepSize:parentSW(2));
childHogCellN=length(1:hogStepSize:childSW(1))*length(1:hogStepSize:childSW(2));

% fprintf('start doing dot product, size(parentApprFeat)=[%g %g], size(childApprFeat)=[%g %g]\n',...
%     size(parentApprFeat,1),size(parentApprFeat,2),size(childApprFeat,1),size(childApprFeat,2));
apprDist=-(1/(parentHogCellN*childHogCellN))*(parentApprFeat*childApprFeat');
% fprintf('finish dot product, size(parentApprFeat)=[%g %g], size(childApprFeat)=[%g %g]\n',...
%     size(parentApprFeat,1),size(parentApprFeat,2),size(childApprFeat,1),size(childApprFeat,2));


apprDist(parentInvalidEnergyIdx,:)=inf;
apprDist(:,childInvalidEnergyIdx)=inf;
% compute distance on the projection line w
if ~isempty(w) && sum(isnan(w))==0
    wParentFeat=(parentFeat*w)';
    wChildFeat=(childFeat*w)';
else
    wParentFeat=zeros(1,size(parentFeat,1));
    wChildFeat=zeros(1,size(childFeat,1));
end

% compute the distance between context features
contextDist=-parentExtFeat*childExtFeat';

projCost=max(lambda-isParentStronger*bsxfun(@minus,wParentFeat',wChildFeat),0);
if ~isempty(detector)
    detWParentFeat=(parentPedroHog*detector.w(:)-detector.b)';
    detWChildFeat=(childPedroHog*detector.w(:)-detector.b)';
    overallObj=bsxfun(@plus,c_resp*detWParentFeat',-c_proj*projCost-c_appr*apprDist-c_context*contextDist);
else
    overallObj=-c_proj*projCost-c_appr*apprDist-c_context*contextDist;
end

% % TODO: here is the mechanism for pruning out low response patches w.r.t. the ranker
% projProhibIdxParent=wParentFeat<projRespThresh;
% projProhibIdxChild=wChildFeat<projRespThresh;
% projCost(projProhibIdxParent,projProhibIdxChild)=inf;
% overallObj=bsxfun(@plus,c_resp*wParentFeat',-c_proj*projCost-c_appr*apprDist);
if ~childHaveChildren
    % child is a leaf, we collect its unary potential
    if ~isempty(detector)
        overallObj=bsxfun(@plus,overallObj,c_resp*detWChildFeat);
    end
end

wParentFeat=reshape(wParentFeat,[length(parentHMark) length(parentWMark)]);
wChildFeat=reshape(wChildFeat,[length(childHMark) length(childWMark)]);
if ~isempty(detector)
    detWParentFeat=reshape(detWParentFeat,[length(parentHMark) length(parentWMark)]);
    detWChildFeat=reshape(detWChildFeat,[length(childHMark) length(childWMark)]);
else
    detWParentFeat=[];
    detWChildFeat=[];
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function [score lh lw apprDist wParentFeat wChildFeat]=computeObj(parentInt,childInt,parentSW,childSW,parentStepsize,childStepsize,w,lambda,c_appr,c_proj,spry,childScore)
% 
% [parentApprFeat MP NP parentHMark parentWMark atomP]=getBatchFeat(spry,parentInt,parentSW,parentStepsize);
% [childApprFeat MC NC childHMark childWMark atomC]=getBatchFeat(spry,childInt,childSW,childStepsize);
% parentFeat=parentApprFeat(:,1:atomP);
% childFeat=childApprFeat(:,1:atomC);
% 
% % compute distance between window appearances
% apprDist=pdist2(parentApprFeat,childApprFeat);
% % compute distance on the projection line w
% wParentFeat=(parentFeat*w)';
% wChildFeat=(childFeat*w)';
% projCost=max(lambda-bsxfun(@minus,wParentFeat',wChildFeat),0);
% overallObj=-c_proj*projCost-c_appr*apprDist;
% if exist('childScore','var')
%     % child is not a leaf node
%     overallObj=bsxfun(@plus,overallObj,childScore(:)');
% end
% 
% [score maxI]=max(overallObj,[],2);
% score=reshape(score,genSize([MP NP],parentSW,parentStepsize));
% [lh lw]=ind2sub(genSize([MC NC],childSW,childStepsize),maxI);
% lh=reshape(lh,genSize([MP NP],parentSW,parentStepsize));
% lw=reshape(lw,genSize([MP NP],parentSW,parentStepsize));
% wParentFeat=reshape(wParentFeat,[length(parentHMark) length(parentWMark)]);
% wChildFeat=reshape(wChildFeat,[length(childHMark) length(childWMark)]);
% 
% apprIdx=sub2ind(size(apprDist),vec(1:size(apprDist,1)),maxI);
% apprDist=reshape(apprDist(apprIdx),[length(parentHMark) length(parentWMark)]);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function stepsize=estimateStepsize(parentSW,parentInt,MAXWIN)
% assume the parentSW in decreasing order 
mapSize=cellfun(@(x)size(x),parentInt,'uniformoutput',false);
mapSize=cat(1,mapSize{:});
minParentSW=parentSW(end,:);
stepsize=zeros(size(mapSize,1),1);
for i = 1:size(mapSize,1)
    pixelN=prod(mapSize(i,1:2)-minParentSW+1);
    ratio=pixelN/MAXWIN;
    stepsize(i)=max(1,ceil(sqrt(ratio)));
end




% function [feat scales scaledSize]=loadIntegralMap(integralDir,imgIdx)
% integralFeat=load(fullfile(integralDir,sprintf('%g.mat',imgIdx)));
% scaledSize=integralFeat.scaledSize;
% scales=integralFeat.scales;
% feat=integralFeat.feat;


function [contFeat M N hMark wMark atomN]=getBatchFeat(spry,intMap,SW,stepsize)
% assume that spry starts with "1" which means that the first atomN column
% of contFeat must be the feat of the global patch
M=size(intMap,1);
N=size(intMap,2);
ppp=reshape(1:M*N,[M N]);
intMap=reshape(intMap,[],size(intMap,3));
[ignore hMark wMark]=genSize([M N],SW,stepsize);
indMark=ppp(hMark,wMark);
indMark=indMark(:);
[uu vv]=ind2sub([M N],indMark);
atomN=size(intMap,2);
contFeat=zeros(length(indMark),atomN*sum(spry.^2));
counter=0;
for i = 1:length(spry)
    hGrid=round(SW(1)/spry(i));
    wGrid=round(SW(2)/spry(i));
    for j = 1:spry(i)^2
        [hIdx wIdx]=ind2sub([spry(i) spry(i)],j);
        uuStart=uu+(hIdx-1)*hGrid;
        vvStart=vv+(wIdx-1)*wGrid;
        uuEnd=uuStart+hGrid-1;
        vvEnd=vvStart+wGrid-1;
        bbox=clip_to_image([vvStart uuStart vvEnd uuEnd],[1 1 N M]);
        vvStart=bbox(:,1);
        uuStart=bbox(:,2);
        vvEnd=bbox(:,3);
        uuEnd=bbox(:,4);
        hSwS=sub2ind([M N],uuStart,vvStart);
        hEwE=sub2ind([M N],uuEnd,vvEnd);
        hSwE=sub2ind([M N],uuStart,vvEnd);
        hEwS=sub2ind([M N],uuEnd,vvStart);
        feat=intMap(hEwE,:)+intMap(hSwS,:)-intMap(hSwE,:)-intMap(hEwS,:);
        feat=bsxfun(@rdivide,feat,sum(feat,2));
        feat=sqrt(feat);
        contFeat(:,(1:atomN)+atomN*counter)=feat;
        counter=counter+1;
    end
end


function [contFeat apprFeat pedroHog extfeat M N hMark wMark atomN invalidEnergyIdx]=getBatchFeatHeter(spry,intMap,hogMap,intGradientMap,whitenMu,whitenRT,SW,stepsize,hogStepSize,extRate)
% assume that spry starts with "1" which means that the first atomN column
% of contFeat must be the feat of the global patch
M=size(intMap,1);
N=size(intMap,2);
ppp=reshape(1:M*N,[M N]);
intMap=reshape(intMap,[],size(intMap,3));
[ignore hMark wMark]=genSize([M N],SW,stepsize);
indMark=ppp(hMark,wMark);
indMark=indMark(:);
[uu vv]=ind2sub([M N],indMark);
atomN=size(intMap,2);
contFeat=zeros(length(indMark),atomN*sum(spry.^2));
counter=0;
% TODO: switch between original pooling region and the cropped pooling
% region which basically tries to match pedro hog and pooling feature
% SWPooling=SW-hogStepSize;% NOTE: this is for the pooling feature since we reduce the sliding window with sbin to match pedro hog and pooling feature
SWPooling=SW;

for i = 1:length(spry)
    hGrid=round(SWPooling(1)/spry(i));
    wGrid=round(SWPooling(2)/spry(i));
    for j = 1:spry(i)^2
        [hIdx wIdx]=ind2sub([spry(i) spry(i)],j);
        uuStart=uu+(hIdx-1)*hGrid;
        vvStart=vv+(wIdx-1)*wGrid;
        uuEnd=uuStart+hGrid-1;
        vvEnd=vvStart+wGrid-1;
        bbox=clip_to_image([vvStart uuStart vvEnd uuEnd],[1 1 N M]);
        vvStart=bbox(:,1);
        uuStart=bbox(:,2);
        vvEnd=bbox(:,3);
        uuEnd=bbox(:,4);
        hSwS=sub2ind([M N],uuStart,vvStart);
        hEwE=sub2ind([M N],uuEnd,vvEnd);
        hSwE=sub2ind([M N],uuStart,vvEnd);
        hEwS=sub2ind([M N],uuEnd,vvStart);
        feat=intMap(hEwE,:)+intMap(hSwS,:)-intMap(hSwE,:)-intMap(hEwS,:);        
        feat=subnorm(feat,atomN);
        %feat=subnorm(feat,atomN-3);
        % feat=bsxfun(@rdivide,feat,sum(feat,2));
        % feat=sqrt(feat);
        contFeat(:,(1:atomN)+atomN*counter)=feat;
        counter=counter+1;
    end
end
contFeat=subnorm(contFeat,size(contFeat,2));


% get context feature with spatial pyramid
counter=0;
extfeat=zeros(length(indMark),atomN*sum(spry.^2));
hExt=extRate;
wExt=extRate;
hExtPixel=round(SW(1)*hExt);
wExtPixel=round(SW(2)*wExt);
uuExtStart=uu-hExtPixel;
vvExtStart=vv-wExtPixel;
contextWindow=[SW(1)+2*hExtPixel SW(2)+2*wExtPixel];
for i = 1:length(spry)
    hGrid=round(contextWindow(1)/spry(i));
    wGrid=round(contextWindow(2)/spry(i));
    for j = 1:spry(i)^2
        [hIdx wIdx]=ind2sub([spry(i) spry(i)],j);
        uuStart=uuExtStart+(hIdx-1)*hGrid;
        vvStart=vvExtStart+(wIdx-1)*wGrid;
        uuEnd=uuStart+hGrid-1;
        vvEnd=vvStart+wGrid-1;
        bbox=clip_to_image([vvStart uuStart vvEnd uuEnd],[1 1 N M]);
        vvStart=bbox(:,1);
        uuStart=bbox(:,2);
        vvEnd=bbox(:,3);
        uuEnd=bbox(:,4);
        hSwS=sub2ind([M N],uuStart,vvStart);
        hEwE=sub2ind([M N],uuEnd,vvEnd);
        hSwE=sub2ind([M N],uuStart,vvEnd);
        hEwS=sub2ind([M N],uuEnd,vvStart);
        feat=intMap(hEwE,:)+intMap(hSwS,:)-intMap(hSwE,:)-intMap(hEwS,:);        
        feat=subnorm(feat,atomN);
        %feat=subnorm(feat,atomN-3);
        % feat=bsxfun(@rdivide,feat,sum(feat,2));
        % feat=sqrt(feat);
        extfeat(:,(1:atomN)+atomN*counter)=feat;
        counter=counter+1;
    end
end
extfeat=subnorm(extfeat,size(extfeat,2));

% % get context feature
% hExt=extRate;
% wExt=extRate;
% hExtPixel=round(SW(1)*hExt);
% wExtPixel=round(SW(2)*wExt);
% contextWindow=[SW(1)+2*hExtPixel SW(2)+2*wExtPixel];
% uuExtStart=uu-hExtPixel;
% vvExtStart=vv-wExtPixel;
% uuExtEnd=uuExtStart+contextWindow(1);
% vvExtEnd=uuExtStart+contextWindow(2);
% extBbox=clip_to_image([vvExtStart uuExtStart vvExtEnd uuExtEnd],[1 1 N M]);
% vvExtStart=extBbox(:,1);
% uuExtStart=extBbox(:,2);
% vvExtEnd=extBbox(:,3);
% uuExtEnd=extBbox(:,4);
% ext_hSwS=sub2ind([M N],uuExtStart,vvExtStart);
% ext_hEwE=sub2ind([M N],uuExtEnd,vvExtEnd);
% ext_hSwE=sub2ind([M N],uuExtStart,vvExtEnd);
% ext_hEwS=sub2ind([M N],uuExtEnd,vvExtStart);
% extfeat=intMap(ext_hEwE,:)+intMap(ext_hSwS,:)-intMap(ext_hSwE,:)-intMap(ext_hEwS,:);
% % remove color feature
% extfeat=extfeat(:,1:end-3);
% extfeat=subnorm(extfeat,size(extfeat,2));




% extH=SW(1)+2*hExtPixel;
% extW=SW(2)+2*wExtPixel;
% hogHMark=1:extH;
% hogWMark=1:extW;
% hcoord=bsxfun(@plus,uuExtStart,repmat(hogHMark,[1 length(hogWMark)]))-1;
% wcoord=bsxfun(@plus,vvExtStart,vec(repmat(hogWMark,[length(hogHMark) 1]))')-1;
% nanMask=~(hcoord>=1&hcoord<=M&wcoord>=1&wcoord<=N);
% hcoord(nanMask)=nan;
% wcoord(nanMask)=nan;
% extIndMark=reshape(sub2ind([M N],vec(hcoord),vec(wcoord)),size(hcoord));
% for patchidx = 1:size(extIndMark,1)
%     extIndMarkRow=extIndMark(patchidx,:);
%     extIndMarkRow=extIndMarkRow(~isnan(extIndMarkRow));
%     hogmass=hogMapVec(extIndMarkRow,:);
%     % % a piece of debug code
%     % hdebugcoord=reshape(bsxfun(@plus,uuExtStart(patchidx),repmat(hogHMark,[1 length(hogWMark)]))-1,[length(hogHMark) length(hogWMark)]);
%     % wdebugcoord=reshape(bsxfun(@plus,vvExtStart(patchidx),vec(repmat(hogWMark,[length(hogHMark) 1]))'-1),[length(hogHMark) length(hogWMark)]);
%     % validx=(hdebugcoord>=1&hdebugcoord<=MHog&wdebugcoord>=1&wdebugcoord<=NHog);
%     % colvalidx=sum(validx,1)>0;
%     % rowvalidx=sum(validx,2)>0;
%     % hogmass=reshape(hogmass,[sum(rowvalidx) sum(colvalidx) 31]);
%     % subplot(1,2,1);
%     % imshow(HOGpicture(hogmass));
%     % gthogidx=sub2ind([MHog NHog],hdebugcoord(validx),wdebugcoord(validx));
%     % gthog=reshape(hogMapVec(gthogidx,:),[sum(rowvalidx) sum(colvalidx) 31]);
%     % subplot(1,2,2);
%     % imshow(HOGpicture(gthog));
% end



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% compute HOG 
epsilon=1e-6;
MHog=size(hogMap,1);
NHog=size(hogMap,2);
hogMapVec=reshape(hogMap,[],size(hogMap,3));
% transform into the hog coord since hog has sbin more dim on both direction
indMark=sub2ind([MHog NHog],uu,vv);% here the assumption is that the gradientMap is the same size as the hogMap

% TODO: switch between shoes and LFW10, compute gradient energy
% gradientEnergyThresh=2.0/60;
gradientEnergyThresh=0.01;

intGradientMap=vec(intGradientMap);
uuEnd=uu+(SW(1)-1);
vvEnd=vv+(SW(2)-1);


hSwS=sub2ind([MHog NHog],uu,vv);
hEwE=sub2ind([MHog NHog],uuEnd,vvEnd);
hSwE=sub2ind([MHog NHog],uu,vvEnd);
hEwS=sub2ind([MHog NHog],uuEnd,vv);
gradientMag=sqrt((intGradientMap(hEwE)+intGradientMap(hSwS)-intGradientMap(hSwE)-intGradientMap(hEwS))/(SW(1)*SW(2)));
invalidEnergyIdx=(gradientMag<gradientEnergyThresh);

% TODO: only for shoes, mask out the patches falling onto the mid-regions
halfN=round(NHog/2);
horMidPoint=mean([vv vvEnd],2);
midDev=abs(halfN-horMidPoint);
[midDev sortidx]=sort(midDev,'ascend');
devThresh=(max(midDev)-min(midDev))*0.1+min(midDev);
maskoutidx=sortidx(midDev<devThresh);
invalidEnergyIdx(maskoutidx)=true;

% compute the relative index for one sub-block
hStepsize=hogStepSize;
wStepsize=hogStepSize;
hogHMark=1:hStepsize:SW(1);
hogWMark=1:wStepsize:SW(2);
relCoord=repmat(vec(hogHMark),[1 length(hogWMark)]);
relCoord=vec(bsxfun(@plus,relCoord,(hogWMark-1)*MHog));
hogIdx=bsxfun(@plus,relCoord,indMark')-1;

% obtained directly by vec(hogFeat);
apprFeat=reshape(hogMapVec(vec(hogIdx),:)',[size(hogMap,3)*length(hogHMark)*length(hogWMark) length(indMark)]);
apprFeat=arrayfun(@(x)vec(shiftdim(reshape(apprFeat(:,x),[size(hogMap,3) length(hogHMark) length(hogWMark)]),1)),1:size(apprFeat,2),'uniformoutput',false);
apprFeat=cat(2,apprFeat{:});
pedroHog=apprFeat';
% TODO: add me if doing whitening
apprFeat=(whitenRT)\bsxfun(@minus,apprFeat,whitenMu);
% apprFeat=bsxfun(@rdivide,apprFeat,sqrt(sum(apprFeat.^2,1))+epsilon);
apprFeat=apprFeat';


% % DEBUG code
% diff=nan(length(uu),1);
% for ii = 1:length(uu)
%     uuI=uu(ii);
%     vvI=vv(ii);
%     directCrop=hogMap(uuI+hogHMark-1,vvI+hogWMark-1,:);
%     indirectCrop=shiftdim(reshape(apprFeat(ii,:),[size(hogMap,3) length(hogHMark) length(hogWMark)]),1);
%     % subplot(1,2,1);
%     % imshow(HOGpicture(directCrop));
%     % title('directCrop');
%     % subplot(1,2,2);
%     % imshow(HOGpicture(indirectCrop));
%     % title('indirectCrop');
%     diff(ii)=norm(vec(directCrop-indirectCrop));
%     fprintf('%g/%g\n',ii,length(uu));
% end










