function dumpChain(dsidx)
global ds;
touch;
if ~dsfield(ds,'store')
    dsload('ds.store.operaingIdx');
    dsload('ds.store.operatingIMDB');
    dsload('ds.store.operatingRes');
    dsload('ds.store.operaingPrintDir');
    dsload('ds.store.operatingChainLength');
    dsload('ds.store.operatingPedroHog');
    dsload('ds.store.operatingHogStepSize');
    dsload('ds.store.operatingWhitenMu');
    dsload('ds.store.operatingWhitenRT');
    dsload('ds.store.operatingExtRate');
end
imgIdx=ds.store.operaingIdx;
IMDB=ds.store.operatingIMDB;
res=ds.store.operatingRes;
printDir=ds.store.operaingPrintDir;
chainLength=ds.store.operatingChainLength;
pedroHog=ds.store.operatingPedroHog;
hogStepSize=ds.store.operatingHogStepSize;
whitenMu=ds.store.operatingWhitenMu;
whitenRT=ds.store.operatingWhitenRT;
extRate=ds.store.operatingExtRate;

bgDim=cellfun(@(x)length(x),whitenMu);
im=readImIMDB(imgIdx(dsidx),IMDB);
bboxes=cellfun(@(x)x(dsidx,:),res,'uniformoutput',false);
bboxes=cat(1,bboxes{:});
extBboxes=extendBbox(bboxes(:,1:4),extRate);
bboxes(:,1:4)=clip_to_image(round(bboxes(:,1:4)),[1 1 size(im,2) size(im,1)]);
extBboxes=clip_to_image(round(extBboxes),[1 1 size(im,2) size(im,1)]);
for j = 1:size(bboxes,1)
    filename=fullfile(printDir,sprintf('%g',chainLength),sprintf('%g',j),sprintf('%g.jpg',imgIdx(dsidx)));
    plottedIm=plot_bb(im,bboxes(j,:),'r');
    %plottedIm=plot_bb(plottedIm,extBboxes(j,:),'b');
    myimwrite(plottedIm,filename);
end
ds.res.imGrad{dsidx}=nan(size(bboxes,1),1);
% write hog images
uScales=unique(bboxes(:,10));
% TODO: remove me, here is to fake pedro's hog
%hogPyr=pixelwiseHogPyramidFixedScales(im,uScales);
%[hogPyr scaledSize]=pedroHogFixedScales(im,uScales);
%hogPyr=fakePadding(hogPyr,scaledSize);
hogPyr=pedroHog{dsidx};
hogScales=hogPyr.scales;


gradientMap=cell(length(uScales),1);
for j = 1:length(uScales)
    scaled=myimresize(im,uScales(j));
    [gx gy]=gradient(im2double(scaled),1);
    gradientMap{j}=sqrt(max(gx.^2,[],3)+max(gy.^2,[],3));
end
for j = 1:size(bboxes,1)
    filename=fullfile(printDir,'hog',sprintf('%g',chainLength),sprintf('%g',j),sprintf('%g.jpg',imgIdx(dsidx)));
    hogMap=hogPyr.hog{epsilonMatch(hogScales,bboxes(j,10))};
    gg=gradientMap{epsilonMatch(uScales,bboxes(j,10))};
    uu=bboxes(j,6);
    vv=bboxes(j,5);
    SW(1)=bboxes(j,8)-bboxes(j,6)+1;
    SW(2)=bboxes(j,7)-bboxes(j,5)+1;
    hogHMark=1:hogStepSize:SW(1);
    hogWMark=1:hogStepSize:SW(2);
    % TODO: switch between original and efficient way
    hIdx=max(1,min(size(hogMap,1),floor((uu+hogHMark-1)/hogStepSize)+1));
    wIdx=max(1,min(size(hogMap,2),floor((vv+hogWMark-1)/hogStepSize)+1));
    hogFeat=hogMap(hIdx,wIdx,:);
    %hogFeat=hogMap(uu+hogHMark-1,vv+hogWMark-1,:);
    checkFeat=reshape(hogFeat,[],31);mag=sqrt(sum(checkFeat.^2,2))>0;distM=pdist2(checkFeat,checkFeat);distM=distM(mag,mag);idN=sum(vec(distM==0))-size(distM,1);
    if idN>0
        fprintf('some thing wrong\n');
        %keyboard;
    end
    bgStatIdx=find(numel(hogFeat)==bgDim);
    hogFeat=reshape((whitenRT{bgStatIdx})\(vec(hogFeat)-whitenMu{bgStatIdx}),size(hogFeat));
    hogPic=HOGpicture(hogFeat);
    myimwrite(hogPic,filename);
    ds.res.imGrad{dsidx}(j)=norm(vec(gg(uu:uu+SW(1)-1,vv:vv+SW(2)-1)))/sqrt(SW(1)*SW(2));
end
fprintf('written %g/%g th image, imgIdx=%g\n',dsidx,length(imgIdx),imgIdx(dsidx));

function minIdx=epsilonMatch(array,val)
[minVal minIdx]=min(abs(array-val));
if minVal>1e-6
    error('there seems to be a problem!')
end



