% testing function 


function [wFinal accRes accResGlobal ensembleTable moreRes]=ensembleTest(ensembleK,bboxes,accTable,universalTrainIdx,...
    universalValIdx,universalTestIdx,trainConstraints,valConstraints,testConstraints,universalScales,universalScaledSize,atomN,grids,spry,templateH,templateW,...
    globalTemplateH,globalTemplateW,esvmDefaultParams,IMDB,imgCodeDir,bufferDir,rootPrintDir,attrName,dataset_name)


[sortval sortidx]=sort(accTable(:,4),'descend');
sortidx=sortidx(1:min(ensembleK,length(sortidx)));
ensembleTable=accTable(sortidx,:);

fprintf('ensembleTable:\n');
ensembleTable


uRootIdx=unique(ensembleTable(:,1));
testFeatEnsemble=cell(size(ensembleTable,1),1);
trainFeatEnsemble=cell(size(ensembleTable,1),1);
valFeatEnsemble=cell(size(ensembleTable,1),1);


switch dataset_name
    case 'utzap50k'
        halfFlag=true;
        operGlobalTemplateW=round(globalTemplateW/2);
    case 'shoes'
        halfFlag=true;
        operGlobalTemplateW=round(globalTemplateW/2);
    case 'LFW10'
        halfFlag=false;
        operGlobalTemplateW=globalTemplateW;
    case 'devi'
        halfFlag=false;
        operGlobalTemplateW=globalTemplateW;
    otherwise
        error('unknown dataset');
end

% get global feat
tmpGlobalTrainIdx=[vec(universalTrainIdx);vec(universalValIdx)];
globalTrainSizes=getIMDBProperty(tmpGlobalTrainIdx,IMDB,'size');
globalTrainBboxes=[ones(length(tmpGlobalTrainIdx),2) globalTrainSizes(:,[2 1])];
globalTrainBboxes=[globalTrainBboxes vec(tmpGlobalTrainIdx) ones(length(tmpGlobalTrainIdx),1)*globalTemplateH ones(length(tmpGlobalTrainIdx),1)*operGlobalTemplateW];  
[retGlobalTrainBboxes globalTrainFeat]=computeFeat(globalTrainBboxes,universalScaledSize,universalScales,spry,IMDB,imgCodeDir,struct('half',halfFlag));

[a b]=ismember(retGlobalTrainBboxes(:,5),tmpGlobalTrainIdx);
trainFeatEnsembleGlobal(:,b)=globalTrainFeat;
trainFeatEnsembleGlobal=fillcol(trainFeatEnsembleGlobal,length(tmpGlobalTrainIdx));

tmpGlobalTestIdx=universalTestIdx;
globalTestSizes=getIMDBProperty(tmpGlobalTestIdx,IMDB,'size');
globalTestBboxes=[ones(length(tmpGlobalTestIdx),2) globalTestSizes(:,[2 1])];
globalTestBboxes=[globalTestBboxes vec(tmpGlobalTestIdx) ones(length(tmpGlobalTestIdx),1)*globalTemplateH ones(length(tmpGlobalTestIdx),1)*operGlobalTemplateW];        
[retGlobalTestBboxes globalTestFeat]=computeFeat(globalTestBboxes,universalScaledSize,universalScales,spry,IMDB,imgCodeDir,struct('half',halfFlag));

[a b]=ismember(retGlobalTestBboxes(:,5),tmpGlobalTestIdx);
testFeatEnsembleGlobal(:,b)=globalTestFeat;
testFeatEnsembleGlobal=fillcol(testFeatEnsembleGlobal,length(tmpGlobalTestIdx));

% prune empty guys
emptyIdx=(sum(testFeatEnsembleGlobal==0,1)==size(testFeatEnsembleGlobal,1));
testFeatEnsembleGlobal(:,emptyIdx)=[];
universalTestIdxGlobal=tmpGlobalTestIdx;
universalTestIdxGlobal(emptyIdx)=[];
emptyIdx=(sum(trainFeatEnsembleGlobal==0,1)==size(trainFeatEnsembleGlobal,1));
trainFeatEnsembleGlobal(:,emptyIdx)=[];
universalTrainIdxGlobal=tmpGlobalTrainIdx;
universalTrainIdxGlobal(emptyIdx)=[];

operTrainConstraints=[trainConstraints;valConstraints];
operTrainConstraints=verifyConstraints(operTrainConstraints,universalTrainIdxGlobal);
operTestConstraints=testConstraints;
operTestConstraints=verifyConstraints(operTestConstraints,universalTestIdxGlobal);
[wGlobal accResGlobal]=evaluateDriver(universalTrainIdxGlobal,trainFeatEnsembleGlobal,universalTestIdxGlobal,testFeatEnsembleGlobal,operTrainConstraints,operTestConstraints);

moreRes.global.universalTrainIdx=universalTrainIdxGlobal;
moreRes.global.universalTestIdx=universalTestIdxGlobal;
moreRes.global.trainFeatEnsemble=trainFeatEnsembleGlobal;
moreRes.global.testFeatEnsemble=testFeatEnsembleGlobal;
moreRes.global.operTrainConstraints=operTrainConstraints;
moreRes.global.operTestConstraints=operTestConstraints;
fprintf('ensembleTest: global baseline on test data, trAcc=%g, cvAcc=%g\n',accResGlobal.trAcc,accResGlobal.cvAcc);


testBboxesBag=cell(size(ensembleTable,1),1);
trainBboxesBag=cell(size(ensembleTable,1),1);
valBboxesBag=cell(size(ensembleTable,1),1);
for bi=1:length(uRootIdx)
    hypoFilename=fullfile(bufferDir,sprintf('hypoDetectors_%s_%g.mat',attrName,uRootIdx(bi)));
    hypoConcepts=load(hypoFilename);
    hypoConcepts=hypoConcepts.hypoConcepts;
    pertTable=ensembleTable(uRootIdx(bi)==ensembleTable(:,1),:);
    % fire root detector on the testing data
    sortPrintDir=fullfile(rootPrintDir,'ensemble',sprintf('%s',attrName),sprintf('root_%g',uRootIdx(bi)));
    [ignore ignore testFireBboxes ignore testFireScores]=sortImagesByDetect(hypoConcepts.detectorFinal,universalTestIdx,IMDB,sortPrintDir,universalScales,esvmDefaultParams,...
            struct('padding',esvmDefaultParams.detect_pyramid_padding,'isJointFeat',true,'contextExtRate',0.35));
    testFireBboxes(:,6:7)=repmat([templateH,templateW],[size(testFireBboxes,1) 1]);
    
    % fire root detector on the validation data
    sortPrintDir=fullfile(rootPrintDir,'ensemble',sprintf('%s',attrName),sprintf('root_val_%g',uRootIdx(bi)));
    [ignore ignore valFireBboxes ignore valFireScores]=sortImagesByDetect(hypoConcepts.detectorFinal,universalValIdx,IMDB,sortPrintDir,universalScales,esvmDefaultParams,...
            struct('padding',esvmDefaultParams.detect_pyramid_padding,'isJointFeat',true,'contextExtRate',0.35));
    valFireBboxes(:,6:7)=repmat([templateH,templateW],[size(valFireBboxes,1) 1]);

    for kk=1:size(pertTable,1)
        pertIdx=pertTable(kk,2);
        pertAcc=pertTable(kk,4);
        ensemblePtr=find(ismember(ensembleTable(:,1:2),[uRootIdx(bi) pertIdx],'rows'));
        perturbationH=hypoConcepts.perturbations{pertIdx}.perturbationH;
        perturbationW=hypoConcepts.perturbations{pertIdx}.perturbationW;
        operTestBboxes=perturbBboxesVar(testFireBboxes,perturbationH,perturbationW);
        operValBboxes=perturbBboxesVar(valFireBboxes,perturbationH,perturbationW);
        testBboxesBag{ensemblePtr}=[operTestBboxes ones(size(operTestBboxes,1),1)*ensemblePtr vec(testFireScores)];
        trainBboxesBag{ensemblePtr}=[hypoConcepts.perturbations{pertIdx}.hypoBboxes ones(size(hypoConcepts.perturbations{pertIdx}.hypoBboxes,1),1)*ensemblePtr];
        valBboxesBag{ensemblePtr}=[operValBboxes ones(size(operValBboxes,1),1)*ensemblePtr vec(valFireScores)];
        
        % visualization section
        pertPrintDir=fullfile(rootPrintDir,'ensemble',sprintf('%s',attrName),sprintf('root_%g',uRootIdx(bi)));
        pertFileDir=fullfile(pertPrintDir,sprintf('pert_%g',pertIdx));
        printImg(operTestBboxes,IMDB,pertFileDir);
        printpage(operTestBboxes,[],pertFileDir,pertPrintDir,sprintf('pert_%g_%.2f.html',pertIdx,pertAcc));
        
        pertPrintDir=fullfile(rootPrintDir,'ensemble',sprintf('%s',attrName),sprintf('root_val_%g',uRootIdx(bi)));
        pertFileDir=fullfile(pertPrintDir,sprintf('pert_%g',pertIdx));
        printImg(operValBboxes,IMDB,pertFileDir);
        printpage(operValBboxes,[],pertFileDir,pertPrintDir,sprintf('pert_%g_%.2f.html',pertIdx,pertAcc));
    end
    fprintf('ensembleTest: loading %g/%g bag, bag idx=%g\n',bi,length(uRootIdx),uRootIdx(bi));
end



% get feature for the training bboxes
batchN=20;
counter=0;
while counter<size(ensembleTable,1)
    actualBatchN=min(size(ensembleTable,1)-counter,batchN);
    trainBboxes=[];
    testBboxes=[];
    valBboxes=[];
    for kk=1:actualBatchN
        ptr=kk+counter;
        tmpBboxes=trainBboxesBag{ptr};
        trainBboxes=[trainBboxes;tmpBboxes];
        tmpBboxes=testBboxesBag{ptr};
        testBboxes=[testBboxes;tmpBboxes];
        tmpBboxes=valBboxesBag{ptr};
        valBboxes=[valBboxes;tmpBboxes];
    end
    [retTrainBboxes retTrainFeat]=computeFeat_multi(trainBboxes,universalScaledSize,universalScales,grids,IMDB,imgCodeDir);
    [retTestBboxes retTestFeat]=computeFeat_multi(testBboxes,universalScaledSize,universalScales,grids,IMDB,imgCodeDir);
    [retValBboxes retValFeat]=computeFeat_multi(valBboxes,universalScaledSize,universalScales,grids,IMDB,imgCodeDir);
    
    % distribute the feature
    uChainIdx=unique(retTrainBboxes(:,8));
    for kk=1:length(uChainIdx)
        chainIdx=uChainIdx(kk);
        
        chainValIdx=retTrainBboxes(:,8)==chainIdx;
        chainBboxes=retTrainBboxes(chainValIdx,:);
        chainFeat=retTrainFeat(:,chainValIdx);
        [a b]=ismember(chainBboxes(:,5),universalTrainIdx);
        assert(sum(a==0)==0);
        trainFeatEnsemble{chainIdx}(:,b)=chainFeat;
        trainFeatEnsemble{chainIdx}=fillcol(trainFeatEnsemble{chainIdx},length(universalTrainIdx));
        
        chainValIdx=retTestBboxes(:,8)==chainIdx;
        chainBboxes=retTestBboxes(chainValIdx,:);
        chainFeat=retTestFeat(:,chainValIdx);
        [a b]=ismember(chainBboxes(:,5),universalTestIdx);
        assert(sum(a==0)==0);
        testFeatEnsemble{chainIdx}(:,b)=chainFeat;
        testFeatEnsemble{chainIdx}=fillcol(testFeatEnsemble{chainIdx},length(universalTestIdx));
        
        chainValIdx=retValBboxes(:,8)==chainIdx;
        chainBboxes=retValBboxes(chainValIdx,:);
        chainFeat=retValFeat(:,chainValIdx);
        [a b]=ismember(chainBboxes(:,5),universalValIdx);
        assert(sum(a==0)==0);
        valFeatEnsemble{chainIdx}(:,b)=chainFeat;
        valFeatEnsemble{chainIdx}=fillcol(valFeatEnsemble{chainIdx},length(universalValIdx));
    end
    counter=counter+actualBatchN;
end


% manufacture the final feat for both training and testing 
trainFeatEnsemble=cat(1,trainFeatEnsemble{:});
testFeatEnsemble=cat(1,testFeatEnsemble{:});
valFeatEnsemble=cat(1,valFeatEnsemble{:});

% prune empty guys
emptyIdx=(sum(testFeatEnsemble==0,1)==size(testFeatEnsemble,1));
testFeatEnsemble(:,emptyIdx)=[];
universalTestIdx(emptyIdx)=[];
testBboxesBag=cellfun(@(x)x(ismember(x(:,5),universalTestIdx),:),testBboxesBag,'uniformoutput',false);

emptyIdx=(sum(trainFeatEnsemble==0,1)==size(trainFeatEnsemble,1));
trainFeatEnsemble(:,emptyIdx)=[];
universalTrainIdx(emptyIdx)=[];
trainBboxesBag=cellfun(@(x)x(ismember(x(:,5),universalTrainIdx),:),trainBboxesBag,'uniformoutput',false);

emptyIdx=(sum(valFeatEnsemble==0,1)==size(valFeatEnsemble,1));
valFeatEnsemble(:,emptyIdx)=[];
universalValIdx(emptyIdx)=[];
valBboxesBag=cellfun(@(x)x(ismember(x(:,5),universalValIdx),:),valBboxesBag,'uniformoutput',false);


operTrainConstraints=verifyConstraints(trainConstraints,universalTrainIdx);
operTestConstraints=verifyConstraints(testConstraints,universalTestIdx);
operValConstraints=verifyConstraints(valConstraints,universalValIdx);

% scan through different grids to pick out the best performing guys
gridValAcc=zeros(size(ensembleTable,1)*sum(grids.^2),6); % [cvAcc, ensembleIdx, gridIdx, teAcc, rootIdx, pertIdx]
ensembleCounter=0;
counter=0;
for kk=1:size(ensembleTable,1)
    ensembleDimOffset=ensembleCounter*atomN*sum(grids.^2);
    gridCounter=0;
    for i = 1:length(grids)
        for j = 1:grids(i)^2
            valSubFeat=valFeatEnsemble(ensembleDimOffset+(1:atomN)+atomN*gridCounter,:);
            trainSubFeat=trainFeatEnsemble(ensembleDimOffset+(1:atomN)+atomN*gridCounter,:);
            testSubFeat=testFeatEnsemble(ensembleDimOffset+(1:atomN)+atomN*gridCounter,:);
            [wFinal tmpAccRes]=evaluateDriver(universalTrainIdx,trainSubFeat,universalValIdx,valSubFeat,operTrainConstraints,operValConstraints);
            [wFinal teRes]=evaluateDriver(universalTrainIdx,trainSubFeat,universalTestIdx,testSubFeat,operTrainConstraints,operTestConstraints);
            gridValAcc(counter+1,:)=[tmpAccRes.cvAcc kk gridCounter+1 teRes.cvAcc ensembleTable(kk,1) ensembleTable(kk,2)];
            fprintf('ensembleTest: ensembleIdx=%g (r/p:%g/%g), gridIdx=%g, cvAcc=%g, teAcc=%g\n',...
                gridValAcc(counter+1,2),gridValAcc(counter+1,5),gridValAcc(counter+1,6),gridValAcc(counter+1,3),gridValAcc(counter+1,1),gridValAcc(counter+1,4));
            gridCounter=gridCounter+1;
            counter=counter+1;
        end
    end
    ensembleCounter=ensembleCounter+1;
end


% select out grids that perform well
tmpGridValAcc=gridValAcc;
gridK=min(60,size(tmpGridValAcc,1));
[sortval sortidx]=sort(tmpGridValAcc(:,1),'descend');
sortidx=sortidx(1:gridK);
selGrid=tmpGridValAcc(sortidx,:);
selGrid
selDim=calDim(selGrid,atomN,grids);



[gridEnsembleTable gridTestBboxesBag]=genGridData(selGrid,ensembleTable,testBboxesBag,grids);
[ignore gridValBboxesBag]=genGridData(selGrid,ensembleTable,valBboxesBag,grids);

% clustering over bboxes (ignore this, it is for the feature clustering experiment)
% [groupIndicator]=clusterChains(gridValBboxesBag,selGrid,IMDB);
groupIndicator=1:length(gridValBboxesBag);

operTrainFeat=poolByGroup(trainFeatEnsemble,selGrid,atomN,grids,groupIndicator);
operValFeat=poolByGroup(valFeatEnsemble,selGrid,atomN,grids,groupIndicator);
operTestFeat=poolByGroup(testFeatEnsemble,selGrid,atomN,grids,groupIndicator);

% classifier hyper-parameter
C = 0.01;
[wFinal accRes]=evaluateDriver([universalTrainIdx;universalValIdx],[operTrainFeat operValFeat],universalTestIdx,operTestFeat,...
    [operTrainConstraints;operValConstraints],operTestConstraints,C);
fprintf('ensembleTest: feat concat on test data (%g patches), trAcc=%g, cvAcc=%g\n',ensembleK,accRes.trAcc,accRes.cvAcc);


% display with overlay
% sorting
switch dataset_name
    case 'utzap50k'
        mergeDisp=true;
    case 'shoes'
        mergeDisp=true;
    case 'LFW10'
        mergeDisp=false;
    otherwise
        error('unknown dataset');
end


operTestResp=wFinal'*operTestFeat;
overlayImgPrintDir=fullfile(rootPrintDir,'ensemble',sprintf('%s',attrName),'overlay');
overlayHTMLPrintDir=fullfile(rootPrintDir,'ensemble',sprintf('%s',attrName));
overlayDisp(gridEnsembleTable,universalTestIdx,gridTestBboxesBag,operTestResp,groupIndicator,overlayHTMLPrintDir,'overlay',overlayImgPrintDir,IMDB,mergeDisp);

% select out the good-performing grids for the global baseline
% get the corresponding train and val splits for fair comparison with our
% approach
[a b]=ismember(universalValIdx,universalTrainIdxGlobal);
b=b(a);
newValFeatEnsembleGlobal=zeros(size(trainFeatEnsembleGlobal,1),length(universalValIdx));
newValFeatEnsembleGlobal(:,a)=trainFeatEnsembleGlobal(:,b);
[a b]=ismember(universalTrainIdx,universalTrainIdxGlobal);
b=b(a);
newTrainFeatEnsembleGlobal=zeros(size(trainFeatEnsembleGlobal,1),length(universalTrainIdx));
newTrainFeatEnsembleGlobal(:,a)=trainFeatEnsembleGlobal(:,b);
[a b]=ismember(universalTestIdx,universalTestIdxGlobal);
b=b(a);
newTestFeatEnsembleGlobal=zeros(size(testFeatEnsembleGlobal,1),length(universalTestIdx));
newTestFeatEnsembleGlobal(:,a)=testFeatEnsembleGlobal(:,b);

globalGridValAcc=zeros(sum(spry.^2),6); % [cvAcc, ensembleIdx, gridIdx, teAcc, rootIdx, pertIdx]
counter=0;
kk=1;
for i = 1:length(spry)
    for j = 1:spry(i)^2
        valSubFeat=newValFeatEnsembleGlobal((1:atomN)+atomN*counter,:);
        trainSubFeat=newTrainFeatEnsembleGlobal((1:atomN)+atomN*counter,:);
        testSubFeat=newTestFeatEnsembleGlobal((1:atomN)+atomN*counter,:);
        [wFinal tmpAccRes]=evaluateDriver(universalTrainIdx,trainSubFeat,universalValIdx,valSubFeat,operTrainConstraints,operValConstraints);
        [wFinal teRes]=evaluateDriver(universalTrainIdx,trainSubFeat,universalTestIdx,testSubFeat,operTrainConstraints,operTestConstraints);
        globalGridValAcc(counter+1,:)=[tmpAccRes.cvAcc kk counter+1 teRes.cvAcc 1 1];
        fprintf('ensembleTest: global grid selection gridIdx=%g, cvAcc=%g, teAcc=%g\n',...
            globalGridValAcc(counter+1,3),globalGridValAcc(counter+1,1),globalGridValAcc(counter+1,4));
        counter=counter+1;
    end
end

% print the heat map overlay with global grid selection (baseline)
tmpGlobalGridValAcc=globalGridValAcc;
tmpGlobalGridValAcc(tmpGlobalGridValAcc(:,3)==1,:)=[];
[sortval sortidx]=sort(tmpGlobalGridValAcc(:,1),'descend');
globalSelGrid=tmpGlobalGridValAcc(sortidx,:);
globalEnsembleTable=ensembleTable(1,:);

tmpimgsize = getIMDBProperty(universalTestIdxGlobal,IMDB,'size');
imgsize = [ones(length(universalTestIdxGlobal),2) tmpimgsize(:,[2 1])];
globalTestBboxesBag={[imgsize vec(universalTestIdxGlobal)]};

[globalGridEnsembleTable globalGridTestBboxesBag]=genGridData(globalSelGrid,globalEnsembleTable,globalTestBboxesBag,spry);
operGlobalTestResp=wGlobal'*newTestFeatEnsembleGlobal;

overlayImgPrintDir=fullfile(rootPrintDir,'ensemble',sprintf('%s',attrName),'overlay_global');
overlayHTMLPrintDir=fullfile(rootPrintDir,'ensemble',sprintf('%s',attrName));
overlayDisp(globalGridEnsembleTable,universalTestIdx,globalGridTestBboxesBag,operGlobalTestResp,ones(size(globalGridEnsembleTable,1),1),overlayHTMLPrintDir,'overlay_global',overlayImgPrintDir,IMDB);

% visualize by the attribute strength
[sortedTestResp sortidx]=sort(operTestResp,'descend');
sortedUniversalTestIdx=universalTestIdx(sortidx);
for kk=1:length(testBboxesBag)
    [a b]=ismember(sortedUniversalTestIdx,testBboxesBag{kk}(:,5));
    b=b(a);
    tmpSortedTestResp=sortedTestResp(a);
    operBboxes=testBboxesBag{kk}(b,:);
    rootIdx=ensembleTable(kk,1);
    pertIdx=ensembleTable(kk,2);
    valAcc=ensembleTable(kk,4);
    themename=sprintf('root_%g_pert_%g_acc_%g',rootIdx,pertIdx,valAcc);
    printdir=fullfile(rootPrintDir,'ensemble',sprintf('%s',attrName),'chainByAttrStrength',themename);
    printImgAtom(operBboxes,IMDB,fullfile(printdir,'img'));
    printPageAtom(operBboxes,tmpSortedTestResp,'img',printdir);
end


moreRes.universalTrainIdx=universalTrainIdx;
moreRes.universalTestIdx=universalTestIdx;
moreRes.universalValIdx=universalValIdx;
moreRes.trainFeatEnsemble=trainFeatEnsemble;
moreRes.testFeatEnsemble=testFeatEnsemble;
moreRes.valFeatEnsemble=valFeatEnsemble;
moreRes.operTrainConstraints=operTrainConstraints;
moreRes.operTestConstraints=operTestConstraints;
moreRes.operValConstraints=operValConstraints;
moreRes.trainBboxesBag=trainBboxesBag;
moreRes.testBboxesBag=testBboxesBag;
moreRes.valBboxesBag=valBboxesBag;
moreRes.gridValAcc=gridValAcc;
moreRes.selGrid=selGrid;
moreRes.groupIndicator=groupIndicator;
moreRes.gridEnsembleTable=gridEnsembleTable;
moreRes.gridTestBboxesBag=gridTestBboxesBag;
moreRes.ensembleTable=ensembleTable;

function A=fillcol(A,k)
if isempty(A)
    error('A is empty!');
end
if size(A,2)>=k
    return;
end
A=[A zeros(size(A,1),k-size(A,2))];


function printImg(bboxes,IMDB,printdir)
for i = 1:size(bboxes,1)
    imgidx=bboxes(i,5);
    imgFilename=fullfile(printdir,sprintf('%g.jpg',imgidx));
    img=readImIMDB(imgidx,IMDB);
    img=plot_bb(img,bboxes(i,1:4),'r');
    myimwrite(img,imgFilename);
end

function printpage(bboxes,resp,sortimgdir,printdir,filename)
if isempty(resp)
    resp=nan(size(bboxes,1),1);
end
imgList=[];
imgStr=[];
htmlfilename=fullfile(printdir,filename);
for i = 1:size(bboxes,1)
    imgidx=bboxes(i,5);
    imgFilename=fullfile(sortimgdir,sprintf('%g.jpg',imgidx));
    imgList{end+1}=relativepath(imgFilename,printdir);
    imgStr{end+1}=sprintf('(%g/%g) imgIdx:%g,d=%g',i,size(bboxes,1),imgidx,resp(i));
end
displayPatch(htmlfilename,imgList,imgStr,[],[],9,200,200);




