% testing function 


function [wFinal accRes ensembleTable moreRes]=ensembleTest_Deep(ensembleK,bboxes,accTable,universalTrainIdx,universalTestIdx,trainConstraints,testConstraints,universalScales,universalScaledSize,templateH,templateW,esvmDefaultParams,IMDB,...
    imgCodeDir,bufferDir,rootPrintDir,attrName)

% [accSortVal accSortIdx]=sort(accTable(:,4),'descend');
% ensembleIdx=accSortIdx(1:min(length(accSortIdx),ensembleK));
% NMS
% set a thresh to prune out the bad guys

ensembleTableFilename=fullfile(bufferDir,sprintf('ensembleTable_%s.mat',attrName));
if ~exist(ensembleTableFilename,'file')
    % get the intersect of sets
    intersectTrainIdx=bboxes{1}(:,5);
    for bi=1:length(bboxes)
        intersectTrainIdx=intersect(intersectTrainIdx,bboxes{bi}(:,5));
    end
    intersectBboxes=cell(length(bboxes),1);
    for bi=1:length(bboxes)
        [a b]=ismember(bboxes{bi}(:,5),intersectTrainIdx);
        b(b==0)=[];
        tmpBboxes=[];
        tmpBboxes(b,:)=bboxes{bi}(a,:);
        intersectBboxes{bi}=tmpBboxes;
    end
    
    scoreThresh=0.7;
    keepIdx=accTable(:,4)>=scoreThresh;
    intersectBboxes=intersectBboxes(keepIdx);
    accTable=accTable(keepIdx,:);
    [res ensembleIdx]=chainNMS(intersectBboxes,ensembleK,accTable(:,4));
    ensembleTable=accTable(ensembleIdx,:);
    mySaveFile(ensembleTableFilename,ensembleTable);
else
    load(ensembleTableFilename);
end
fprintf('ensembleTable:\n');
ensembleTable


uRootIdx=unique(ensembleTable(:,1));
testFeatEnsemble=cell(size(ensembleTable,1),1);
trainFeatEnsemble=cell(size(ensembleTable,1),1);

for bi=1:length(uRootIdx)
    hypoFilename=fullfile(bufferDir,sprintf('hypoDetectors_%s_%g.mat',attrName,uRootIdx(bi)));
    hypoConcepts=load(hypoFilename);
    hypoConcepts=hypoConcepts.hypoConcepts;
    % fire root detector on the testing data
    sortPrintDir=fullfile(rootPrintDir,'ensemble',sprintf('%s',attrName),sprintf('root_%g',uRootIdx(bi)));
    [ignore ignore testFireBboxes]=sortImagesByDetect(hypoConcepts.detectorFinal,universalTestIdx,IMDB,sortPrintDir,universalScales,esvmDefaultParams,...
            struct('padding',esvmDefaultParams.detect_pyramid_padding,'isJointFeat',true,'contextExtRate',0.35));
    pertTable=ensembleTable(uRootIdx(bi)==ensembleTable(:,1),:);
    testFireBboxes(:,6:7)=repmat([templateH,templateW],[size(testFireBboxes,1) 1]);

    for kk=1:size(pertTable,1)
        pertIdx=pertTable(kk,2);
        pertAcc=pertTable(kk,4);
        ensemblePtr=find(ismember(ensembleTable(:,1:2),[uRootIdx(bi) pertIdx],'rows'));
        perturbationH=hypoConcepts.perturbations{pertIdx}.perturbationH;
        perturbationW=hypoConcepts.perturbations{pertIdx}.perturbationW;
        operTestBboxes=perturbBboxesVar(testFireBboxes,perturbationH,perturbationW);
        [retTestBboxes testFeat]=computePool5Feat_multi(operTestBboxes,IMDB);
        testFeat=double(testFeat);
        [a b]=ismember(retTestBboxes(:,5),universalTestIdx);
        assert(sum(a==0)==0);
        testFeatEnsemble{ensemblePtr}(:,b)=testFeat;
        testFeatEnsemble{ensemblePtr}=fillcol(testFeatEnsemble{ensemblePtr},length(universalTestIdx));
        
        
        [retTrainBboxes trainFeat]=computePool5Feat_multi(hypoConcepts.perturbations{pertIdx}.hypoBboxes,IMDB);
        trainFeat=double(trainFeat);
        [a b]=ismember(retTrainBboxes(:,5),universalTrainIdx);
        assert(sum(a==0)==0);
        trainFeatEnsemble{ensemblePtr}(:,b)=trainFeat;
        trainFeatEnsemble{ensemblePtr}=fillcol(trainFeatEnsemble{ensemblePtr},length(universalTrainIdx));
        
        
        % visualization section
        pertPrintDir=fullfile(rootPrintDir,'ensemble',sprintf('%s',attrName),sprintf('root_%g',uRootIdx(bi)));
        pertFileDir=fullfile(pertPrintDir,sprintf('pert_%g',pertIdx));
        printImg(operTestBboxes,IMDB,pertFileDir);
        printpage(operTestBboxes,[],pertFileDir,pertPrintDir,sprintf('pert_%g_%.2f.html',pertIdx,pertAcc));
    end
    fprintf('ensembleTest: loading %g/%g bag, bag idx=%g\n',bi,length(uRootIdx),uRootIdx(bi));
end

% manufacture the final feat for both training and testing 
trainFeatEnsemble=cat(1,trainFeatEnsemble{:});
testFeatEnsemble=cat(1,testFeatEnsemble{:});

% prune empty guys
emptyIdx=(sum(testFeatEnsemble==0,1)==size(testFeatEnsemble,1));
testFeatEnsemble(:,emptyIdx)=[];
universalTestIdx(emptyIdx)=[];
emptyIdx=(sum(trainFeatEnsemble==0,1)==size(trainFeatEnsemble,1));
trainFeatEnsemble(:,emptyIdx)=[];
universalTrainIdx(emptyIdx)=[];

operTrainConstraints=verifyConstraints(trainConstraints,universalTrainIdx);
operTestConstraints=verifyConstraints(testConstraints,universalTestIdx);

[wFinal accRes]=evaluateDriver(universalTrainIdx,trainFeatEnsemble,universalTestIdx,testFeatEnsemble,operTrainConstraints,operTestConstraints);
moreRes.universalTrainIdx=universalTrainIdx;
moreRes.universalTestIdx=universalTestIdx;
moreRes.trainFeatEnsemble=trainFeatEnsemble;
moreRes.testFeatEnsemble=testFeatEnsemble;
moreRes.operTrainConstraints=operTrainConstraints;
moreRes.operTestConstraints=operTestConstraints;


function A=fillcol(A,k)
if isempty(A)
    error('A is empty!');
end
if size(A,2)>=k
    return;
end
A=[A zeros(size(A,1),k-size(A,2))];


function printImg(bboxes,IMDB,printdir)
for i = 1:size(bboxes,1)
    imgidx=bboxes(i,5);
    imgFilename=fullfile(printdir,sprintf('%g.jpg',imgidx));
    img=readImIMDB(imgidx,IMDB);
    img=plot_bb(img,bboxes(i,1:4),'r');
    myimwrite(img,imgFilename);
end

function printpage(bboxes,resp,sortimgdir,printdir,filename)
if isempty(resp)
    resp=nan(size(bboxes,1),1);
end
imgList=[];
imgStr=[];
htmlfilename=fullfile(printdir,filename);
for i = 1:size(bboxes,1)
    imgidx=bboxes(i,5);
    imgFilename=fullfile(sortimgdir,sprintf('%g.jpg',imgidx));
    imgList{end+1}=relativepath(imgFilename,printdir);
    imgStr{end+1}=sprintf('(%g/%g) imgIdx:%g,d=%g',i,size(bboxes,1),imgidx,resp(i));
end
displayPatch(htmlfilename,imgList,imgStr,[],[],9,200,200);










