function [gridEnsembleTable gridTestBboxesBag]=genGridData(grid,ensembleTable,bboxesBag,spry)
gridTestBboxesBag=cell(size(grid,1),1);
gridEnsembleTable=zeros(size(grid,1),5);
for i=1:size(grid,1)
    ensembleIdx=grid(i,2);
    gridIdx=grid(i,3);
    gridTestBboxesBag{i}=partitionBboxes(bboxesBag{ensembleIdx},spry,gridIdx);
    gridEnsembleTable(i,:)=ensembleTable(ensembleIdx,:);
    gridEnsembleTable(i,4)=grid(i,1);
end

function gridBboxes=partitionBboxes(bboxes,spry,gridIdx)
gridNByLayer=cumsum(spry.^2);
layer=find(gridIdx<=gridNByLayer);
layer=layer(1);

gridN=spry(layer);
if layer>1
    gridIdxWithinLayer=gridIdx-gridNByLayer(layer-1);
else
    gridIdxWithinLayer=gridIdx;
end
[hIdx wIdx]=ind2sub([gridN gridN],gridIdxWithinLayer);

h=bboxes(:,2);
w=bboxes(:,1);
wid=bboxes(:,3)-bboxes(:,1)+1;
hgt=bboxes(:,4)-bboxes(:,2)+1;
hGrid=hgt/gridN;
wGrid=wid/gridN;

uuStart=h+(hIdx-1)*hGrid;
vvStart=w+(wIdx-1)*wGrid;
uuEnd=uuStart+hGrid-1;
vvEnd=vvStart+wGrid-1;

gridBboxes=[vvStart uuStart vvEnd uuEnd bboxes(:,5:end)];