function getMapValue(dsidx)
global ds;
touch;
if (~dsfield(ds,'store')),
    dsload('ds.store.operatingBboxes');
    dsload('ds.store.operatingMapDir');
    dsload('ds.store.operatingW');
    dsload('ds.store.operatingDetector');
    dsload('ds.store.operatingSbin');
    dsload('ds.store.operatingDictN');
    dsload('ds.store.operatingSpry');
    dsload('ds.store.operatingIMDB');
    dsload('ds.store.operatingLoc');
    dsload('ds.store.operatingInfo');
    dsload('ds.store.operatingRespmaponthefly');
    dsload('ds.store.operatingHogScaleArr');
    dsload('ds.store.operatingScaledSize');
    dsload('ds.store.operatingScales');
    dsload('ds.store.operatingOptions');
end;
bboxIdx=ds.mapstore.operatingGetMapValIdx(dsidx);
if dsmapredisopen
    dsload(sprintf('ds.store.operatingHogLayer{%g}',bboxIdx));
end

startTime=tic;
bboxes=ds.store.operatingBboxes;
mapDir=ds.store.operatingMapDir;
w=ds.store.operatingW;
detector=ds.store.operatingDetector;
sbin=ds.store.operatingSbin;
dictN=ds.store.operatingDictN;
spry=ds.store.operatingSpry;
IMDB=ds.store.operatingIMDB;
loc=ds.store.operatingLoc;
info=ds.store.operatingInfo;
universalScales=ds.store.operatingScales;
universalScaledSize=ds.store.operatingScaledSize;
options=ds.store.operatingOptions;

if ~isempty(loc)
    layer=loc(bboxIdx,5);
else
    layer=1;
end
imgIdx=bboxes(bboxIdx,5);
I=readImIMDB(imgIdx,IMDB);

% get val for atom map
if isfield(options,'atom')&&~isempty(options.atom)&&options.atom
    %bbox=bboxes(dsidx,:);
    
    [integratedMap]=loadCodeMap(mapDir,getIMDBProperty(imgIdx,IMDB,'origImgIdx'),sbin);
    [integratedMap]=integrateMap(integratedMap,I,true);
    integratedMap=integratedMap{layer};
    
    [HSize]=size(integratedMap,1);
    [WSize]=size(integratedMap,2);
    hmp=max(1-loc(bboxIdx,2),0);
    wmp=max(1-loc(bboxIdx,1),0);
    hpp=max(loc(bboxIdx,4)-HSize,0);
    wpp=max(loc(bboxIdx,3)-WSize,0);
    if hmp>0||wmp>0||hpp>0||wpp>0
        paddedIntegratedMap=padarray(integratedMap,[hmp wmp],0,'pre');
        paddedIntegratedMap=padarray(paddedIntegratedMap,[hpp wpp],0,'post');
        shiftedBbox=[loc(bboxIdx,1)+wmp loc(bboxIdx,2)+hmp loc(bboxIdx,3)+wmp loc(bboxIdx,4)+hmp];
    else
        paddedIntegratedMap=integratedMap;
        shiftedBbox=loc(bboxIdx,:);
    end
    atomMap=paddedIntegratedMap(shiftedBbox(2):shiftedBbox(4),shiftedBbox(1):shiftedBbox(3),:);
    atomMap=colorizeAtomMap(atomMap,layer,[],w,sbin,dictN,spry);
    ds.res.atomRange{dsidx}=vec(atomMap);
else
    ds.res.atomRange{dsidx}=0;
end

% get val for resp map
if isfield(options,'resp')&&~isempty(options.resp)&&options.resp
    hogLayer=ds.store.operatingHogLayer{bboxIdx};
    hogScaleArr=ds.store.operatingHogScaleArr;
    respmaponthefly=ds.store.operatingRespmaponthefly;
    % determine whether to compute the response map on the fly
    respmaponthefly=respmaponthefly || ~isstruct(hogLayer) || sum(vec(isnan(hogScaleArr)))>0;

    if respmaponthefly
        hogScale=universalScales(layer);
        [pedroHog]=pedroHogFixedScales(I,hogScale);
    else
        hogScale=hogScaleArr(bboxIdx,1);
        pedroHog=hogLayer.layer(hogScale==hogLayer.scale);
    end
    if (isstruct(info{bboxIdx}))
        respMap=createRespMap(pedroHog,layer,hogScale,info{bboxIdx},detector,sbin,universalScaledSize,respmaponthefly);
        ds.res.respRange{dsidx}=vec(respMap);
    end
else
    ds.res.respRange{dsidx}=0;
end
timeSpent=toc(startTime);
fprintf('getRanker: getting value from %g th image pair, time:%g\n',bboxIdx,timeSpent);












