function [wFinal detector feat pyrFeat loc bboxes accRes precomp]=getRanker(constraints,bboxes,detTrainIdx,valConstraints,...
    valBboxes,IMDB,map,sbin,scaledSize,scales,integralDir,atomMapDir,imgCodeDir,neg_set,avoidBboxes,tmpLRADetModelDir,...
    printDirPattern,iter,options,precomp)

% input: bboxes -- N*5 matrix, [x1 y1 x2 y2 imgIdx] correspond to each
% columns, respectively
global ds;

if ~exist('precomp','var')
    precomp=[];
end
if isempty(detTrainIdx)
    detTrainIdx=bboxes(:,5);
end

if ~exist('options','var') || isempty(options)
    options.trainDetector=true;
    options.trainRanker=true;
    options.display=true;
    options.mineHard=false;
    options.flexiblePyrLevel=false;
end

if ~isfield(options,'trainDetector')
    options.trainDetector=true;
end

if ~isfield(options,'trainRanker')
    options.trainRanker=true;
end

if ~isfield(options,'display')
    options.display=true;
end

if ~isfield(options,'mineHard')
    options.mineHard=false;
end

if ~isfield(options,'isJointFeat')
    options.isJointFeat=false;
end

if ~isfield(options,'saveDisplayInfo')
    options.saveDisplayInfo=false;
end

if ~isfield(options,'deepRank')
    options.deepRank=false;
end

if ~isfield(options,'withIMDB')
    options.withIMDB=true;
end

% options.imgCodeDir=imgCodeDir;
% options.spry=ds.store.spry;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
spry=ds.store.spry;
[bboxes feat pyrFeat hogFeat contextFeat loc info]=computeFeat(bboxes,scaledSize,scales,spry,IMDB,imgCodeDir,options);
constraints=verifyConstraints(constraints,bboxes);

% if options.flexiblePyrLevel
%     testScales=info{1}.enhancedScales;
%     testScaledSize=info{1}.enhancedScaledSize;
% else
%     testScales=scales;
%     testScaledSize=scaledSize;
% end

% TODO: change me back, have more layers?
% testScales=sort(unique([scales scales/(1+2*options.contextExtRate)]),'descend');
testScales=scales;
% TODO: should we enforce this?
trainScales=scales;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

involvingImgIdx=unique(vec(constraints(:,1:2)));
[ignore involvingBboxesIdx]=ismember(involvingImgIdx,bboxes(:,5));
if sum(involvingBboxesIdx==0)>0
    error('There are images in the constraints that are not provided with bounding boxes');
end

[ignore localIdx]=ismember(vec(constraints(:,1:2)),involvingImgIdx);% transform image index into local index
localConstraints=constraints;
localConstraints(:,1:2)=reshape(localIdx,[size(constraints,1) 2]);

% form the constraint structure for learning
imgN=length(involvingImgIdx);

inequality=localConstraints(localConstraints(:,4)<3,:);
O=zeros(size(inequality,1),imgN);
isFirstWin=inequality(:,4)==1;
strongIdx=zeros(size(inequality,1),1);
strongIdx(isFirstWin)=inequality(isFirstWin,1);
strongIdx(~isFirstWin)=inequality(~isFirstWin,2);
strongIdx=sub2ind(size(O), (1:size(inequality,1))', strongIdx);
weakIdx=zeros(size(inequality,1),1);
weakIdx(isFirstWin)=inequality(isFirstWin,2);
weakIdx(~isFirstWin)=inequality(~isFirstWin,1);
weakIdx=sub2ind(size(O), (1:size(inequality,1))', weakIdx);
O(strongIdx)=1;
O(weakIdx)=-1;
coSeq=inequality(:,5).*inequality(:,6);
isTrain=inequality(:,7);

equality=localConstraints(localConstraints(:,4)==3,:);
S=zeros(size(equality,1),imgN);
strongIdx=equality(:,1);
weakIdx=equality(:,2);
strongIdx=sub2ind(size(S), (1:size(equality,1))', strongIdx);
weakIdx=sub2ind(size(S), (1:size(equality,1))', weakIdx);
S(strongIdx)=1;
S(weakIdx)=-1;
csSeq=equality(:,5).*equality(:,6);


% O=[];
% S=[];
% coSeq=[];
% csSeq=[];
% isTrain=[];
% for j = 1:size(constraints,1)
%     if constraints(j,4)<3
%         % inequality
%         entry=zeros(1,imgN);
%         entry(constraints(j,1))=1;
%         entry(constraints(j,2))=-1;
%         if constraints(j,4)==2
%             % second win
%             entry=-entry;
%         end
%         O=[O;entry];
%         isTrain=[isTrain;constraints(j,7)];
%         coSeq=[coSeq;constraints(j,5)*constraints(j,6)];
%     else
%         % equality
%         entry=zeros(1,imgN);
%         entry(constraints(j,1))=1;
%         entry(constraints(j,2))=-1;
%         S=[S;entry];
%         csSeq=[csSeq;constraints(j,5)*constraints(j,6)];
%     end
%     fprintf('scan %g/%g constraint\n',j,size(constraints,1));
% end

O=sparse(O);
S=sparse(S);
isTrain=logical(isTrain);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if isfield(precomp,'detector')
    detector=precomp.detector;
    m=[];
    models=[];
    m.models_name='LRA_detector_model';
    m.objectid=1;
    m.model.w=detector.w;
    m.model.b=detector.b;
    if isfield(detector,'contextw')
        m.model.contextw=detector.contextw;
    end
    m.model.hg_size=size(m.model.w);
    m.model.init_params.sbin=sbin;
    models{1}=m;
else
    [ignore detTrainLocalIdx]=ismember(detTrainIdx,bboxes(:,5));
    detTrainLocalIdx(detTrainLocalIdx==0)=[];
    if ~isempty(detTrainLocalIdx) && options.trainDetector
        hogFeatDim=cellfun(@(x)numel(x),hogFeat(detTrainLocalIdx));
        uHogFeatDim=unique(hogFeatDim);
        dimCount=zeros(length(uHogFeatDim),1);
        for kk=1:length(uHogFeatDim)
            dimCount(kk)=sum(uHogFeatDim(kk)==hogFeatDim);
        end
        [maxDimVal maxDimIdx]=max(dimCount);
        detTrainLocalIdx=detTrainLocalIdx(uHogFeatDim(maxDimIdx)==hogFeatDim);
        if ~isempty(contextFeat)
            options.contextFeat=contextFeat(:,detTrainLocalIdx);
        else
            options.contextFeat=[];
        end
        [detector models]=trainDetector(hogFeat(detTrainLocalIdx),neg_set,avoidBboxes,trainScales,options);
    else
        hogFeatSum=zeros(size(hogFeat{1}));
        for kk=1:length(hogFeat)
            hogFeatSum=hogFeatSum+hogFeat{1};
        end
        hogFeatSum=hogFeatSum/length(hogFeat);
        detector.w=hogFeatSum;
        detector.b=0;
        clear hogFeatSum;
        models=[];
    end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% apply detector on validation set to get bboxes (this is only useful when training the ranker)
if options.trainRanker
    if ~exist('precomp','var') || ~isfield(precomp,'valprecomp')
        dsupWrap('ds.store.operatingOptions',options);
        dsupWrap('ds.store.operatingScaledSize',scaledSize);
        dsupWrap('ds.store.operatingScales',scales);
        if isempty(valBboxes)
            valImgIdx=unique(vec(valConstraints(:,1:2)));
            valFilenames=getIMDBProperty(valImgIdx,IMDB,'batch_img_path');
            valSize=getIMDBProperty(valImgIdx,IMDB,'size');
            esvmParams=ds.store.esvmDefaultParams;
            esvmParams.dataset_params.localdir=tmpLRADetModelDir;
            esvmParams.detect_save_features=1;
            esvmParams.detect_min_scale=0.2;
            % TODO: do we need this?
            %esvmParams.detect_pyramid_padding=0;
            esvmParams.detect_keep_threshold=-inf;
            esvmParams.detect_add_flip=false;
            esvmParams.mineHard=true;
            esvmParams.specifiedScales=testScales;

            dsupWrap('ds.store.operatingIMDB',IMDB);
            dsupWrap('ds.store.operatingDetector',models);
            dsupWrap('ds.store.operatingImgSet',valImgIdx);
            dsupWrap('ds.store.operatingAvoidBboxes',0);
            dsupWrap('ds.store.operatingTopK',1);
            dsupWrap('ds.store.operatingDetectorParams',esvmParams);
            dsupWrap('ds.store.operatingNegOSThresh',0.3);
            dsupWrap('ds.store.operatingGetHogLayer',true);
            % if isfield(options,'isJointFeat') && options.isJointFeat
            %     dsupWrap('ds.store.operatingImgSetIdx',options.negSetImgIdx);
            % end

            if dsmapredisopen()
                NBatch=ceil(length(ds.store.operatingImgSet)/(length(ds.sys.distproc.availslaves)*1));
            else
                NBatch=20;
            end
            batchSeq=unSyncDistribute(length(ds.store.operatingImgSet),NBatch);
            dsupWrap('ds.store.operatingNBatch',NBatch);
            % dssaveAndWait;
            dsrundistributed('mineHardNeg(dsidx);',length(batchSeq));
            valBboxes=cat(1,ds.res.bboxes{:});
            valHogFeat=cat(1,ds.res.feat{:});
            valHogLayer=cat(1,ds.res.hogLayer{:})';
            valAdditionalInfo=cat(1,ds.res.additionalInfo{:});
            keepidx=cellfun(@(x)isnumeric(x),valBboxes);
            valImgIdx=valImgIdx(keepidx);
            valBboxes=valBboxes(keepidx);
            valHogFeat=valHogFeat(keepidx);
            valAdditionalInfo=valAdditionalInfo(keepidx);
            valHogLayer=valHogLayer(keepidx);
            valBboxes=cat(1,valBboxes{:});
            valScales=valBboxes(:,8:10);
            customedSize=round(bsxfun(@times,[valBboxes(:,4)-valBboxes(:,2) valBboxes(:,3)-valBboxes(:,1)],valBboxes(:,8)));
            valBboxes=[valBboxes(:,1:4) valImgIdx customedSize];
            valSize=valSize(keepidx,:);
            
            % TODO: do we need to clip?
            %valBboxes(:,1:4)=clip_to_image_group(round(valBboxes(:,1:4)),valSize);
            valBboxes(:,1:4)=round(valBboxes(:,1:4));
            
            valHogFeat=cat(2,valHogFeat{:});
            if isfield(options,'isJointFeat') && options.isJointFeat
                valHogFeatResp=[detector.w(:);detector.contextw]'*valHogFeat-detector.b;
            else
                valHogFeatResp=detector.w(:)'*valHogFeat-detector.b;
            end
            dsdelete('ds.res');
            dsdelete('ds.store.operatingIMDB');
            dsdelete('ds.store.operatingDetector');
            dsdelete('ds.store.operatingImgSet');
            dsdelete('ds.store.operatingAvoidBboxes');
            dsdelete('ds.store.operatingTopK');
            dsdelete('ds.store.operatingDetectorParams');
            dsdelete('ds.store.operatingNegOSThresh');
            dsdelete('ds.store.operatingNBatch');
            dsdelete('ds.store.operatingGetHogLayer');
            % if isfield(options,'isJointFeat') && options.isJointFeat
            %     dsdelete('ds.store.operatingImgSetIdx');
            % end
        else
            valHogFeatResp=nan(1,size(valBboxes,1));
            valScales=nan(size(valBboxes,1),3);
            valHogLayer=repmat({'nan'},[1 size(valBboxes,1)]);
        end
        
        %assert(size(valBboxes,1)==length(valImgIdx));
        assert(sum(~ismember(vec(valConstraints(:,1:2)),valBboxes(:,5)))==0);
        % get LLC codes from the bboxes
        dsupWrap('ds.store.operatingBboxes',valBboxes);
        dsupWrap('ds.store.operatingDir',imgCodeDir);
        dsupWrap('ds.store.operatingDir',imgCodeDir);
        dsupWrap('ds.store.operatingSpry',spry);
        dsupWrap('ds.store.operatingIMDB',IMDB);
        NBatch=6;
        % if dsmapredisopen()
        %     NBatch=ceil(size(ds.store.operatingBboxes,1)/(length(ds.sys.distproc.availslaves)*1));
        % else
        %     NBatch=20;
        % end
        batchSeq=unSyncDistribute(size(ds.store.operatingBboxes,1),NBatch);
        dsupWrap('ds.store.operatingNBatch',NBatch);
        % dssaveAndWait;
        dsrundistributed('computeFeatFromBbox(dsidx);',length(batchSeq));

        % TODO: change me back to ds.res.feat{:}
        valFeat=cat(1,ds.res.pyrFeat{:});

        valPyrFeat=cat(1,ds.res.pyrFeat{:});
        valLoc=cat(1,ds.res.loc{:});
        valInfo=cat(1,ds.res.info{:});
        % valHogFeat=cat(1,ds.res.hogFeat{:});
        dsdelete('ds.store.operatingIMDB');
        dsdelete('ds.store.operatingSpry');
        dsdelete('ds.store.operatingBboxes');
        dsdelete('ds.store.operatingDir');
        dsdelete('ds.store.operatingNBatch');
        dsdelete('ds.store.operatingOptions');
        dsdelete('ds.store.operatingScaledSize');
        dsdelete('ds.store.operatingScales');
        dsdelete('ds.res');
        % dssaveAndWait;
        valFeat=cat(2,valFeat{:});
        valPyrFeat=cat(2,valPyrFeat{:});
        valLoc=cat(1,valLoc{:});

        pruneIdx=find(sum(isnan(valFeat),1)>0);
        constrPruneIdx=sum(reshape(ismember(vec(valConstraints(:,1:2)),valBboxes(pruneIdx,5)),[size(valConstraints,1) 2]),2)>0;
        valFeat(:,pruneIdx)=[];
        valBboxes(pruneIdx,:)=[];
        valScales(pruneIdx,:)=[];
        valPyrFeat(:,pruneIdx)=[];
        valHogLayer(pruneIdx)=[];
        valHogFeatResp(pruneIdx)=[];
        % valHogFeat(pruneIdx)=[];
        valLoc(pruneIdx,:)=[];
        valInfo(pruneIdx)=[];
        valConstraints(constrPruneIdx,:)=[];

        precomp.valprecomp.valFeat=valFeat;
        precomp.valprecomp.valPyrFeat=valPyrFeat;
        precomp.valprecomp.valBboxes=valBboxes;
        precomp.valprecomp.valScales=valScales;
        precomp.valprecomp.valHogLayer=valHogLayer;
        precomp.valprecomp.valHogFeatResp=valHogFeatResp;
        precomp.valprecomp.valLoc=valLoc;
        precomp.valprecomp.valInfo=valInfo;
    else
        valFeat=precomp.valprecomp.valFeat;
        valPyrFeat=precomp.valprecomp.valPyrFeat;
        valBboxes=precomp.valprecomp.valBboxes;
        valScales=precomp.valprecomp.valScales;
        valHogLayer=precomp.valprecomp.valHogLayer;
        valHogFeatResp=precomp.valprecomp.valHogFeatResp;
        valLoc=precomp.valprecomp.valLoc;
        valInfo=precomp.valprecomp.valInfo;
    end
    

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % learn ranker 
    % do cross-validation to determine C_O and C_S
    if ~isempty(valBboxes)&&~isempty(valConstraints)
        cArray=10.^(-2:1:4);
        acc=zeros(length(cArray),1);
        for i = 1:length(cArray)
            w=ranksvm_with_sim_fanyi(feat(:,involvingBboxesIdx)',O,S,cArray(i)*coSeq,cArray(i)*csSeq);
            acc(i)=judgeStandard(w,valBboxes,valFeat,valConstraints);
            %r=w'*feat(:,involvingBboxesIdx);
            %acc(i)=judgeSparse(r,O(~isTrain,:));
            fprintf('cross val -- c=%g\n',cArray(i));
        end
        [cvAcc maxIdx]=max(acc);
        C=cArray(maxIdx);
        fprintf('cross val -- best c=%g, cv acc=%g\n',C,cvAcc);
    else
        C=100;
        cvAcc=nan;
    end
    wFinal=ranksvm_with_sim_fanyi(feat(:,involvingBboxesIdx)',O,S,C*coSeq,C*csSeq);
    r=wFinal'*feat(:,involvingBboxesIdx);
    trAcc=judgeSparse(r,O);
else
    wFinal=[];
    C=nan;
    cvAcc=nan;
    trAcc=nan;
    valHogLayer=[];
end
accRes=[];
accRes.cvAcc=cvAcc;
accRes.trAcc=trAcc;
accRes.C=C;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% generate visualization
% if size(bboxes,2)==7
%     bboxes(:,8)=ones(size(bboxes,1),1);
% end
% dictN=size(ds.store.dict,1)+3;% +3 for RGB value concatenation
dictN=size(ds.store.dict,1);
if ~isempty(printDirPattern)&&(options.display||options.saveDisplayInfo)
    dispConstraints=constraints;
    dispBboxes=bboxes;
    dispLoc=loc;
    dispFeat=feat;
    dispInfo=info;
    dispHogFeat=cellfun(@(x)vec(x),hogFeat,'uniformoutput',false);
    dispHogDim=cellfun(@(x)numel(x),dispHogFeat);
    if length(unique(dispHogDim))==1
        dispHogFeat=cat(2,dispHogFeat{:});
        dispHogResp=detector.w(:)'*dispHogFeat-detector.b;
    else
        dispHogResp=nan(1,length(dispHogFeat));
    end
    
    if ~isempty(wFinal)&&~isempty(dispFeat)
        dispFeatRankingScore=wFinal'*dispFeat;
    else
        dispFeatRankingScore=[];
    end
    
    if ~isempty(wFinal)&&~isempty(valFeat)
        valFeatRankingScore=wFinal'*valFeat;
    else
        valFeatRankingScore=[];
    end
    
    if options.trainRanker
        dispOptions=struct('resp',true,'atom',true);
    else
        dispOptions=struct('resp',true,'atom',false);
    end
    
    
    if options.display
        picPrintDir=fullfile(sprintf(printDirPattern,iter),'trainval');
        %dispOptions.contextExtRate=options.contextExtRate;
        printImg(dispBboxes,repmat({'nan'},[1 size(dispBboxes,1)]),nan(size(dispBboxes,1),3),dispLoc,dispInfo,scales,scaledSize,wFinal,detector,map,sbin,dictN,spry,IMDB,imgCodeDir,picPrintDir,true,dispOptions,precomp);
        printPage(dispBboxes,dispConstraints,dispFeatRankingScore,dispHogResp,trAcc,cvAcc,C,'ranking.html','trainval',printDirPattern,iter,true);

        if options.trainRanker
            picPrintDir=fullfile(sprintf(printDirPattern,iter),'heldout');
            %dispOptions.valAdditionalInfo=valAdditionalInfo;
            printImg(valBboxes,valHogLayer,valScales,valLoc,valInfo,scales,scaledSize,wFinal,detector,map,sbin,dictN,spry,IMDB,imgCodeDir,picPrintDir,false,dispOptions,precomp);
            printPage(valBboxes,valConstraints,valFeatRankingScore,valHogFeatResp,trAcc,cvAcc,C,'heldout.html','heldout',printDirPattern,iter,true);
        end
    end
    
    if options.saveDisplayInfo
        precomp.display.isVal=options.trainRanker;
        
        precomp.display.train.bboxes=dispBboxes;
        precomp.display.train.loc=dispLoc;
        precomp.display.train.info=dispInfo;
        precomp.display.train.picPrintDir=fullfile(sprintf(printDirPattern,iter),'trainval');
        precomp.display.train.constraints=dispConstraints;
        precomp.display.train.featRankingScore=dispFeatRankingScore;
        precomp.display.train.hogResp=dispHogResp;
        
        if precomp.display.isVal
            precomp.display.val.bboxes=valBboxes;
            precomp.display.val.loc=valLoc;
            precomp.display.val.info=valInfo;
            precomp.display.val.picPrintDir=fullfile(sprintf(printDirPattern,iter),'heldout');
            precomp.display.val.hogLayer=valHogLayer;
            precomp.display.val.scales=valScales;
            precomp.display.val.constraints=valConstraints;
            precomp.display.val.featRankingScore=valFeatRankingScore;
            precomp.display.val.hogResp=valHogFeatResp;
        end
        
        precomp.display.trAcc=trAcc;
        precomp.display.cvAcc=cvAcc;
        precomp.display.C=C;
        precomp.display.printDirPattern=printDirPattern;
        precomp.display.iter=iter;
        
        precomp.display.scales=scales;
        precomp.display.scaledSize=scaledSize;
        precomp.display.wFinal=wFinal;
        precomp.display.detector=detector;
        precomp.display.map=map;
        precomp.display.sbin=sbin;
        precomp.display.dictN=dictN;
        precomp.display.spry=spry;
        precomp.display.IMDB=IMDB;
        precomp.display.imgCodeDir=imgCodeDir;
        precomp.display.options=dispOptions;
    end
end








