% sample mean and cov for hog
bgStatFilename=fullfile(ds.store.expDir,'bg.mat');

% get a set of whitening parameters
if ~dsfield(ds,'store','whitenMu') || ~dsfield(ds,'store','whitenRT')
    regConst=0.01;
    whitenMatFilename=fullfile(ds.store.expDir,'whiten_60.mat');
    if ~exist(whitenMatFilename,'file')
        load(bgStatFilename);
        whitenMu=cell(length(ds.store.templateH),1);
        whitenRT=cell(length(ds.store.templateH),1);
        
        for i = 1:length(ds.store.templateH)
            fprintf('start computing whitening data for [%g %g] window size\n',ds.store.templateH(i),ds.store.templateW(i));
            hgt=length(1:ds.store.hogStepSize:ds.store.templateH(i));
            wid=length(1:ds.store.hogStepSize:ds.store.templateW(i));
            [R,mu]=whiten(bg,wid,hgt);
            %[U D V]=svd(cov);
            %d=(diag(D)).^(-1/2);
            whitenMu{i}=single(mu);
            whitenRT{i}=single(R');
            fprintf('whitening data for [%g %g] window size computed\n',ds.store.templateH(i),ds.store.templateW(i));
        end
        mySaveFile(whitenMatFilename,whitenMu,whitenRT);
    else
        load(whitenMatFilename);
    end
    ds.store.whitenMu=whitenMu;
    ds.store.whitenRT=whitenRT;
end


