function mineHardNeg(dsidx)
global ds;
touch;

if ~dsfield(ds,'store')
    fprintf('reload ds.store\n');
    dsload('ds.store.operatingImgSet');
    dsload('ds.store.operatingDetectorParams');
    dsload('ds.store.operatingDetector');
    dsload('ds.store.operatingAvoidBboxes');
    dsload('ds.store.operatingNegOSThresh');
    dsload('ds.store.operatingTopK');
    dsload('ds.store.operatingNBatch');
    dsload('ds.store.operatingGetHogLayer');
    dsload('ds.store.operatingOptions');
    if isfield(ds.store.operatingOptions,'withIMDB') && ds.store.operatingOptions.withIMDB
        dsload('ds.store.operatingIMDB');
    end
    % if isfield(ds.store.operatingOptions,'isJointFeat') && ds.store.operatingOptions.isJointFeat
    %     dsload('ds.store.operatingImgSetIdx');
    % end
end
startTime=tic;
sbin=8;
isGetHog=ds.store.operatingGetHogLayer;
imgSet=ds.store.operatingImgSet;
operatingIdxSeq=unSyncMapper(dsidx,length(imgSet),ds.store.operatingNBatch);
params=ds.store.operatingDetectorParams;
detectors=ds.store.operatingDetector;
avoidBboxes=ds.store.operatingAvoidBboxes;
negOSThresh=ds.store.operatingNegOSThresh;
topK=ds.store.operatingTopK;
fprintf('topK=%g\n',topK);
% fprintf('Iter tag for model:%g\n',detectors{1}.itertag);
options=ds.store.operatingOptions;
% if isfield(options,'isJointFeat') && options.isJointFeat
%     operatingImgSetIdx=ds.store.operatingImgSetIdx;
% end
if isfield(params,'specifiedScales') && ~isempty(params.specifiedScales)
    specifiedScales=params.specifiedScales;
else
    specifiedScales=[];
end

if isfield(ds.store,'operatingIMDB')
    IMDB=ds.store.operatingIMDB;
else
    IMDB=[];
end

resBboxes=cell(length(operatingIdxSeq),1);
resFeat=cell(length(operatingIdxSeq),1);
hogLayer=cell(length(operatingIdxSeq),1);
resAdditionalInfo=cell(length(operatingIdxSeq),1);
for k = 1:length(operatingIdxSeq)
    operatingIdx=operatingIdxSeq(k);
    if ~isempty(IMDB)
        I=readImIMDB(imgSet(operatingIdx),IMDB);
        [ignore imgName]=fileparts(getIMDBProperty(imgSet(operatingIdx),IMDB,'single_img_path'));
    else
        I=readImIMDB(imgSet{operatingIdx});
        [ignore imgName]=fileparts(imgSet{operatingIdx});
    end
    
    detectParams=params;
    if ~isempty(specifiedScales)
        [feat]=pedroHogFixedScales(I,specifiedScales,sbin);
        t=[];
        t.padder=params.detect_pyramid_padding;
        for level = 1:length(feat)
            feat{level} = padarray(feat{level}, [t.padder t.padder 0], 0);
        end
        t.hog=feat;
        t.size=size(I);
        t.scales=specifiedScales;
        usedScales=specifiedScales;
    else
        t=get_pyramid(I,sbin,params);
        usedScales=t.scales;
    end
    detectParams.precomputation.orig=t;
    
    if isfield(options,'isJointFeat') && options.isJointFeat
        % add pooling feature
        %imgIdx=operatingImgSetIdx(operatingIdx);
        % [map scaledSize scales]=loadCodeMap(options.imgCodeDir,imgIdx,[]);
        % detectParams.poolFeat.map=map;
        % detectParams.poolFeat.scaledSize=scaledSize;
        % detectParams.poolFeat.scales=scales;
        
        detectParams.contextExtRate=options.contextExtRate;
        %detectParams.spry=options.spry;
        % compute hog on reduced scales
        [contexHOGFeat]=pedroHogFixedScales(I,usedScales/(1+2*detectParams.contextExtRate),sbin);
        contexHOG=[];
        contexHOG.padder=params.detect_pyramid_padding;
        for level = 1:length(contexHOGFeat)
            contexHOGFeat{level} = padarray(contexHOGFeat{level}, [contexHOG.padder contexHOG.padder 0], 0);
        end
        contexHOG.hog=contexHOGFeat;
        contexHOG.size=size(I);
        contexHOG.scales=usedScales/(1+2*detectParams.contextExtRate);
        detectParams.contexHOG=contexHOG;
        [rs t]=esvm_detect_doubleHOGFeat(I,detectors,detectParams);
    else
        [rs t]=esvm_detect(I,detectors,detectParams);
    end
    
    
    if isempty(rs.bbs{1})
        % no FP detection
        resBboxes{k}='nan';
        resFeat{k}='nan';
        hogLayer{k}='nan';
        resAdditionalInfo{k}='nan';
        continue;
    end

    bboxes=rs.bbs{1};
    feat=rs.xs{1};
    feat=cat(2,feat{:});
    if isfield(options,'isJointFeat') && options.isJointFeat
        additionalInfo=rs.additionalInfo;
    else
        additionalInfo=[];
    end

    if iscell(avoidBboxes)
        if length(avoidBboxes)~=length(imgSet)
            error('length(avoidBboxes)~=length(imgSet)');
        end
        % prune out avoid bboxes
        if isfield(options,'isJointFeat') && options.isJointFeat
            os=getosmatrix_bb(directEnlargeBboxes(bboxes,options.contextExtRate),directEnlargeBboxes(avoidBboxes{operatingIdx},options.contextExtRate));
        else
            os=getosmatrix_bb(bboxes,avoidBboxes{operatingIdx});
        end
        [maxos maxosidx]=max(os,[],2);
        
        % % DEBUG code
        % dispBboxes=directEnlargeBboxes(bboxes,options.contextExtRate);
        % dispAvoidBboxes=directEnlargeBboxes(avoidBboxes{operatingIdx},options.contextExtRate);
        % for p = 1:size(dispAvoidBboxes,1)
        %     [sortval sortidx]=sort(os(:,p),'descend');
        %     for q=1:length(sortidx)
        %         plotI=I;
        %         plotI=plot_bb(plotI,dispAvoidBboxes(p,:),'r');
        %         plotI=plot_bb(plotI,dispBboxes(sortidx(q),:),'b');
        %         imshow(plotI);
        %         title(sprintf('os:%g',sortval(q)));
        %         pause;
        %     end
        % end
        
        pruneIdx=maxos>negOSThresh;
        bboxes(pruneIdx,:)=[];
        feat(:,pruneIdx)=[];
        maxos(pruneIdx)=[];
        
        % % debug code
        % plotI=I;
        % for kk=1:size(avoidBboxes{operatingIdx},1)
        %     plotI=plot_bb(plotI,avoidBboxes{operatingIdx}(kk,:),'r');
        % end
        % dispBboxes=bboxes;
        % [sortval sortidx]=sort(dispBboxes(:,end),'descend');
        % dispBboxes=dispBboxes(sortidx,:);
        % dispOS=maxos(sortidx);
        % dispK=min(10,size(dispBboxes,1));
        % for kk=1:dispK
        %     imshow(plot_bb(plotI,dispBboxes(kk,1:4),'b'));
        %     title(sprintf('%g/%g -- score:%g, ov:%g',kk,dispK,dispBboxes(kk,end),dispOS(kk)));
        %     pause;
        % end
    end

    if isempty(bboxes)
        % no FP detection
        resBboxes{k}='nan';
        resFeat{k}='nan';
        hogLayer{k}='nan';
        resAdditionalInfo{k}='nan';
        continue;
    end


    %switch between "hard" neg mining and "random" neg harvasting
    if isfield(params,'mineHard') && ~params.mineHard 
        sortIdx=randperm(size(bboxes,1));
    else
        [sortVal sortIdx]=sort(bboxes(:,12),'descend');
    end
    
    bboxes=bboxes(sortIdx(1:min(topK,length(sortIdx))),:);
    feat=feat(:,sortIdx(1:min(topK,length(sortIdx))));
    
    % a piece of debug code
    % imshow(plot_bb(I,bboxes(1,:),'r'));
    % fprintf('[x:%g y:%g scale:%g]\n',bboxes(1,9),bboxes(1,10),bboxes(1,8));
    
    
    % get hog layer
    origScalesRule=t(1).scales;
    origScales=bboxes(bboxes(:,7)==0,8);
    [ignore origIdx]=ismember(origScales,origScalesRule);
    origIdx=unique(origIdx);
    hogLayer{k}.layer=t(1).hog(origIdx);
    hogLayer{k}.scale=t(1).scales(origIdx);
    
    % if length(t)>1
    %     flipScalesRule=t(2).scales;
    %     flipScales=bboxes(bboxes(:,7)==1,8);
    %     [ignore flipIdx]=ismember(flipScales,flipScalesRule);
    %     flipIdx=unique(flipIdx);
    % end
    
    resAdditionalInfo{k}=additionalInfo;
    resBboxes{k}=bboxes;
    resFeat{k}=feat;
    timeSpent=toc(startTime);
    fprintf('detection on img %s is done (%g samples),maxval=%g,minVal=%g,time=%g\n',imgName,size(bboxes,1),max(bboxes(:,12)),min(bboxes(:,12)),timeSpent);
end
ds.res.bboxes{dsidx}=resBboxes;
ds.res.feat{dsidx}=resFeat;
ds.res.additionalInfo{dsidx}=resAdditionalInfo;
if isGetHog
    ds.res.hogLayer{dsidx}=hogLayer;
end
