function morphing(ensembleTable,attrName,rootPrintDir,IMDB,scaledSize,scales,bufferDir,spry,imgCodeDir,dataset_name)
% let's do some morphing 
sbin=8;
[sortval sortidx]=sort(ensembleTable(:,4),'descend');
ensembleTable=ensembleTable(sortidx,:);

% only do morphing for the highest ranked chain
ensembleTable=ensembleTable(1,:);


switch dataset_name
    case 'utzap50k'
        doSide=true;
    case 'shoes'
        doSide=true;
    case 'LFW10'
        doSide=false;
    case 'devi'
        doSide=false;
    otherwise
        error('unknown dataset');
end

imgDir=fullfile(rootPrintDir,'morphing',sprintf('%s',attrName),'img');
htmlDir=fullfile(rootPrintDir,'morphing',sprintf('%s',attrName));

for kk=1:size(ensembleTable,1)
    rootIdx=ensembleTable(kk,1);
    pertIdx=ensembleTable(kk,2);

    % load concept
    hypoFilename=fullfile(bufferDir,sprintf('hypoDetectors_%s_%g.mat',attrName,rootIdx));
    hypoConcepts=load(hypoFilename);
    hypoConcepts=hypoConcepts.hypoConcepts;
    pertConcepts=hypoConcepts.perturbations{pertIdx};
    morphingFilename=fullfile(bufferDir,sprintf('morphing_%s.mat',attrName));
    
    
    % search for the nearest neighbors w.r.t. color histograms
    % compute feat and rank
    if ~exist(morphingFilename,'file')
        [chainBboxes chainFeat]=computeFeat(pertConcepts.hypoBboxes,scaledSize,scales,spry,IMDB,imgCodeDir);    
        rankerScore=pertConcepts.wFinal'*chainFeat;
        [rankerScore sortidx]=sort(rankerScore,'descend');
        chainBboxes=chainBboxes(sortidx,:);
        chainFeat=chainFeat(:,sortidx);
        mySaveFile(morphingFilename,chainBboxes,chainFeat,rankerScore);
    else
        load(morphingFilename);
    end
    
    
    % load image
    patch=cell(size(chainBboxes,1),1);
    colorFeat=cell(size(chainBboxes,1),1);
    for qq=1:size(chainBboxes,1)
        entry=chainBboxes(qq,:);
        imgIdx=entry(5);
        entry(1:4)=clip_to_image(round(entry(1:4)),[1 1 IMDB(imgIdx).size(2) IMDB(imgIdx).size(1)]);
        I=readImIMDB(imgIdx,IMDB);
        patch{qq}=I(entry(2):entry(4),entry(1):entry(3),:);
        patch{qq}=imresize(patch{qq},[entry(6) entry(7)]);
        
        % compute feature
        pixels=reshape(patch{qq},[],3);
        diff=sum(abs(bsxfun(@minus,pixels,[1 1 1])),2);
        epsilon=1e-6;
        whiteIdx=diff<epsilon;
        pixels(whiteIdx,:)=[];
        meanPixel=mean(pixels,1);
        stdPixel=sqrt(mean(bsxfun(@minus,pixels,meanPixel).^2,1));
        colorFeat{qq}=[vec([meanPixel stdPixel]);vec(patch{qq}(:,1,:));vec(patch{qq}(1,:,:));vec(patch{qq}(:,end,:));vec(patch{qq}(end,:,:))];
        
        %patch{qq}=rgb2gray(patch{qq});
        fprintf('morphing: %g/%g patch cropped\n',qq,size(chainBboxes,1));
    end
    colorFeat=cat(2,colorFeat{:});
    
    patchImgIdx=chainBboxes(:,5);
    dist=pdist2(colorFeat',colorFeat');
    dispK=20;
    [dist distIdx]=sort(dist,1,'ascend');
    distIdx=reshape(patchImgIdx(vec(distIdx)),size(distIdx));
    dist=dist(1:dispK,:);
    distIdx=distIdx(1:dispK,:);

    % sampling
    %sampleIdx=myPermute(size(distIdx,2),50);
    avgDist=mean(dist,1);
    [sortval sortidx]=sort(avgDist,'ascend');
    candK=round(length(sortidx)/5);
    sortidx=sortidx(1:candK);
    sortidx=sortidx(myPermute(length(sortidx),50));
    sampleIdx=sortidx(1:min(50,length(sortidx)));
    
    dist=dist(:,sampleIdx);
    distIdx=distIdx(:,sampleIdx);
    dispChainBboxes=chainBboxes(sampleIdx,:);
    [ignore localDistIdx]=ismember(vec(distIdx),patchImgIdx);
    localDistIdx=reshape(localDistIdx,size(distIdx));
    dispScore=reshape(rankerScore(vec(localDistIdx)),size(localDistIdx));
    [dispScore transIdx]=sort(dispScore,1,'descend');
    transIdx=bsxfun(@plus,transIdx,(0:size(transIdx,2)-1)*size(transIdx,1));
    dist=reshape(dist(transIdx),size(dist));
    distIdx=reshape(distIdx(transIdx),size(distIdx));
    
    
    montageDisp(dist,distIdx,dispScore,dispChainBboxes,chainBboxes,patch,doSide,patchImgIdx,IMDB,imgDir,htmlDir);
    
    
    
    % for qq=1:length(patch)
    %     imshow(patch{qq});
    %     title(sprintf('%g/%g\n',qq,length(patch)));
    %     pause(0.01);
    % end
    
    
    
    % patches=cellfun(@(x)vec(x),patch,'uniformoutput',false);
    % patches=cat(2,patches{:});
    % patchesMean=mean(patches,2);
    % patchesBa=bsxfun(@minus,patches,patchesMean);
    % [U D V]=svd(patchesBa);
    % % for qq=1:size(U,2)
    % %     imagesc(reshape(U(:,qq)+patchesMean,size(patch{1})));
    % %     title(sprintf('%g/%g',qq,size(U,2)));
    % %     pause;
    % % end
    % eigIdx=1000;
    % const=sqrt(D(eigIdx,eigIdx));
    % strength=[-1:0.01:1];
    % base=patch{1};
    % pc=reshape(U(:,eigIdx),size(patch{1}));
    % patchesMeanImg=reshape(patchesMean,[60 60]);
    % for qq=1:length(strength)
    %     imagesc(pc*strength(qq)*const+patchesMeanImg);
    %     colormap(gray);
    %     title(sprintf('%g',strength(qq)));
    %     pause(0.05);
    % end
    
    
    % feat=cell(size(pertConcepts.hypoBboxes,1),1);
    % for qq=1:size(pertConcepts.hypoBboxes,1)
    %     padded=padarray(patch{qq},[sbin sbin],'symmetric','both');
    %     feat{qq}=features_pedro(padded,sbin);
    %     fprintf('morphing: %g/%g patch feature computed\n',qq,size(pertConcepts.hypoBboxes,1));
    % end
    % featFlat=cellfun(@(x)vec(x),feat,'uniformoutput',false);
    % featFlat=cat(2,featFlat{:});
    % 
    % % PCA
    % [U D V]=svd(featFlat);
    
    % for qq=1:size(U,2)
    %     dispFeat=U(:,qq);
    %     dispFeatPos=max(dispFeat,0);
    %     dispFeatNeg=max(-dispFeat,0);
    %     dispFeatPos=reshape(dispFeatPos,[8 8 31]);
    %     dispFeatNeg=reshape(dispFeatNeg,[8 8 31]);
    %     subplot(1,2,1);
    %     imshow(HOGpicture(dispFeatPos));
    %     subplot(1,2,2);
    %     imshow(HOGpicture(dispFeatNeg));
    %     title(sprintf('%g/%g\n',qq,size(U,2)));
    %     pause;
    % end

    % for qq=1:length(feat)
    %     subplot(2,2,1);
    %     imshow(patch{qq});
    %     subplot(2,2,2);
    %     imshow(HOGpicture(feat{qq}));
    %     subplot(2,2,3);
    %     imshow(invertHOG(feat{qq}));
    % end        
end



function montageDisp(dist,distIdx,dispScore,chainBboxes,referenceChainBboxes,patch,doSide,patchImgIdx,IMDB,imgDir,htmlDir)
dispK=size(dist,1);
imgList=[];
imgStr=[];
startTime=tic;
for i=1:size(dist,2)
    imgIdx=chainBboxes(i,5);
    I=readImIMDB(imgIdx,IMDB);
    targetBbox=chainBboxes(i,1:4);
    targetBbox=clip_to_image(round(targetBbox),[1 1 IMDB(imgIdx).size(2) IMDB(imgIdx).size(1)]);
    boundedI=plot_bb(I,targetBbox,'r');
    targetImgFilename=fullfile(imgDir,sprintf('target_%g.jpg',imgIdx));
    if doSide
        side=autoSide(boundedI,targetBbox);
        boundedI=attentionCrop(boundedI,side);
    end
    myimwrite(boundedI,targetImgFilename);
    imgList{end+1}=relativepath(targetImgFilename,htmlDir);
    imgStr{end+1}=sprintf('target:%g',imgIdx);

    targetSize=[targetBbox(4)-targetBbox(2)+1 targetBbox(3)-targetBbox(1)+1];
    for j=1:length(distIdx(:,i))
        sourceImgIdx=distIdx(j,i);
        %sourcePatch=imresize(patch{sourceImgIdx==patchImgIdx},targetSize);
        sourceBbox=clip_to_image(round(referenceChainBboxes(referenceChainBboxes(:,5)==sourceImgIdx,1:4)),[1 1 IMDB(sourceImgIdx).size(2) IMDB(sourceImgIdx).size(1)]);
        sourcePatch=readImIMDB(sourceImgIdx,IMDB);
        sourcePatch=sourcePatch(sourceBbox(2):sourceBbox(4),sourceBbox(1):sourceBbox(3),:);
        sourcePatch=imresize(sourcePatch,targetSize);
        
        montageI=I;
        %montageI(targetBbox(2):targetBbox(4),targetBbox(1):targetBbox(3),:)=sourcePatch;
        montageI=poissonBlend(montageI,targetBbox,sourcePatch);
        
        montageI=plot_bb(montageI,targetBbox,'r');
        sourceImgFilename=fullfile(imgDir,sprintf('source_%g_%g.jpg',imgIdx,sourceImgIdx));
        if doSide
            side=autoSide(montageI,targetBbox);
            montageI=attentionCrop(montageI,side);
        end
        myimwrite(montageI,sourceImgFilename);
        imgList{end+1}=relativepath(sourceImgFilename,htmlDir);
        imgStr{end+1}=sprintf('souce:%g, target:%g,dist:%g,attr:%g',sourceImgIdx,imgIdx,dist(j,i),dispScore(j,i));
    end
    timeSpent=toc(startTime);
    fprintf('montageDisp: %g/%g image processed, ETA:%g\n',i,size(dist,2),timeSpent/i*(size(dist,2)-i));
end
htmlfilename=fullfile(htmlDir,'montage.html');
displayPatch(htmlfilename,imgList,imgStr,[],[],dispK+1,200,200);



function I=attentionCrop(I,side)
mid=round(size(I,2)/2);
if strcmp(side,'r')
    I=I(:,mid+1:end,:);
elseif strcmp(side,'l')
    I=I(:,1:mid,:);
else
    error('unknown side');
end


function side=autoSide(I,bbox)
imsize=size(I);
halfpoint=imsize(2)/2;
center=[(bbox(2)+bbox(4))/2 (bbox(1)+bbox(3))/2];
if center(2)>=halfpoint
    side='r';
else
    side='l';
end
    










