function [obj, grad, sv] = obj_fun_linear_fanyi(w,C,X,A,n0)
% Compute the objective function, its gradient and the set of support vectors
% Out is supposed to contain 1-A*X*w
out = [ones(n0,1);zeros(size(A,1)-n0,1)]-A*(X*w);
out(1:n0) = max(0,out(1:n0)); % This has been updated as of 01/20/2014. Old line: out = max(0,out);
obj = sum(C.*out.^2)/2 + w'*w/2; % L2 penalization of the errors
grad = w - (((C.*out)'*A)*X)'; % Gradient
sv = out>0;