function overlayDisp(ensembleTable,universalTestIdx,displayTestBboxes,testResp,groupIndicator,htmlDir,htmlFilename,imgDir,IMDB,mergeDisp)

if ~exist('mergeDisp','var')
    mergeDisp=false;
end



% sorting 
[testResp, sortidx]=sort(testResp,'descend');
universalTestIdx=universalTestIdx(sortidx);
% displayTestBboxes=cellfun(@(x)x(sortidx,:),displayTestBboxes,'uniformoutput',false);


% colors=distinguishable_colors(length(displayTestBboxes));
uGroupIdx=unique(groupIndicator);
colors=distinguishable_colors(length(uGroupIdx));




% for generating GIFs
% gifIdx=[1306 1324 1065 1707 1179 1028 1750 1163];
% gifDir='~/Dropbox/gifs/';
% if ~exist(gifDir,'dir')
%     mkdir(gifDir);
% end
% DelayTime=0.1;
% for curGifIdx = vec(gifIdx)'
%     dispI=readImIMDB(curGifIdx,IMDB);
%     dispICopy=dispI;
%     heatGIFFilename=fullfile(gifDir,sprintf('heat_%g.gif',curGifIdx));
%     boxGIFFilename=fullfile(gifDir,sprintf('box_%g.gif',curGifIdx));
%     heatMap=zeros(size(dispI,1),size(dispI,2));
%     gifCounter=1;
%     heatGIF=[];
%     boxGIF=[];
%     for pp=1:length(displayTestBboxes)
%         bbox=displayTestBboxes{pp}(curGifIdx==displayTestBboxes{pp}(:,5),:);
%         if ~isempty(bbox)
%             bbox(1:4)=clip_to_image(round(bbox(1:4)),[1 1 IMDB(curGifIdx).size(2) IMDB(curGifIdx).size(1)]);
%             dispICopy=plot_bb(dispICopy,bbox,[1 0.647 0],'1');
%             heatMap(bbox(2):bbox(4),bbox(1):bbox(3),:)=heatMap(bbox(2):bbox(4),bbox(1):bbox(3),:)+ensembleTable(pp,4);
%             calibHeatMap=calibProb(heatMap,[min(vec(heatMap)) max(vec(heatMap))]);
%             % sigmoid stretching for emphasizing highlited regions
%             kk=10;
%             calibHeatMap = sigmoid(calibHeatMap,kk,kk*-0.6);
%             [overlayProb ignore map]=sc(calibHeatMap,'prob_jet');
%             alpha=0.3;
%             heatI=(1-alpha)*dispI+alpha*overlayProb;
%             imagesc(heatI);
%             colormap(map);
%             axis off;
%             drawnow
%             set(gca,'position',[0 0 1 1],'units','normalized')
%             frame = getframe(1);
%             im = frame2im(frame);
%             [A,heatGIFMap] = rgb2ind(im,256); 
%             if gifCounter == 1;
%                 imwrite(A,heatGIFMap,heatGIFFilename,'gif','LoopCount',Inf,'DelayTime',1);
%             else
%                 imwrite(A,heatGIFMap,heatGIFFilename,'gif','WriteMode','append','DelayTime',DelayTime);
%             end
%             close all;
%             imagesc(dispICopy);
%             axis off;
%             drawnow
%             set(gca,'position',[0 0 1 1],'units','normalized')
%             frame = getframe(1);
%             im = frame2im(frame);
%             [A,boxGIFMap] = rgb2ind(im,256); 
%             if gifCounter == 1;
%                 imwrite(A,boxGIFMap,boxGIFFilename,'gif','LoopCount',Inf,'DelayTime',1);
%             else
%                 imwrite(A,boxGIFMap,boxGIFFilename,'gif','WriteMode','append','DelayTime',DelayTime);
%             end
%             close all;
%             gifCounter=gifCounter+1;
%         end
%     end
% end



for qq=1:length(universalTestIdx)
    dispImgIdx=universalTestIdx(qq);
    imgFilename=fullfile(imgDir,sprintf('%g.jpg',dispImgIdx));
    heatFilename=fullfile(imgDir,sprintf('heat_%g.jpg',dispImgIdx));
    
    dispI=readImIMDB(dispImgIdx,IMDB);
    dispICopy=dispI;
    heatMap=zeros(size(dispI,1),size(dispI,2));
    for pp=1:length(displayTestBboxes)
        bbox=displayTestBboxes{pp}(dispImgIdx==displayTestBboxes{pp}(:,5),:);
        if ~isempty(bbox)
            tmpsize=getIMDBProperty(dispImgIdx,IMDB,'size');
            bbox(1:4)=clip_to_image(round(bbox(1:4)),[1 1 tmpsize(2) tmpsize(1)]);
            dispI=plot_bb(dispI,bbox,colors(groupIndicator(pp)==uGroupIdx,:),'1');
            heatMap(bbox(2):bbox(4),bbox(1):bbox(3),:)=heatMap(bbox(2):bbox(4),bbox(1):bbox(3),:)+ensembleTable(pp,4);
        end
    end
    
    if mergeDisp
        dispICopy=dispICopy(:,1:round(size(dispICopy,2)/2),:);
        heatMap=reshape(heatMap,size(heatMap,1),[],2);
        heatMapFlip=fliplr(heatMap(:,:,2));
        heatMap=heatMap(:,:,1);
        heatMap=(heatMap+heatMapFlip)/2;
    end
    
    
    heatMap=calibProb(heatMap,[min(vec(heatMap)) max(vec(heatMap))]);
    % sigmoid stretching for emphasizing highlited regions
    kk=10;
    heatMap = sigmoid(heatMap,kk,kk*-0.6);
    
    [overlayProb ignore map]=sc(heatMap,'prob_jet');
    alpha=0.3;
    dispICopy=(1-alpha)*dispICopy+alpha*overlayProb;
    imagesc(dispICopy);
    %colorbar;
    colormap(map);
    axis off;
    mysaveas(gca,heatFilename);
    myimwrite(dispI,imgFilename);
    fprintf('overlayDisp: %g/%g image printed\n',qq,length(universalTestIdx));
end










htmlfilename=fullfile(htmlDir,sprintf('%s.html',htmlFilename));
imgList=[];
imgStr=[];
for qq=1:length(universalTestIdx)
    dispImgIdx=universalTestIdx(qq);
    imgFilename=fullfile(imgDir,sprintf('%g.jpg',dispImgIdx));
    imgList{end+1}=relativepath(imgFilename,htmlDir);
    imgStr{end+1}=sprintf('(%g/%g) imgIdx:%g',qq,length(universalTestIdx),dispImgIdx);
end
displayPatch(htmlfilename,imgList,imgStr,[],[],9,200,200);


htmlfilename=fullfile(htmlDir,sprintf('%s_heat.html',htmlFilename));
imgList=[];
imgStr=[];
for qq=1:length(universalTestIdx)
    dispImgIdx=universalTestIdx(qq);
    imgFilename=fullfile(imgDir,sprintf('heat_%g.jpg',dispImgIdx));
    imgList{end+1}=relativepath(imgFilename,htmlDir);
    imgStr{end+1}=sprintf('(%g/%g) imgIdx:%g',qq,length(universalTestIdx),dispImgIdx);
end
displayPatch(htmlfilename,imgList,imgStr,[],[],9,200,200);




function y = sigmoid(x,a,b)
if ~exist('a','var')    
    a = 1;
end
if ~exist('b','var')    
    b = 1;
end

f = a*x+b;
y = 1./(1+exp(-f));






