function [hypoBboxes perturbationH perturbationW]=perturbBboxes(operBboxes,imgSize,perturbRatio,N,tolerance)

hypoBboxes=[];
perturbationH=[];
perturbationW=[];
% actualExtRate=[];
    
if N<=0
    warning('N<=0');
    return;
end

hgt=operBboxes(:,4)-operBboxes(:,2)+1;
wid=operBboxes(:,3)-operBboxes(:,1)+1;

% % enlarge the bboxes
% en_wm=min(min((operBboxes(:,1)-1)./wid),extRate);% wid minus
% en_hm=min(min((operBboxes(:,2)-1)./hgt),extRate);% hgt minus
% en_wp=min(min((imgSize(:,2)-operBboxes(:,3))./wid),extRate);% wid plus
% en_hp=min(min((imgSize(:,1)-operBboxes(:,4))./hgt),extRate);% hgt plus
% 
% [en_wm,en_wp,en_hm,en_hp]=cropSquare(en_wm,en_wp,en_hm,en_hp);
% actualExtRate=((en_wm+en_wp)+(en_hm+en_hp))/2+1;
% 
% % update operBboxes
% bboxN=size(operBboxes,1);
% operBboxes(:,1:4)=round([operBboxes(:,1)-en_wm*wid operBboxes(:,2)-en_hm*hgt operBboxes(:,3)+en_wp*wid operBboxes(:,4)+en_hp*hgt]);
% operBboxes(:,1:4)=clip_to_image_group(round(operBboxes(:,1:4)),[ones(bboxN,1) ones(bboxN,1) imgSize(:,2) imgSize(:,1)]);
% hgt=operBboxes(:,4)-operBboxes(:,2);
% wid=operBboxes(:,3)-operBboxes(:,1);

% get the boundary range
wm=-(min((operBboxes(:,1)-1)./wid)+tolerance);% wid minus
hm=-(min((operBboxes(:,2)-1)./hgt)+tolerance);% hgt minus
wp=min((imgSize(:,2)-operBboxes(:,3))./wid)+tolerance;% wid plus
hp=min((imgSize(:,1)-operBboxes(:,4))./hgt)+tolerance;% hgt plus

wm=max(wm,-perturbRatio);
hm=max(hm,-perturbRatio);
wp=min(wp,perturbRatio);
hp=min(hp,perturbRatio);

% sample
% perturbationW=perturbRatio*(((rand(N,1)>0.5)-0.5)*2.*rand(N,1));
% perturbationH=perturbRatio*(((rand(N,1)>0.5)-0.5)*2.*rand(N,1));
perturbationW=wm+(wp-wm)*rand(N,1);
perturbationH=hm+(hp-hm)*rand(N,1);



hypoBboxes=cell(N,1);
for i =1:N
    hypoBboxes{i}=[operBboxes(:,1)+perturbationW(i)*wid operBboxes(:,2)+perturbationH(i)*hgt ...
        operBboxes(:,1)+perturbationW(i)*wid+wid-1 operBboxes(:,2)+perturbationH(i)*hgt+hgt-1 operBboxes(:,5:end)];
end



function [en_wm,en_wp,en_hm,en_hp]=cropSquare(en_wm,en_wp,en_hm,en_hp)
% crop into square
if en_wm+en_wp>en_hm+en_hp
    avg=(en_hm+en_hp)/2;
    if en_wm>=avg && en_wp>=avg
        en_wm=avg;
        en_wp=avg;
    elseif en_wm>=avg
        en_wm=avg;
    else
        en_wp=avg;
    end
else
    avg=(en_wm+en_wp)/2;
    if en_hm>=avg && en_hp>=avg
        en_hm=avg;
        en_hp=avg;
    elseif en_hm>=avg
        en_hm=avg;
    else
        en_hp=avg;
    end
end


% if en_wm+en_wp>en_hm+en_hp
%     gap=(en_wm+en_wp)-(en_hm+en_hp);
%     if en_wm>=en_wp
%         red=min(gap,en_wm);
%         en_wm=en_wm-red;
%         gap=gap-red;
%         if gap>0
%             en_wp=en_wp-gap;
%         end
%     else
%         red=min(gap,en_wp);
%         en_wp=en_wp-red;
%         gap=gap-red;
%         if gap>0
%             en_wm=en_wm-gap;
%         end
%     end
% else
%     gap=(en_hm+en_hp)-(en_wm+en_wp);
%     if en_hm>=en_hp
%         red=min(gap,en_hm);
%         en_hm=en_hm-red;
%         gap=gap-red;
%         if gap>0
%             en_hp=en_hp-gap;
%         end
%     else
%         red=min(gap,en_hp);
%         en_hp=en_hp-red;
%         gap=gap-red;
%         if gap>0
%             en_hm=en_hm-gap;
%         end
%     end
% end





