function Y=poissonBlend(target,targetBbox,src)

targetBbox=clip_to_image(round(targetBbox),[1 1 size(target,2) size(target,1)]);
targetSize=[targetBbox(4)-targetBbox(2)+1 targetBbox(3)-targetBbox(1)+1];
src=imresize(src,targetSize);

[Lh Lv] = imgrad(target);
[Gh Gv] = imgrad(src);

X = target;
Fh = Lh;
Fv = Lv;

hs=targetBbox(2);
he=targetBbox(4);
ws=targetBbox(1);
we=targetBbox(3);

X(hs:he,ws:we,:) = src;
Fh(hs:he,ws:we,:) = Gh;
Fv(hs:he,ws:we,:) = Gv;

% figure out the actual mask to avoid whiten blended in
colCrop=target(:,ws:we,:);
colEnergy=sqrt(sum(sum(colCrop.^2,3),2)/((we-ws+1)*size(colCrop,3)));
% plot(colEnergy);hold on;plot(hs,colEnergy(hs),'r+');plot(he,colEnergy(he),'r+');hold off;
rowCrop=target(hs:he,:,:);
rowEnergy=sqrt(sum(sum(rowCrop.^2,3),1)/((he-hs+1)*size(rowCrop,3)));

whiteEnergy=1;
thresh=0.1;
if (he+1)<=length(colEnergy) && abs(colEnergy(he+1)-whiteEnergy)<thresh
    X(he+1:end,:,:)=repmat(X(he,:,:),[size(X,1)-he 1 1]);
    Fh(he+1:end,:,:)=repmat(Fh(he,:,:),[size(Fh,1)-he 1 1]);
    Fv(he+1:end,:,:)=repmat(Fv(he,:,:),[size(Fv,1)-he 1 1]);
end
if (hs-1)>=1 && abs(colEnergy(hs-1)-whiteEnergy)<thresh
    X(1:hs-1,:,:)=repmat(X(hs,:,:),[hs-1 1 1]);
    Fh(1:hs-1,:,:)=repmat(Fh(hs,:,:),[hs-1 1 1]);
    Fv(1:hs-1,:,:)=repmat(Fv(hs,:,:),[hs-1 1 1]);
end
if (we+1)<=length(rowEnergy) && abs(rowEnergy(we+1)-whiteEnergy)<thresh
    X(:,we+1:end,:)=repmat(X(:,we,:),[1 size(X,2)-we 1]);
    Fh(:,we+1:end,:)=repmat(Fh(:,we,:),[1 size(Fh,2)-we 1]);
    Fv(:,we+1:end,:)=repmat(Fv(:,we,:),[1 size(Fv,2)-we 1]);
end
if (ws-1)>=1 && abs(rowEnergy(ws-1)-whiteEnergy)<thresh
    X(:,1:ws-1,:)=repmat(X(:,ws,:),[1 ws-1 1]);
    Fh(:,1:ws-1,:)=repmat(Fh(:,ws,:),[1 ws-1 1]);
    Fv(:,1:ws-1,:)=repmat(Fv(:,ws,:),[1 ws-1 1]);
end



% hGap=min(he-hs+1,10);
% wGap=min(we-ws+1,10);

msk = zeros(size(X));
msk(hs:he,ws:we,:) = 1;
% msk(hs:hs+hGap-1,ws:we,:) = 1;
% msk(he-hGap+1:he,ws:we,:) = 1;
% msk(hs:he,ws:ws+wGap-1,:) = 1;
% msk(hs:he,we-wGap+1:we,:) = 1;


method='Jacob';
if strcmp(method,'Jacob')
    tmpY = PoissonJacobi( X, Fh, Fv, msk );
elseif strcmp(method,'Gauss')
    tmpY = PoissonGaussSeidel( X, Fh, Fv, msk );
else
    error('unknown blending method');
end
Y=target;
Y(hs:he,ws:we,:)=tmpY(hs:he,ws:we,:);

% imshow(plot_bb(Y,targetBbox,'r'));
% stop=1;

