function printImgDriver(dsidx)
global ds;
touch;
if (~dsfield(ds,'store')),
    dsload('ds.store.operatingBboxes');
    dsload('ds.store.operatingPrintDir');
    dsload('ds.store.operatingMapDir');
    dsload('ds.store.operatingLoc');
    dsload('ds.store.operatingW');
    dsload('ds.store.operatingDetector');
    dsload('ds.store.operatingSbin');
    dsload('ds.store.operatingDictN');
    dsload('ds.store.operatingSpry');
    dsload('ds.store.operatingIMDB');
    dsload('ds.store.operatingInfo');
    dsload('ds.store.operatingMap');
    dsload('ds.store.operatingRespClimBar');
    dsload('ds.store.operatingAtomClimBar');
    dsload('ds.store.operatingRespmaponthefly');
    dsload('ds.store.operatingHogScaleArr');
    dsload('ds.store.operatingScaledSize');
    dsload('ds.store.operatingScales');
    dsload('ds.store.operatingOptions');
end;
if dsmapredisopen
    dsload(sprintf('ds.store.operatingHogLayer{%g}',dsidx));
end
startTime=tic;
fprintf('retrieve ds.store.operatingHogLayer{%g}\n',dsidx);
hogLayer=ds.store.operatingHogLayer{dsidx};
hogScaleArr=ds.store.operatingHogScaleArr;
respmaponthefly=ds.store.operatingRespmaponthefly;
bboxes=ds.store.operatingBboxes;
printDir=ds.store.operatingPrintDir;
mapDir=ds.store.operatingMapDir;
loc=ds.store.operatingLoc;
w=ds.store.operatingW;
detector=ds.store.operatingDetector;
sbin=ds.store.operatingSbin;
dictN=ds.store.operatingDictN;
spry=ds.store.operatingSpry;
IMDB=ds.store.operatingIMDB;
info=ds.store.operatingInfo;
map=ds.store.operatingMap;
respClimBar=ds.store.operatingRespClimBar;
atomClimBar=ds.store.operatingAtomClimBar;
universalScales=ds.store.operatingScales;
universalScaledSize=ds.store.operatingScaledSize;
options=ds.store.operatingOptions;

if ~isempty(loc)
    layer=loc(dsidx,5);
else
    layer=1;
end
bbox=bboxes(dsidx,:);
imgIdx=bboxes(dsidx,5);
I=readImIMDB(imgIdx,IMDB);
respMapFilename=fullfile(printDir,'resp',sprintf('%g.jpg',imgIdx));
atomMapFilename=fullfile(printDir,'atom',sprintf('%g.jpg',imgIdx));
bboxFilename=fullfile(printDir,'bbox',sprintf('%g.jpg',imgIdx));



% print atom map
if isfield(options,'atom')&&~isempty(options.atom)&&options.atom
    [integratedMap]=loadCodeMap(mapDir,getIMDBProperty(imgIdx,IMDB,'origImgIdx'),sbin);
    [integratedMap]=integrateMap(integratedMap,I,true);
    integratedMap=integratedMap{layer};
    
    [HSize]=size(integratedMap,1);
    [WSize]=size(integratedMap,2);
    hmp=max(1-loc(dsidx,2),0);
    wmp=max(1-loc(dsidx,1),0);
    hpp=max(loc(dsidx,4)-HSize,0);
    wpp=max(loc(dsidx,3)-WSize,0);
    if hmp>0||wmp>0||hpp>0||wpp>0
        paddedIntegratedMap=padarray(integratedMap,[hmp wmp],0,'pre');
        paddedIntegratedMap=padarray(paddedIntegratedMap,[hpp wpp],0,'post');
        shiftedBbox=[loc(dsidx,1)+wmp loc(dsidx,2)+hmp loc(dsidx,3)+wmp loc(dsidx,4)+hmp];
    else
        paddedIntegratedMap=integratedMap;
        shiftedBbox=loc(dsidx,:);
    end
    atomMap=paddedIntegratedMap(shiftedBbox(2):shiftedBbox(4),shiftedBbox(1):shiftedBbox(3),:);
    %atomMap=integratedMap(loc(dsidx,2):loc(dsidx,4),loc(dsidx,1):loc(dsidx,3),:);
    atomMap=colorizeAtomMap(atomMap,layer,[],w,sbin,dictN,spry);
    overlayAtomMap(I,loc(dsidx,1:4),universalScales(layer),atomMap,atomClimBar,map,sbin);
    mysaveas(gca,atomMapFilename);
end




% print resp map
% determine whether to compute the response map on the fly
respmaponthefly=respmaponthefly || ~isstruct(hogLayer) || sum(vec(isnan(hogScaleArr)))>0;
if respmaponthefly
    hogScale=universalScales(layer);
    [pedroHog scaledSize]=pedroHogFixedScales(I,hogScale);
else
    hogScale=hogScaleArr(dsidx,1);
    pedroHog=hogLayer.layer(hogScale==hogLayer.scale);
end
% pedroHog=fakePadding(pedroHog,scaledSize);
% pedroHog=pedroHog{1};
if isstruct(info{dsidx})
    
    respMap=createRespMap(pedroHog,layer,hogScale,info{dsidx},detector,sbin,universalScaledSize,respmaponthefly);
    % % DEBUG create a response map for context feature
    % if ~isfield(options,'valAdditionalInfo')
    %     respMap=createRespMap(pedroHog,layer,hogScale,info{dsidx},detector,sbin,universalScaledSize,norespmaponthefly);
    %     %SW=[size(detector.w,1) size(detector.w,2)]*sbin*(1+2*options.contextExtRate);
    %     %[respMap]=createContextRespMap(integratedMap,detector,SW,spry);
    % else
    %     respMap=options.valAdditionalInfo{dsidx}.contextResp{layer};
    % end
    
    if respmaponthefly
        scaledBbox=clip_to_image(round(bbox(1:4)*hogScale),[1 1 size(respMap,2) size(respMap,1)]);
        scaledH=scaledBbox(4)-scaledBbox(2);
        scaledW=scaledBbox(3)-scaledBbox(1);
    else
        scaledBbox=[hogScaleArr(dsidx,3) hogScaleArr(dsidx,2)];
        scaledH=size(detector.w,1)-1;
        scaledW=size(detector.w,2)-1;
    end
    clf;
    h=imagesc(respMap);
    colormap('default');
    colorbar;
    if sum(isnan(respClimBar))==0
    set(gca,'clim',respClimBar);
    end
    rectangle('Position',[scaledBbox(1) scaledBbox(2) scaledW scaledH],'EdgeColor','r','LineWidth',3);
    mysaveas(h,respMapFilename);
    % im=export_fig;
    % myimwrite(im,respMapFilename);
end

% print the bounding box
bbI=plot_bb(I,bbox,'r');
myimwrite(bbI,bboxFilename);

timeSpent=toc(startTime);
fprintf('printImgDriver: printing %g/%g image pair, time:%g\n',dsidx,size(bboxes,1),timeSpent);
