function printPage(bboxes,constraints,score,detectorScores,acc,cvacc,C,htmlFilename,stuffFolder,printDirPattern,iter,isPrintResp)
if ~exist('isPrintResp','var')
    isPrintResp=false;
end

if isempty(score)
    score=nan(size(bboxes,1),1);
end
[sortedScore sortedIdx]=sort(score,'descend');

printDir=sprintf(printDirPattern,iter);
fullHtmlFilename=fullfile(printDir,htmlFilename);
imgList=[];
imgStr=[];

imgList{end+1}=relativepath(fullfile(printDir,stuffFolder,'posHog.jpg'),printDir);
imgStr{end+1}='pos HOG';
imgList{end+1}=relativepath(fullfile(printDir,stuffFolder,'negHog.jpg'),printDir);
imgStr{end+1}='neg HOG';

for i = 1:length(sortedIdx)
    imgIdx=bboxes(sortedIdx(i),5);
    atomMapFilename=fullfile(printDir,stuffFolder,'atom',sprintf('%g.jpg',imgIdx));
    respMapFilename=fullfile(printDir,stuffFolder,'resp',sprintf('%g.jpg',imgIdx));
    bboxFilename=fullfile(printDir,stuffFolder,'bbox',sprintf('%g.jpg',imgIdx));
    % write image
    imgList{end+1}=relativepath(bboxFilename,printDir);
    if isPrintResp
        imgList{end+1}=relativepath(respMapFilename,printDir);
    end
    imgList{end+1}=relativepath(atomMapFilename,printDir);
    if i==1
        imgStr{end+1}=sprintf('(tr:%g,cv:%g,C=%g)<br>bbox img:%g, %g/%g<br>r=%g,d=%g',acc,cvacc,C,imgIdx,i,length(sortedIdx),score(sortedIdx(i)),detectorScores(sortedIdx(i)));
    else
        imgStr{end+1}=sprintf('bbox img:%g, %g/%g<br>r=%g,d=%g',imgIdx,i,length(sortedIdx),score(sortedIdx(i)),detectorScores(sortedIdx(i)));
    end
    if isPrintResp
        imgStr{end+1}=sprintf('resp img:%g',imgIdx);
    end
    imgStr{end+1}=sprintf('atom img:%g',imgIdx);
    fprintf('printPage: printing %g/%g image pair\n',i,length(sortedIdx));
end
if isPrintResp
    displayPatch(fullHtmlFilename,imgList,imgStr,fullfile(sprintf(printDirPattern,iter-1),htmlFilename),...
        fullfile(sprintf(printDirPattern,iter+1),htmlFilename),[2 9*ones(1,ceil(length(sortedIdx)/3))],200,200);
else
    displayPatch(fullHtmlFilename,imgList,imgStr,fullfile(sprintf(printDirPattern,iter-1),htmlFilename),...
        fullfile(sprintf(printDirPattern,iter+1),htmlFilename),8,200,200);
end


% -----------------------------------------------------------------
% print page showing all comparison pairs
[ignore htmlFilename]=fileparts(htmlFilename);
htmlFilename=[htmlFilename '_comparison.html'];
fullHtmlFilename=fullfile(printDir,htmlFilename);
imgList=[];
imgStr=[];
for i = 1:size(constraints,1)
    phrase='stronger';
    if constraints(i,4)==1
        strongIdx=constraints(i,1);
        weakIdx=constraints(i,2);
    elseif constraints(i,4)==2
        strongIdx=constraints(i,2);
        weakIdx=constraints(i,1);
    else
        strongIdx=constraints(i,1);
        weakIdx=constraints(i,2);
        phrase='equal';
    end
    
    %strongRespMapFilename=fullfile(printDir,stuffFolder,'resp',sprintf('%g.jpg',strongIdx));
    strongBboxFilename=relativepath(fullfile(printDir,stuffFolder,'bbox',sprintf('%g.jpg',strongIdx)),printDir);
    strongAtomMapFilename=relativepath(fullfile(printDir,stuffFolder,'atom',sprintf('%g.jpg',strongIdx)),printDir);
    
    %weakRespMapFilename=fullfile(printDir,stuffFolder,'resp',sprintf('%g.jpg',weakIdx));
    weakBboxFilename=relativepath(fullfile(printDir,stuffFolder,'bbox',sprintf('%g.jpg',weakIdx)),printDir);
    weakAtomMapFilename=relativepath(fullfile(printDir,stuffFolder,'atom',sprintf('%g.jpg',weakIdx)),printDir);
    
    [ignore strongLocalIdx]=ismember(strongIdx,bboxes(:,5));
    [ignore weakLocalIdx]=ismember(weakIdx,bboxes(:,5));
    
    if strcmp(phrase,'stronger')
        correct=score(strongLocalIdx)>score(weakLocalIdx);
    else
        correct=true;
    end
    
    imgList{end+1}=strongBboxFilename;
    imgList{end+1}=strongAtomMapFilename;
    imgList{end+1}=weakBboxFilename;
    imgList{end+1}=weakAtomMapFilename;
    
    if correct
        imgStr{end+1}=sprintf('<font color="green">%s</font>',phrase);
    else
        imgStr{end+1}=sprintf('<font color="red">%s</font>',phrase);
    end
    imgStr{end+1}=sprintf('img:%g,score:%g',strongIdx,score(strongLocalIdx));
    imgStr{end+1}='';
    imgStr{end+1}=sprintf('img:%g,score:%g',weakIdx,score(weakLocalIdx));
end

displayPatch(fullHtmlFilename,imgList,imgStr,fullfile(sprintf(printDirPattern,iter-1),htmlFilename),...
        fullfile(sprintf(printDirPattern,iter+1),htmlFilename),4,200,200);
