function resBboxes=processGrid(dispbboxespool,selGrid,hGrid,wGrid)

resBboxes=[];
for i = 1:size(selGrid,1)
    chainIdx=selGrid(i,1);
    gridIdx=selGrid(i,2);
    chainBboxes=dispbboxespool(dispbboxespool(:,end)==chainIdx,:);
    [grids marker]=gridilization(chainBboxes,[],hGrid,wGrid,1,1,1,false);
    for j = 1:length(grids)
        grids{j}(:,5)=grids{j}(:,5)+1;
    end
    tmpBboxes=[chainBboxes(:,1:4) ones(size(chainBboxes,1),1) ones(size(chainBboxes,1),1)*chainIdx];
    grids=[{tmpBboxes} grids];
    tmpBboxes=[grids{gridIdx}(:,1:4) chainBboxes(:,5) grids{gridIdx}(:,5:6) ones(size(chainBboxes,1),1)*i];
    resBboxes=[resBboxes;tmpBboxes];
end



function [grids marker]=gridilization(bboxes,imgsize,hGrid,wGrid,wWindow,hWindow,stride,isLimitInFrame)
if ~exist('isLimitInFrame','var') || isempty(isLimitInFrame)
    isLimitInFrame=true;
end

bboxesN=size(bboxes,1);
height=bboxes(:,4)-bboxes(:,2)+1;
width=bboxes(:,3)-bboxes(:,1)+1;
hUnit=max(round(height/hGrid),1.0);
wUnit=max(round(width/wGrid),1.0);

% make the masked version of the patches
grids=[];
marker=[];
counter=1;
for wIdx=1:stride:(wGrid-wWindow+1)
    for hIdx=1:stride:(hGrid-hWindow+1)
        hStart=bboxes(:,2)+(hIdx-1)*hUnit;
        hEnd=hStart+hUnit*hWindow-1;
        wStart=bboxes(:,1)+(wIdx-1)*wUnit;
        wEnd=wStart+wUnit*wWindow-1;
        
        % whether limit the coordinates in the frame
        if isLimitInFrame
            maskBboxes=[clip_to_image_group(round([wStart hStart wEnd hEnd]),...
                [ones(bboxesN,2) imgsize(:,2) imgsize(:,1)]) counter*ones(bboxesN,1) vec(bboxes(:,end))];
        else
            maskBboxes=[round([wStart hStart wEnd hEnd]),...
                counter*ones(bboxesN,1) vec(bboxes(:,end))];
        end
        
        assert(size(maskBboxes,1)==bboxesN);
        grids{end+1}=maskBboxes;
        marker=[marker;wIdx hIdx wIdx+wWindow-1 hIdx+hWindow-1];
        counter=counter+1;
    end
end