function res = computeLookupTable(dict,models,quantizeBboxSize,fsize)
if prod(quantizeBboxSize)*fsize~=size(dict,1)
    error('dictionary and quantize bbox dimension mismatch!');
end
modelSizes = cellfun2(@(x)x.model.hg_size,models);
modelSizes = cat(1,modelSizes{:});
S = max(modelSizes,[],1);
hSB = S(1);
wSB = S(2);
hQB = quantizeBboxSize(1);
wQB = quantizeBboxSize(2);

% padding models
W = cellfun2(@(x)vec(paddingToSpecSize(x.model.w,hSB,wSB)),models);
W = cat(2,W{:});
b = cellfun(@(x)x.model.b,models);
if size(b,1) == 1
    b = b';
end

hBin = round(hSB/hQB);
wBin = round(wSB/wQB);
counter = 1;
res.lut = cell(wBin*hBin,1);
for i = 1:wBin
    for j = 1:hBin
        mask = false(hSB,wSB,fsize);
        mask((j-1)*hQB+1:j*hQB,(i-1)*wQB+1:i*wQB,:) = true;
        mask = mask(:);
        res.lut{counter} = W(mask,:)'*dict;
        res.wBin(counter) = i;
        res.hBin(counter) = j;
        res.ws{counter} = W(mask,:);
        %fprintf('%g th displacement lookup table computed\n',counter);
        counter = counter + 1;
    end
end
res.bs = b;

