function display_bbox_clique(I,bboxes,clique_idx,N_thresh)
dark_mask = 0.2;

I = im2double(I);
isrgb = ndims(I) == 3;
M = size(I,1);
N = size(I,2);

u_clique_idx = unique(clique_idx);
N_per_clique = zeros(length(u_clique_idx),1);
for i = 1:length(u_clique_idx)
    N_per_clique(i) = sum(u_clique_idx(i)==clique_idx);
end
u_clique_idx = u_clique_idx(N_per_clique>=N_thresh);

N_clique = length(u_clique_idx);

scores = bboxes(:,end);
bboxes = clip_to_image(round(bboxes(:,1:4)),[1 1 N M]);
% clique_color = 'rgbmyc';



for i = 1:N_clique
    val_idx = find(clique_idx == u_clique_idx(i));
    mask = zeros(size(I,1),size(I,2));
    for j = 1:length(val_idx)
        box = bboxes(val_idx(j),:);
        mask(box(2):box(4),box(1):box(3)) = mask(box(2):box(4),box(1):box(3)) + scores(val_idx(j));
    end
    % normalize
    mask = mask/max(mask(:));
%     mask(mask==0) = dark_mask;
    mask = mask + dark_mask;
    subplot_tight(1,N_clique,i);
    if isrgb
        imshow(I.*repmat(mask,[1 1 3]));
    else
        imshow(I.*mask);
    end
    title([num2str(length(val_idx))]);
end

