function Clets = extract_Clets(bboxes,os_thresh,N_thresh,N_models,probe_seq)
% keep detections from probe set
complete_model_idx = bboxes(:,6);
val_idx = ismember(complete_model_idx,probe_seq);
bboxes = bboxes(val_idx,:);

bboxes(:,end) = bboxes(:,end) + 1;
os = getosmatrix_bb(bboxes(:,1:4),bboxes(:,1:4));

[sortval sortidx] = sort(bboxes(:,end));
count = 0;
Clets = [];
while ~isempty(sortidx)
    count = count + 1;
    center_idx = sortidx(1);
    clique_idx = find(os(center_idx,sortidx) > os_thresh);
    global_clique_idx = sortidx(clique_idx);
    
    
    if length(global_clique_idx) >= N_thresh
        % keep one detection for each model
        model_idx = bboxes(global_clique_idx,6);
        [u_model_idx trans] = unique(model_idx);
        scores = zeros(length(u_model_idx),1);
        
        if length(u_model_idx) ~= length(model_idx)
            for i = 1:length(u_model_idx)
                val_idx = (u_model_idx(i) == model_idx);
                scores(i) = max(bboxes(val_idx,end));
            end
        else
            scores = bboxes(trans,end);
        end
        
        Clets(:,end+1) = zeros(2*N_models,1);
        Clets(u_model_idx,end) = scores;
    end
    sortidx(clique_idx) = [];
end

