function IOU = get3Dos(box3D_1,box3D_2)
debug = 0;

boxXZ_1 = box3D_1([1 3],1:4);
boxXZ_2 = box3D_2([1 3],1:4);
    
P1.x=boxXZ_1(1,:); 
P1.y=boxXZ_1(2,:); 
P1.hole=0;
P2.x=boxXZ_2(1,:); 
P2.y=boxXZ_2(2,:); 
P2.hole=0;
type = 1; % intersection
P3=PolygonClip(P1,P2,type);
if ~isempty(P3)
    intersection_X = P3.x';
    intersection_Y = P3.y';
end

% display
if debug
    close all;
    figure;
    hold on;
    line([boxXZ_1(1,1:4),boxXZ_1(1,1)],[boxXZ_1(2,1:4),boxXZ_1(2,1)],'color','r');
    line([boxXZ_2(1,1:4),boxXZ_2(1,1)],[boxXZ_2(2,1:4),boxXZ_2(2,1)],'color','b');
    for j = 1:4
        text(boxXZ_1(1,j),boxXZ_1(2,j),sprintf('{\\color{red}%d}',j));
        text(boxXZ_2(1,j),boxXZ_2(2,j),sprintf('{\\color{blue}%d}',j));
    end
    if ~isempty(P3)
        line([intersection_X(1:4),intersection_X(1)],...
            [intersection_Y(1:4),intersection_Y(1)],'color','g');
    end
    hold off;
    axis equal
end

if ~isempty(P3)
    % compute the area
    area_1 = polyarea(boxXZ_1(1,:),boxXZ_1(2,:));
    area_2 = polyarea(boxXZ_2(1,:),boxXZ_2(2,:));
    area_intersection = polyarea(intersection_X,intersection_Y);
    IOU = area_intersection/(area_1+area_2-area_intersection);
else
    IOU = 0;
end

