function [I2,mask] = insert_exemplar(I,overlay,d)
%Given a target image, an overlay, and the transform, place it
%inside the new image

% if d(7) == 1
%   overlay.I = flip_image(overlay.I);
%   overlay.alphamask = flip_image(overlay.alphamask);
% end

target = round(d);

newsize = [target(4)-target(2)+1 target(3)- ...
                    target(1)+1];
newI = imresize(overlay.I,newsize,'nearest');
newalpha = imresize(overlay.alphamask, newsize,'nearest');
I2 = I;

newalpha = repmat(newalpha,[1 1 3]);

PAD = round(size(I2,1)*.8);
I2 = pad_image(I2,PAD);

mask = zeros(size(I2,1),size(I2,2));
%%% HACK making black images
%I2 = I2*0;
Iblack = I2*0;

target = target+PAD;

targetx = target(2):target(4);
targety = target(1):target(3);
goodsx = find(targetx>=1 & targetx<=size(I2,1));
goodsy = find(targety>=1 & targety<=size(I2,2));

targetx = targetx(goodsx);
targety = targety(goodsy);

I2(targetx,targety,:) = ...
    I2(targetx,targety,:).*(1-newalpha(goodsx,goodsy,:)) + ...
    newI(goodsx,goodsy,:).*(newalpha(goodsx,goodsy,:));

Iblack(targetx,targety,:) = ...
    Iblack(targetx,targety,:).*(1-newalpha(goodsx,goodsy,:)) + ...
    newI(goodsx,goodsy,:).*(newalpha(goodsx,goodsy,:));


%mask(targetx,targety,:) = 1;

mask(targetx,targety,:) = newalpha(goodsx,goodsy);

I2 = pad_image(I2,-PAD);
I2 = max(0.0,min(1.0,I2));

Iblack = pad_image(Iblack,-PAD);
Iblack = max(0.0,min(1.0,Iblack));

mask = pad_image(mask,-PAD);
mask = max(0.0,min(1.0,mask));

%% do this blending only for segmentations
Ia = Iblack;
Ib = I;
alphamap = mask;
alphamap(alphamap>0) = .8;
alphamap(alphamap==0) = 0;
%alphamap(alphamap>0) = .5;
%alphamap(alphamap==0) = .7;
alphamap = repmat(alphamap,[1 1 3]);
Itotal = Ia.*alphamap + Ib.*(1-alphamap);

I2 = Itotal;