function K = learn_K(R,Y,A,lambda)
%This function solves the following problem
%   1/2*||K*R - Y||^2 + lambda/2*||K-A||^2

% we optimize this function block by block
N_models = size(Y,1);

P = (R*R'+lambda*eye(N_models));
q = R*Y' + lambda*A';
K = (P\q)';
