function [x_new val] = learn_sv(data,margin,C,x)
% this function minimize the following objective
% min 1/2*|x|^2 + \sum_i C/N*epsilon_i
% s.t.       x'*data_i >= margin_i - epsilon_i
%            epsilon_i >= 0

% Quasi Newton for nonsmooth function
options = [];
options.display = 'none';
options.Method = 'lbfgs';
options.maxFunEvals = 2000;
options.TolX = 1e-20;

% [f grad] = sv_obj(x,data,margin,C);
% numgrad = computeNumericalGradient(@(p)sv_obj(p,data,margin,C),x);
% disp([grad numgrad]); 

[x_new val] = minFuncNonsmooth(@sv_obj,x,options,data,margin,C);
