function rect_box3D = regularize_3D(box3D)
% get the approximate cuboid
% we need to test four lines of the bottom quadrangle
debug = 0;
boxXZ = box3D([1 3],:);
quad_lines = [
    boxXZ(:,2) - boxXZ(:,1) ...
    boxXZ(:,3) - boxXZ(:,2) ...
    boxXZ(:,4) - boxXZ(:,3) ...
    boxXZ(:,1) - boxXZ(:,4) 
    ];
quad_lines = quad_lines./repmat(sqrt(sum(quad_lines.^2,1)),[2 1]);

for i = 1:size(quad_lines,2)
    results = zeros(2,4);
    project_line = quad_lines(:,i);
    orth_line = [1; -project_line(1)/project_line(2)];
    orth_line = orth_line./sqrt(sum(orth_line.^2));
    untouch_points = [boxXZ(:,mod(i+1,4)+1) boxXZ(:,mod(i+2,4)+1)];
    vertex_points = [boxXZ(:,mod(i-1,4)+1) boxXZ(:,mod(i,4)+1)];
    real_idx = [mod(i-1,4)+1 mod(i,4)+1 mod(i+1,4)+1 mod(i+2,4)+1];
    [ignore sortidx] = sort(real_idx,'ascend');
    projection = project_line'*[vertex_points untouch_points];
    
    orth = orth_line'*[vertex_points untouch_points];
    untouch_orth = orth(:,3:4);
    [maxscale maxidx] = max(projection);
    [minscale minidx] = min(projection);
    [orthscale orthidx] = max(abs(untouch_orth - orth(1)));
    orth(3:4) = repmat(untouch_orth(:,orthidx),[1 2]);
    results = results + repmat([minscale maxscale maxscale minscale],[2 1]).*...
        repmat(project_line,[1 4]);

    results = results + repmat(orth_line,[1 4]).*repmat(orth,[2 1]);
    results = results(:,sortidx);
    area = abs(maxscale-minscale)*abs(orth(3)-orth(1));
    info{i}.results = results;
    info{i}.area = area;
    
    
    if debug
        close all;
        figure;
        hold on;
        line([boxXZ(1,1:4),boxXZ(1,1)],[boxXZ(2,1:4),boxXZ(2,1)],'color','r');
        line([results(1,1:4),results(1,1)],[results(2,1:4),results(2,1)],'color','b');
        for j = 1:4
            text(boxXZ(1,j),boxXZ(2,j),sprintf('{\\color{red}%d}',j));
            text(results(1,j),results(2,j),sprintf('{\\color{blue}%d}',j));
        end
        hold off;
        axis equal
    end
end

% select the smallest rectangle containing the quadrangle
areas = cellfun(@(x)x.area,info);
[minval minidx] = min(areas);
rect_box3D = zeros(size(box3D));
rect_box3D([1 3],:) = repmat(info{minidx}.results,[1 2]);
rect_box3D(2,:) = box3D(2,:);


