function [posSampledBboxes negSampledBboxes] = sample_bboxes(...
    gtbboxes,img_size,NPosPerGt,negPosRatio,posThresh,negThresh,minLength,seedingNeeded)
if isempty(gtbboxes)
    posSampledBboxes = [];
    negSampledBboxes = [];
    return;
end

if seedingNeeded
    myRandSeeding;
end

% first sample NPosPerGt bboxes per gtbox
gtbboxes = clip_to_image(round(gtbboxes),[1 1 img_size(2) img_size(1)]);
posSampledBboxes = cell(size(gtbboxes,1),1);
blankImg = zeros(img_size(1),img_size(2),3);
debug = 0;
for i = 1:size(gtbboxes,1)
    wid = gtbboxes(i,3) - gtbboxes(i,1);
    hgt = gtbboxes(i,4) - gtbboxes(i,2);
    upperLeftRange = [max(1,gtbboxes(i,1)-1-wid) gtbboxes(i,3)...
        max(1,gtbboxes(i,2)-hgt-1) gtbboxes(i,4)];
    posCount = 0;
    if debug
        curI = plot_bb(blankImg,gtbboxes(i,:),'r');
    end
    while 1
        % sample upper left point
        samples = rand(2,1);
        upperLeft = [round((upperLeftRange(2)-upperLeftRange(1))*samples(1)+upperLeftRange(1)) ...
            round((upperLeftRange(4)-upperLeftRange(3))*samples(2)+upperLeftRange(3))];
        % sample the wid and hgt
        samples = rand(2,1);
        widHgtRange = [(gtbboxes(i,3)+wid+1-upperLeft(1))*samples(1) ...
            (gtbboxes(i,4)+hgt+1-upperLeft(2))*samples(2)];
        bottomRight = upperLeft + widHgtRange;
        sampled_bbox = [upperLeft bottomRight];
        sampled_bbox = clip_to_image(round(sampled_bbox),[1 1 img_size(2) img_size(1)]);
        
        
        if getosmatrix_bb(sampled_bbox,gtbboxes(i,:)) > posThresh
            if debug
                curI_sampled = plot_bb(curI,sampled_bbox,'b');
                imshow(curI_sampled);
            end
            posSampledBboxes{i} = [posSampledBboxes{i}; sampled_bbox];
            posCount = posCount + 1;
            if posCount>=NPosPerGt
                break;
            end
        end
    end
end

if debug
    for i = 1:size(gtbboxes,1)
        blankImg = plot_bb(blankImg,gtbboxes(i,:),'g');
    end
end
% sample neg bboxes
NNegPerImg = round(NPosPerGt*size(gtbboxes,1)*negPosRatio);
NCount = 0;
negSampledBboxes = [];
while 1
    samples = rand(2,1);
    upperLeft = [max(1,round(samples(1)*(img_size(2)-minLength))) max(1,round(samples(2)*(img_size(1)-minLength)))];  
    bottomRight = upperLeft+ [minLength minLength] + [round(img_size(2)-upperLeft(1)-minLength)*samples(1) ...
        round(img_size(1)-upperLeft(2)-minLength)*samples(2)];
    sampled_bbox = [upperLeft bottomRight];
    sampled_bbox = clip_to_image(round(sampled_bbox),[1 1 img_size(2) img_size(1)]);
    
    if debug
        curI = plot_bb(blankImg,sampled_bbox,'r');
        imshow(curI);
    end
    
    if min(getosmatrix_bb(sampled_bbox,gtbboxes)) < negThresh
        negSampledBboxes = [negSampledBboxes; sampled_bbox];
        NCount = NCount + 1;
        if NCount >= NNegPerImg
            break;
        end
    end
end








