function model = struct_SVM(bboxes,gt_labels,C,lambda,W_init,b_init)
%Learn a structured SVM to do model recommendation
%Alternating between hard-negative mining and SVM learning
%Unfinished


% set up parameters
neighbor_thresh = .5;

[N_models dim] = size(W_init); % each column of W_init is the initialization of a particular model
N_models = N_models/2;
N_data = length(bboxes);
converged = false;
h_labels = cell(N_data,1);

while ~converged
    % assign Hypothesis labels to each detection
    for i = 1:N_data
        N_box = size(bboxes{i},1);
        gt_label_i = gt_labels{i};
        
        feat = esvm_get_M_features(bboxes{i}, N_models, neighbor_thresh);
        model_idx = bboxes{i}(:,6);
        model_idx(bboxes{i}(:,7)==1) = model_idx(bboxes{i}(:,7)==1) + N_models;
        
        T_obj = sum(W_init(model_idx,:).*feat',2) + b_init(model_idx) + ...
            hamming_loss(gt_label_i,true(N_box,1),lambda,true);
        
        F_obj = b_init(model_idx) + hamming_loss(gt_label_i,false(N_box,1),lambda,true);
        h_labels{i} = double(T_obj>=F_obj);
        
        loss = hamming_loss(gt_label_i,h_labels{i},lambda,true);
        
        
    end
    
    
    
    
end







function loss = hamming_loss(y,h,lambda,decomp)
% input y and h are two sets of labels (0 and 1) and this function returns the
% hamming distance between these two sets, scaled by lambda
if decomp
    loss = double(y~=h)*lambda;
else
    loss = double(sum(y~=h))*lambda;
end
