function [I2,targetI] = visualizeAlignment(overlayIdx,targetIdx,rootDir,models,neighbors)
% visualize the alignment
targetI = im2double(imread(sprintf(models{targetIdx}.I,rootDir)));
targetGtBbox = models{targetIdx}.model.bb;
if ndims(targetI) == 2
    targetI = repmat(targetI,[1 1 3]);
end
targetGtBbox = clip_to_image(round(targetGtBbox),[1 1 ...
    size(targetI,2) size(targetI,1)]);
targetI = plot_bb(targetI,targetGtBbox,'g');
overlay.alphamask = 0.8*ones(size(targetI,1),size(targetI,2));
targetHgsize = models{targetIdx}.model.hg_size;
HPixelPerCell = (targetGtBbox(4) - targetGtBbox(2))/targetHgsize(1);
WPixelPerCell = (targetGtBbox(3) - targetGtBbox(1))/targetHgsize(2);

% impaint the model j onto every other models
ovI = im2double(imread(sprintf(models{overlayIdx}.I,rootDir)));
if ndims(ovI) == 2
    ovI = repmat(ovI,[1 1 3]);
end
ovGtBbox = models{overlayIdx}.model.bb;
ovGtBbox = clip_to_image(round(ovGtBbox),[1 1 ...
    size(ovI,2) size(ovI,1)]);
ovI = ovI(ovGtBbox(2):ovGtBbox(4),ovGtBbox(1):ovGtBbox(3),:);
overlay.I = ovI;

HPixelOffset = neighbors{targetIdx}.offsetH(overlayIdx);
WPixelOffset = neighbors{targetIdx}.offsetW(overlayIdx);
ovModelH = models{overlayIdx}.model.hg_size(1);
ovModelW = models{overlayIdx}.model.hg_size(2);
HPixel = HPixelPerCell*ovModelH;
WPixel = WPixelPerCell*ovModelW;
startingW = WPixelOffset+targetGtBbox(1);
startingH = HPixelOffset+targetGtBbox(2);
d = [startingW startingH startingW+WPixel startingH+HPixel];
[I2,mask] = insert_exemplar(targetI,overlay,d);
subplot(2,1,1);
imshow(I2);
subplot(2,1,2);
imshow(targetI);