function visualizeExemplarPair(idx1,idx2,models,rootDir)
I1 = imread(sprintf(models{idx1}.I,rootDir));
newSize1 = [models{idx1}.model.rescaledH models{idx1}.model.rescaledW];
I1 = imresize(I1,newSize1);
gtBbox1 = models{idx1}.model.bb;
gtBbox1 = clip_to_image(round(gtBbox1(1:4)),[1 1 size(I1,2) size(I1,1)]);
I1 = plot_bb(I1,gtBbox1,'r');
hgSize1 = models{idx1}.model.hg_size(1:2);
whitenedx1 = models{idx1}.model.whitenedx./norm(models{idx1}.model.whitenedx);
hog1 = HOGpicture(reshape(whitenedx1,models{idx1}.model.hg_size));

I2 = imread(sprintf(models{idx2}.I,rootDir));
newSize2 = [models{idx2}.model.rescaledH models{idx2}.model.rescaledW];
I2 = imresize(I2,newSize2);
gtBbox2 = models{idx2}.model.bb;
gtBbox2 = clip_to_image(round(gtBbox2(1:4)),[1 1 size(I2,2) size(I2,1)]);
I2 = plot_bb(I2,gtBbox2,'r');
hgSize2 = models{idx2}.model.hg_size(1:2);
whitenedx2 = models{idx2}.model.whitenedx./norm(models{idx2}.model.whitenedx);
hog2 = HOGpicture(reshape(whitenedx2,models{idx2}.model.hg_size));

corr = whitenedx1'*whitenedx2;

subplot(2,2,1);
imshow(I1);
title(sprintf('model %g, hg size: [%g %g]',idx1,hgSize1(1),hgSize1(2)));
subplot(2,2,2);
imshow(I2);
title(sprintf('model %g, hg size: [%g %g]',idx2,hgSize2(1),hgSize2(2)));

subplot(2,2,3);
imagesc(hog1);
title(sprintf('model %g, hg size: [%g %g]',idx1,hgSize1(1),hgSize1(2)));
subplot(2,2,4);
imagesc(hog2);
title(sprintf('model %g, hg size: [%g %g],corr:%g',idx2,hgSize2(1),hgSize2(2),corr));