function interupt_signal = visualize_clusters(im,probe_bboxes,cov,info,clusterK,...
    clusterPerK,models,imgs_folder,complete_bboxes)
interupt_signal = 0;
exitSign = 0;
if exist('complete_bboxes','var')
    completeBboxesFlag = 1;
else
    completeBboxesFlag = 0;
end
% fetch data from info
% if isfield(info,'cluster_idx')
%     cluster_idx = info.cluster_idx;
% else
%     cluster_idx = [];
% end
if isfield(info,'precision') && isfield(info,'recall')
    precision = info.precision;
    recall = info.recall;
else
    precision = [];
    recall = [];
end
if isfield(info,'gtbboxes')
    gtbboxes = info.gtbboxes;
else
    gtbboxes = [];
end
if isfield(info,'bboxIdxAfterNMS')
    bboxIdxAfterNMS = info.bboxIdxAfterNMS;
else
    bboxIdxAfterNMS = [];
end

rowForOrigIm = 1;
N_models = length(models);
% first sort the cov
[sortval sortidx] = sort(cov,1,'descend');

% disp params
gap = 35;
set(0,'Units','pixels') 
scnsize = get(0,'ScreenSize');
pos1 = [0,0.5,scnsize(3)/2-gap,scnsize(4)];
pos2 = [scnsize(3)/2+gap,0.5,scnsize(3)/2-gap,scnsize(4)];

h1 = figure;
set(h1,'OuterPosition',pos1) 
% first visualize im and recommended clusters
h1_orig = subplot(clusterK+rowForOrigIm,clusterPerK,1:clusterPerK*rowForOrigIm);
imshow(im);


% now display the response map and provide interactive interface
% generate heat map
img_height = size(im,1);
img_width = size(im,2);
probe_bboxes(:,1:4) = clip_to_image(round(probe_bboxes(:,1:4)),[1 1 img_width img_height]);
% compute an average bbox from cur_probe_bboxes
probeCluster_bboxes = info.probeCluster_bboxes;
    
heat = zeros(img_height,img_width);
max_map = zeros(img_height,img_width);
for i = 1:size(probe_bboxes,1)
    update_flag = probe_bboxes(i,end)>heat(probe_bboxes(i,2):probe_bboxes(i,4),probe_bboxes(i,1):probe_bboxes(i,3));
    template = heat(probe_bboxes(i,2):probe_bboxes(i,4),probe_bboxes(i,1):probe_bboxes(i,3));
    template(update_flag) = probe_bboxes(i,end);
    heat(probe_bboxes(i,2):probe_bboxes(i,4),probe_bboxes(i,1):probe_bboxes(i,3)) = template;
    model_idx = probe_bboxes(i,6)+probe_bboxes(i,7)*N_models;
    template = max_map(probe_bboxes(i,2):probe_bboxes(i,4),probe_bboxes(i,1):probe_bboxes(i,3));
    template(update_flag)  = model_idx;
    max_map(probe_bboxes(i,2):probe_bboxes(i,4),probe_bboxes(i,1):probe_bboxes(i,3)) = template;
end
[max_point max_coord] = max(heat(:));
[maxVer maxHor] = ind2sub(size(heat),max_coord);
curVer = maxVer;
curHor = maxHor;
h2 = figure;
set(h2,'OuterPosition',pos2) 

% interactive section
cluster_count = 0;
point1 = [];
point2 = [];
% update h1
curDispK = updateH1(cluster_count,im,h1,h2,h1_orig,rowForOrigIm,clusterK,clusterPerK,...
    sortval,sortidx,precision,recall,models,imgs_folder,gtbboxes,bboxIdxAfterNMS,probeCluster_bboxes,...
    complete_bboxes);
% update h2
[h21_img h22_img h21 h22] = updateH2(curVer,curHor,im,heat,max_map,h2,models,imgs_folder);

set(h1, 'KeyPressFcn', {@callbackH1,im,h1,h2,h1_orig,rowForOrigIm,clusterK,clusterPerK,sortval,...
    sortidx,precision,recall,models,imgs_folder,gtbboxes,bboxIdxAfterNMS,probeCluster_bboxes,complete_bboxes});
set(h21_img, 'ButtonDownFcn', {@callbackH2,im,heat,max_map,h2,models,imgs_folder,h21,h22});
set(h22_img, 'ButtonDownFcn', {@callbackH2,im,heat,max_map,h2,models,imgs_folder,h21,h22});
set(h2, 'KeyPressFcn', {@callbackH2Key});
while 1
    pause(0.1);
    if exitSign
        close(h1);
        close(h2);
        return;
    end
end

% while 1
%     if curFig == h1 || curFig == 0
%         figure(h1);
%         count = clusterPerK*rowForOrigIm + 1;
%         dispK = min(clusterK,size(sortidx,2)-cluster_count);
%         if completeBboxesFlag
%             miniTitleString = cell(dispK*clusterPerK,1);
%             modelMaxBbox = cell(dispK*clusterPerK,1);
%             title_string = cell(dispK*clusterPerK,1);
%         end
%         for i = 1:dispK
%             for j = 1:clusterPerK
%                 mini_count = (i-1)*clusterPerK+j;
%                 sh(mini_count) = subplot_tight(clusterK+rowForOrigIm,clusterPerK,count);
%                 model_idx = sortidx(j,i+cluster_count);
%                 if model_idx>N_models
%                     model_idx = model_idx - N_models;
%                     flip_flag = 1;
%                 else
%                     flip_flag = 0;
%                 end
%                 
%                 % get max response of this model on the image
%                 if completeBboxesFlag
%                     modelBboxesIdx = find(complete_bboxes(:,6) == model_idx);
%                     candid_responses = complete_bboxes(modelBboxesIdx,end);
%                     if ~isempty(candid_responses)
%                         [modelResp maxIdx] = max(candid_responses);
%                         maxIdx = modelBboxesIdx(maxIdx);
%                         modelMaxBbox{mini_count} = complete_bboxes(maxIdx,1:4);
%                         os = getosmatrix_bb(modelMaxBbox{mini_count},gtbboxes);
%                         maxOs = max(os);
%                     else
%                         modelResp = NaN;
%                         maxIdx = NaN;
%                         maxOs = NaN;
%                     end
%                 else
%                     modelResp = 'NA';
%                     maxIdx = NaN;
%                     maxOs = NaN;
%                 end
%                 
%                 % compute whether this model has finally detected something
%                 if completeBboxesFlag
%                     isKeptAfterNMS = sum(dets_selected_idx == maxIdx)>0;
%                     if isKeptAfterNMS
%                         isKeptAfterNMS = '{\color{green}K}';
%                     else
%                         isKeptAfterNMS = '{\color{red}P}';
%                     end
%                     % compute the overlapping of this bbox and the avg probe
%                     % bbox
%                     probe_os = sprintf('%.2f',getosmatrix_bb(modelMaxBbox{mini_count},avg_bbox));
%                 else
%                     isKeptAfterNMS = 'NA';
%                     probe_os = 'NA';
%                 end
%                 
%                 curid = models{model_idx}.curid;
%                 gt_box = models{model_idx}.gt_box;
%                 model_img = imread(fullfile(imgs_folder,[curid '.png']));
%                 model_img = plot_bb(model_img,gt_box,'r');
%                 if flip_flag 
%                     model_img = flip_image(model_img);
%                 end
%                 hI(mini_count) = imshow(model_img,'Parent',sh(mini_count));
%                 if completeBboxesFlag
%                     miniTitleString{mini_count} = sprintf('%d|os=%.2f|Vi={\\color{blue}%.2f}|%s',...
%                         i+cluster_count,maxOs,modelResp,isKeptAfterNMS);
%                     title(miniTitleString{mini_count});
%                     title_string{mini_count} = ...
%                         sprintf('%d|P=%.2f|R=%.2f|Vc=%.1f|os=%.2f|Pos=%s|Vi={\\color{blue}%.2f}|%s',...
%                         i+cluster_count,precision(i+cluster_count),recall(i+cluster_count),...
%                         sortval(j,i+cluster_count),maxOs,probe_os,modelResp,isKeptAfterNMS);
%                 else
%                     miniTitleString{mini_count} = ...
%                         sprintf('%d|(%.2f,%.2f)|Vc=%.1f|os=%.2f|Vi={\\color{blue}%s}|%s',...
%                         i+cluster_count,maxOs,modelResp,isKeptAfterNMS);
%                     title(miniTitleString{mini_count});
%                 end
%                 count = count + 1;
%             end
%         end
%         if completeBboxesFlag
%             % set up callback
%             for i = 1:dispK
%                 for j = 1:clusterPerK
%                     mini_count = (i-1)*clusterPerK+j;
%                     set(hI(mini_count), 'ButtonDownFcn', {@updateFigure,im,h1_orig,title_string{mini_count},...
%                         modelMaxBbox{mini_count},sh,miniTitleString,h2});
%                 end
%             end
%         end
%         cluster_count = cluster_count + dispK;
%     end
%     if curFig == h2 || curFig == 0
%         figure(h2);
%         % for figure with response map
%         curVer = min(max(round(curVer),1),img_height);
%         curHor = min(max(round(curHor),1),img_width);
%         subplot_tight(3,1,1);
%         imshow(im);
%         hold on;
%         plot(curHor,curVer,'b.','MarkerSize',20);
%         hold off;
% 
%         subplot_tight(3,1,2);
%         imagesc(heat);
%         hold on;
%         plot(curHor,curVer,'b.','MarkerSize',20);
%         colormap;
%         hold off;
%         axis off
%         if max_map(curVer,curHor)~=0
%             model_idx = max_map(curVer,curHor);
%             if model_idx>N_models
%                 model_idx = model_idx - N_models;
%                 flip_flag = 1;
%             else
%                 flip_flag = 0;
%             end
%             title(sprintf('x=%d, y=%d, modelIdx=%d, response=%.3f',...
%                 curVer,curHor,model_idx,heat(curVer,curHor)));
%             model_img = imread(fullfile(imgs_folder,[models{model_idx}.curid '.png']));
%             model_img = plot_bb(model_img,models{model_idx}.gt_box,'r');
%             if flip_flag
%                 model_img = flip_image(model_img);
%             end
%         else
%             model_img = zeros(img_height,img_width,3);
%         end
%         subplot_tight(3,1,3);
%         imshow(model_img);
%     end
% %         curHor = [];
% %         curVer = [];
% %         curFig = [];
% %         button = [];
% %         uiwait;
%         figure(h2);
%         [curHor curVer button] = ginput(1);
%         curFig = gcf;
%         if button == 29 % -->            
%             curFig = h1;
%         elseif button == 110 % 'n'
%             close(h1);
%             close(h2);
%             return;
%         elseif button == 120 %  keyboard 'x'
%             interupt_signal = 1;
%             close(h1);
%             close(h2);
%             return;
%         end
% end

function updateFigure(hObject,eventdata,im,h1_orig,title_string,modelMaxBbox,sh,miniTitleString,HSwitchTo)
% clear titles for all mini plots
for i = 1:length(sh)
    title(sh(i),miniTitleString{i});
end

hSubplot = get(hObject,'Parent');
im = plot_bb(im,modelMaxBbox,'r');
subplot(h1_orig);
imshow(im);
title(h1_orig,title_string);
currentTitle = get(hSubplot,'title');
currentTitle = get(currentTitle,'string');
currentTitle = ['{\color{red}**}' currentTitle];
title(hSubplot,currentTitle);
% figure(HSwitchTo);



function dispK = updateH1(cluster_count,im,h1,h2,h1_orig,rowForOrigIm,clusterK,clusterPerK,...
    sortval,sortidx,precision,recall,models,imgs_folder,gtbboxes,dets_selected_idx,probeCluster_bboxes,...
    complete_bboxes)
if exist('complete_bboxes','var')
    completeBboxesFlag = 1;
end
N_models = length(models);
% update all mini plots in h1
figure(h1);
count = clusterPerK*rowForOrigIm + 1;
dispK = min(clusterK,size(sortidx,2)-cluster_count);
if completeBboxesFlag
    miniTitleString = cell(dispK*clusterPerK,1);
    modelMaxBbox = cell(dispK*clusterPerK,1);
    title_string = cell(dispK*clusterPerK,1);
end
for i = 1:dispK
    for j = 1:clusterPerK
        mini_count = (i-1)*clusterPerK+j;
        sh(mini_count) = subplot_tight(clusterK+rowForOrigIm,clusterPerK,count);
        model_idx = sortidx(j,i+cluster_count);
        if model_idx>N_models
            model_idx = model_idx - N_models;
            flipRec = 1;
        else
            flipRec = 0;
        end

        % get max response of this model on the image
        if completeBboxesFlag
            modelBboxesIdx = find(complete_bboxes(:,6) == model_idx);
            candid_responses = complete_bboxes(modelBboxesIdx,end);
            if ~isempty(candid_responses)
                [modelResp maxIdx] = max(candid_responses);
                maxIdx = modelBboxesIdx(maxIdx);
                modelMaxBbox{mini_count} = complete_bboxes(maxIdx,1:4);
                os = getosmatrix_bb(modelMaxBbox{mini_count},gtbboxes);
                maxOs = max(os);
            else
                modelResp = NaN;
                maxIdx = NaN;
                maxOs = NaN;
            end
        else
            modelResp = 'NA';
            maxIdx = NaN;
            maxOs = NaN;
        end

        % compute whether this model has finally detected something
        if completeBboxesFlag
            isKeptAfterNMS = sum(dets_selected_idx == maxIdx)>0;
            if isKeptAfterNMS
                isKeptAfterNMS = '{\color{green}K}';
            else
                isKeptAfterNMS = '{\color{red}P}';
            end
            % compute the overlapping of this bbox and the avg probe
            % bbox
            probe_os = sprintf('%.2f',getosmatrix_bb(modelMaxBbox{mini_count},probeCluster_bboxes));
        else
            isKeptAfterNMS = 'NA';
            probe_os = 'NA';
        end

        curid = models{model_idx}.curid;
        gt_box = models{model_idx}.gt_box;
        model_img = imread(fullfile(imgs_folder,[curid '.png']));
        model_img = plot_bb(model_img,gt_box,'r');
        if flipRec 
            model_img = flip_image(model_img);
        end
        hI(mini_count) = imshow(model_img,'Parent',sh(mini_count));
        if completeBboxesFlag
            miniTitleString{mini_count} = sprintf('%d|os=%.2f|Vi={\\color{blue}%.2f}|%s',...
                i+cluster_count,maxOs,modelResp,isKeptAfterNMS);
            title(miniTitleString{mini_count});
            title_string{mini_count} = ...
                sprintf('%d|Rec mId=%d|P=%.2f|R=%.2f|Vc=%.1f|os=%.2f|Pos=%s|Vi={\\color{blue}%.2f}|%s',...
                i+cluster_count,model_idx,precision(i+cluster_count),recall(i+cluster_count),...
                sortval(j,i+cluster_count),maxOs,probe_os,modelResp,isKeptAfterNMS);
        else
            miniTitleString{mini_count} = ...
                sprintf('%d|(%.2f,%.2f)|Vc=%.1f|os=%.2f|Vi={\\color{blue}%s}|%s',...
                i+cluster_count,maxOs,modelResp,isKeptAfterNMS);
            title(miniTitleString{mini_count});
        end
        count = count + 1;
    end
end
if completeBboxesFlag
    % set up callback
    for i = 1:dispK
        for j = 1:clusterPerK
            mini_count = (i-1)*clusterPerK+j;
            set(hI(mini_count), 'ButtonDownFcn', {@updateFigure,im,h1_orig,title_string{mini_count},...
                modelMaxBbox{mini_count},sh,miniTitleString,h2});
        end
    end
end
% cluster_count = cluster_count + dispK;


function [h21_img h22_img h21 h22] = updateH2(curVer,curHor,im,heat,max_map,h2,models,imgs_folder,h21,h22)
point1 = evalin('caller','point1');
point2 = evalin('caller','point2');

img_height = size(im,1);
img_width = size(im,2);
N_models = length(models);
figure(h2);
% for figure with response map
curVer = min(max(round(curVer),1),img_height);
curHor = min(max(round(curHor),1),img_width);
if isempty(point1)
    h21 = subplot_tight(3,1,1);
    h21_img = imshow(im,'Parent',h21);
else
    delete(point1);
    h21_img = [];
end
subplot(h21);
hold on;
point1 = plot(curHor,curVer,'b.','MarkerSize',20);
hold off;

if isempty(point2)
    h22 = subplot_tight(3,1,2);
    h22_img = imagesc(heat,'Parent',h22);
else
    delete(point2);
    h22_img = [];
end
subplot(h22);
hold on;
point2 = plot(curHor,curVer,'b.','MarkerSize',20);
colormap;
hold off;
axis off
if max_map(curVer,curHor)~=0
    model_idx = max_map(curVer,curHor);
    if model_idx>N_models
        model_idx = model_idx - N_models;
        flip_flag = 1;
    else
        flip_flag = 0;
    end
    title(sprintf('x=%d, y=%d, modelIdx=%d, response=%.3f',...
        curVer,curHor,model_idx,heat(curVer,curHor)));
    model_img = imread(fullfile(imgs_folder,[models{model_idx}.curid '.png']));
    model_img = plot_bb(model_img,models{model_idx}.gt_box,'r');
    if flip_flag
        model_img = flip_image(model_img);
    end
else
    model_img = zeros(img_height,img_width,3);
end
subplot_tight(3,1,3);
imshow(model_img);
assignin('caller','point1',point1);
assignin('caller','point2',point2);


function callbackH1(hObject,eventdata,im,h1,h2,h1_orig,rowForOrigIm,clusterK,clusterPerK,...
    sortval,sortidx,precision,recall,models,imgs_folder,gtbboxes,dets_selected_idx,probeCluster_bboxes,...
    complete_bboxes)
cluster_count = evalin('caller','cluster_count');
curDispK = evalin('caller','curDispK');
N = size(sortval,2);
cmd = eventdata.Character;
switch cmd
    case 'c' % next page
        cluster_count = cluster_count + curDispK;
    case 'z' % previous page
        if cluster_count>=clusterK
            cluster_count = cluster_count - clusterK;
        end
    case 'n' % exist
        assignin('caller','exitSign',1);
        return;
    case 'x' % exist
        assignin('caller','exitSign',1);
        assignin('caller','interupt_signal',1);
        return;
end
updateH1(cluster_count,im,h1,h2,h1_orig,rowForOrigIm,clusterK,clusterPerK,...
        sortval,sortidx,precision,recall,models,imgs_folder,gtbboxes,dets_selected_idx,probeCluster_bboxes,...
        complete_bboxes);
assignin('caller','cluster_count',cluster_count);
assignin('caller','curDispK',curDispK);

    
function callbackH2(hObject,eventdata,im,heat,max_map,h2,models,imgs_folder,h21,h22)
point1 = evalin('caller','point1');
point2 = evalin('caller','point2');
axesHandle  = get(hObject,'Parent');
coordinates = get(axesHandle,'CurrentPoint'); 
coordinates = coordinates(1,1:2);
% disp(sprintf('%.3f,%.3f',coordinates(1),coordinates(2)));
curVer = coordinates(2);
curHor = coordinates(1);
updateH2(curVer,curHor,im,heat,max_map,h2,models,imgs_folder,h21,h22);
assignin('caller','point1',point1);
assignin('caller','point2',point2);

function callbackH2Key(hObject,eventdata)
cmd = eventdata.Character;
switch cmd
    case 'n'
        assignin('caller','exitSign',1);
        return;
    case 'x'
        assignin('caller','exitSign',1);
        assignin('caller','interupt_signal',1);
        return;
end

