function [w b eval_rec] = esvm_LR_SGD(exemplar,X_neg,UD,r,c1,c2,c3,ratio,maxIter,tol,w0,b0)
% The function performing stochasitc gradient descent on a modified SVM formulation 
% min_w 1/2*w^2 + c1*max(1-w^T*exemplar,0) + c2*sum_(k is belonging to negatives) max(1+w^T*X_k,0) + c3/2*||r-w^T*UD||^2

% par
opt_rec = 1;

% augment data X
[M N] = size(X_neg);
X_aug = [X_neg; -ones(1,N)];
exemplar = [exemplar;-1];

[M_U N_U] = size(UD);
UD_aug = [UD; -ones(1,N_U)];

% k1 = round(N*ratio);
% k2 = round(N_U*ratio);
k1 = N;
k2 = N_U;
maxIter = 1000;
tol = 1e-8;
nabla = 1;
alpha = 0;
beta_brake = 0.8;
beta_speedup = 2;
beta_block_speedup = 1000;
beta_block_brake = 0.1;
line_search_batch = 1;
epsilon = 1e-6;
epsilon_block = 1e-3;
g_topk = M+1;

w = zeros(M+1,maxIter);

if exist('w0') && exist('b0')
    w(:,1) = [w0;b0];
else
    w(:,1) = rand(M+1,1);
end

eval_rec = [];
permutation_UD = randperm(N_U);
permutation_neg = randperm(N);
block_flag = 0;
nabla_seq = -ones(maxIter,1);

for t = 1:maxIter
    
%     if t == 1
%         tic
%         % do a line search in first iteration
%         k1_ls = round(N*line_search_batch);
%         k2_ls = round(N_U*line_search_batch);
%         
%         idx = randperm(N);
%         idx = idx(1:k1_ls);
%         UD_idx = randperm(N_U);
%         UD_idx = UD_idx(1:k2_ls);
%         
%         X_s = X_aug(:,idx);
%         r_s = r(UD_idx);
%         vi_idx = (w(:,t)'*X_s)>-1;
%         pos_vi = double(w(:,t)'*exemplar<1);
%         delta_w = [w(1:end-1,t);0] - pos_vi*c1*exemplar + N/k1_ls*c2*(sum(X_s(:,vi_idx),2)) - ...
%             N_U/k2_ls*c3*(UD_aug(:,UD_idx)*(r_s'-UD_aug(:,UD_idx)'*w(:,t)));
%         cur_f = eval_func(w(:,t),exemplar,X_s,UD_aug(:,UD_idx),r_s,c1,c2,c3);        
%         
%         delta_w_norm = norm(delta_w)^2;
%         while 1
%             w_temp = w(:,t) - nabla*delta_w;
%             if eval_func(w_temp,exemplar,X_s,UD_aug(:,UD_idx),r_s,c1,c2,c3) > cur_f - nabla*alpha*delta_w_norm
%                 nabla = beta*nabla;
%             else
%                 break;
%             end
%         end
%         toc
%     end
    
    
    alpha_t = 1/t;
%     alpha_t = 1;
%     idx = randperm(N);
%     idx = idx(1:k1);
%     UD_idx = randperm(N_U);
%     UD_idx = UD_idx(1:k2);

    idx = permutation_neg(mod([t:t+k1-1],N)+1);
    UD_idx = permutation_UD(mod([t:t+k2-1],N_U)+1);

    X_s = X_aug(:,idx);
    r_s = r(UD_idx);
    UD_s = UD_aug(:,UD_idx);
    
    neg_resp = (w(:,t)'*X_s);
    nondifferential = abs(neg_resp+1) < epsilon;
    
    vi_idx = neg_resp>-1;
    vi_idx(nondifferential) = false;
    
    pos_resp = w(:,t)'*exemplar;
    pos_nondifferential = abs(pos_resp-1) < epsilon;
    pos_vi = double(pos_resp<1);
    pos_vi(pos_nondifferential) = false;
    
    delta_w = [w(1:end-1,t);0] - pos_vi*c1*exemplar + N/k1*c2*(sum(X_s(:,vi_idx),2)) - ...
        N_U/k2*c3*(UD_s*(r_s'-UD_s'*w(:,t)));

    
    if sum(pos_nondifferential) > 0 || sum(nondifferential) > 0
        delta_right = zeros(length(delta_w),1);
        delta_left = zeros(length(delta_w),1);
        sg_final = zeros(length(delta_w),1);
        
        if sum(pos_nondifferential) > 0
            delta_right = delta_right - c1*min(0,exemplar(:,pos_nondifferential));
            delta_left = delta_left - c1*max(0,exemplar(:,pos_nondifferential));
        end
        
        if sum(nondifferential) > 0
            delta_right = delta_right + N/k1*c2*sum(max(0,X_s(:,nondifferential)),2);
            delta_left = delta_left + N/k1*c2*sum(min(0,X_s(:,nondifferential)),2);
        end
        
        delta_right = delta_right + delta_w;
        delta_left = delta_left + delta_w;
        delta_w = 0*delta_w;
        
        left_sg_idx = (delta_left>0);
        right_sg_idx = (delta_right<0);
        
        delta_w(left_sg_idx) = delta_left(left_sg_idx);
        delta_w(right_sg_idx) = delta_right(right_sg_idx);
        
        
        
%         sg_final(left_sg_idx) = delta_left(left_sg_idx);
%         sg_final(right_sg_idx) = delta_right(right_sg_idx);
%         delta_w = delta_w + sg_final;
    end
    

    
%     % check gradient
%     numgrad = computeNumericalGradient( @(x) approx_eval_func(x,exemplar,X_s,UD_aug(:,UD_idx),N,N_U,r_s,c1,c2,c3), w(:,t));
%     disp([delta_w numgrad]); 

    
%     w(:,t+1) = w(:,t) - nabla*alpha_t*delta_w;
    
    % line search
    approx_cur_f = approx_eval_func(w(:,t),exemplar,X_s,UD_s,N,N_U,r_s,c1,c2,c3);

    if block_flag
%         [ignore,val_idx] = psort(-abs(delta_w),g_topk);
%         tmp = 0*delta_w;
%         tmp(val_idx) = delta_w(val_idx);
%         delta_w = tmp;
        
    else
        if max(abs(delta_w)) < epsilon_block
            block_flag = 1;
            beta_speedup = beta_block_speedup;
            beta_brake = beta_block_brake;
        end
    end

    
%     delta_w(abs(delta_w)<epsilon_gshrink) = 0;
    delta_w_norm = norm(delta_w)^2;
    

    
    while 1
        w_temp = w(:,t) - nabla*delta_w;
        if approx_eval_func(w_temp,exemplar,X_s,UD_s,N,N_U,r_s,c1,c2,c3) > approx_cur_f - nabla*alpha*delta_w_norm
            nabla = beta_brake*nabla;
        else
            break;
        end
    end
    w(:,t+1) = w_temp;
    
    
    nabla_seq(t) = nabla;
    nabla = nabla*beta_speedup;

    
    if opt_rec
        if mod(t,1) == 0
            w_temp = w(:,t+1);
            eval_rec(end+1) = eval_func(w_temp,exemplar,X_aug,UD_aug,r,c1,c2,c3);
        end
    end
    
    if norm(w(:,t+1)-w(:,t)) < tol
        break;
    end
end
w = w(:,t+1);
b = w(end);
w(end) = [];




function val = eval_func(w,exemplar,X_neg,UD,r,c1,c2,c3)
% 1/2*w^2 + c1*max(1-w^T*exemplar,0) + c2*sum_(k is belonging to negatives) max(1+w^T*X_k,0) + c3/2*||r-w^T*UD||^2
err = r - w'*UD;
val = 0.5*(w(1:end-1)'*w(1:end-1)) + c1*max(1-w'*exemplar,0) + c2*sum(max(1+w'*X_neg,0)) + c3/2*(err*err');

function val = approx_eval_func(w,exemplar,X_neg,UD,N,N_U,r,c1,c2,c3)
% 1/2*w^2 + c1*max(1-w^T*exemplar,0) + c2*sum_(k is belonging to negatives) max(1+w^T*X_k,0) + c3/2*||r-w^T*UD||^2
k1 = size(X_neg,2);
k2 = size(UD,2);
err = r - w'*UD;
val = 0.5*(w(1:end-1)'*w(1:end-1)) + c1*max(1-w'*exemplar,0) + N/k1*(c2*sum(max(1+w'*X_neg,0))) + (c3/2)*(N_U/k2)*(err*err');















