function M = learn_M_counting(x, exids, os, count_thresh)
%Learn the matrix by counting activations on positives

N = size(x,2);
K = size(x,1);
C = zeros(K,K);

for i = 1:N
  cur = find(x(:,i)>0);  
  %old way: works better!
  C(cur,exids(i)) = C(cur,exids(i)) + os(i)*(os(i) >= count_thresh) / ...
       length(cur);
end

for i = 1:K
  M.w{i} = C(:,i);
  M.b{i} = 0;
end

M.C = sparse(C);