function M = learn_logistic_M(x, exids, os, count_thresh)
%Learn the matrix by counting activations on positives

N = size(x,2);
K = size(x,1);
C = zeros(K,K);
c = 1;

shrink_thresh = 1e-6;
% options for optimization
options = [];
options.display = 'none';
options.Method = 'lbfgs';
options.maxFunEvals = 10000;
options.TolX = 1e-20;

for i = 1:K
    tp_idx = (exids == i & os' >= count_thresh);
    fp_idx = (exids == i & os' < count_thresh);
    tp_feats = x(:,tp_idx);
    fp_feats = x(:,fp_idx);
    
    X = [tp_feats fp_feats]';
    y = [ones(size(tp_feats,2),1);zeros(size(fp_feats,2),1)];
    w0 = rand(size(x,1),1);
    lambda = size(fp_feats,2);
    
%     % check gradient
%     [J0 g0] = logit(w0,X,y,c,lambda);
%     numgrad = computeNumericalGradient(@(x) logit(x,X,y,c,lambda), w0);
%     disp([g0 numgrad]); 
    
    w = minFunc(@logit,w0,options,X,y,c,lambda);
    w(abs(w)<shrink_thresh) = 0;
    C(:,i) = w;
end

for i = 1:K
  M.w{i} = C(:,i);
  M.b{i} = 0;
end

M.C = sparse(C);