function [val delta_w] = LR_obj(w,exemplar,X_neg,UD,r,c1,c2,c3)
% 1/2*w^2 + c1*max(1-w^T*exemplar,0) + c2*sum_(k is belonging to negatives) max(1+w^T*X_k,0) + c3/2*||r-w^T*UD||^2

epsilon = 1e-6;


err = r - w'*UD;
val = 0.5*(w(1:end-1)'*w(1:end-1)) + c1*max(1-w'*exemplar,0) + c2*sum(max(1+w'*X_neg,0)) + c3/2*(err*err');

%     % subgradient
%     neg_resp = (w'*X_neg);
%     vi_idx = neg_resp>=-1;
%     pos_resp = w'*exemplar;
%     pos_vi = double(pos_resp<=1);
%     delta_w = [w(1:end-1);0] - pos_vi*c1*exemplar + c2*(sum(X_neg(:,vi_idx),2)) - ...
%         c3*(UD*(r'-UD'*w));

neg_resp = (w'*X_neg);
nondifferential = abs(neg_resp+1) < epsilon;

vi_idx = neg_resp>-1;
vi_idx(nondifferential) = false;

pos_resp = w'*exemplar;
pos_nondifferential = abs(pos_resp-1) < epsilon;
pos_vi = double(pos_resp<1);
pos_vi(pos_nondifferential) = false;

delta_w = [w(1:end-1);0] - pos_vi*c1*exemplar + c2*(sum(X_neg(:,vi_idx),2)) - ...
    c3*(UD*(r'-UD'*w));


if sum(pos_nondifferential) > 0 || sum(nondifferential) > 0
    delta_right = zeros(length(delta_w),1);
    delta_left = zeros(length(delta_w),1);

    if sum(pos_nondifferential) > 0
        delta_right = delta_right - c1*min(0,exemplar(:,pos_nondifferential));
        delta_left = delta_left - c1*max(0,exemplar(:,pos_nondifferential));
    end

    if sum(nondifferential) > 0
        delta_right = delta_right + c2*sum(max(0,X_neg(:,nondifferential)),2);
        delta_left = delta_left + c2*sum(min(0,X_neg(:,nondifferential)),2);
    end

    delta_right = delta_right + delta_w;
    delta_left = delta_left + delta_w;
    delta_w = 0*delta_w;
        
    left_sg_idx = (delta_left>0);
    right_sg_idx = (delta_right<0);
    delta_w(left_sg_idx) = delta_left(left_sg_idx);
    delta_w(right_sg_idx) = delta_right(right_sg_idx);
end
